/**
 * Created by Tony on 2019/12/25.
 */

module.exports = [
    {
        Name: '预定制计算式',
        Type: 'folder',
        Description: '预定制好的常用计算式模板',
        items: [
            {
                Name: '基本模板',
                Type: 'folder',
                Description: '模板创建时自带的几个定制计算式',
                Template: '',
                items: [
                    {
                        Name: '获取当前页',
                        Type: 'code',
                        Description: '获取当前页',
                        Template: 'let ttp = $JE.P(5010,$CURRENT_RPT);\n ttp.Default_Value = $ME.format.replace(\'(%S)\',$JE.getCurrentPage($CURRENT_RPT));\n ttp = null;',
                    }, {
                        Name: '获取总页数',
                        Type: 'code',
                        Description: '获取总页数',
                        Template: 'let ttp = $JE.P(5011,$CURRENT_RPT);\n ttp.Default_Value = $ME.format.replace(\'(%S)\',$JE.getTotalPage($CURRENT_RPT));\n ttp = null;',
                    }, {
                        Name: '获取打印时间',
                        Type: 'code',
                        Description: '获取打印时间',
                        Template: 'let rpt = $JE.P(5001,$CURRENT_RPT);\n let dt = new Date();\n rpt.Default_Value = dt.Format($ME.format);\n rpt = null;',
                    },
                ],
            }, {
                Name: 'String类模板',
                Type: 'folder',
                Description: '',
                Template: '',
                items: [{
                    Name: '金额转大写',
                    Type: 'code',
                    Description: '本模板实现阿拉伯数字金额转大写金额，具体用法可参考 ·标准对象· 中$JE.STR_UTIL.convertToCaptionNum()的说明。',
                    Template: 'let capF = $JE.F(/*目标指标ID*/, $CURRENT_RPT), orgF = $JE.F(/*原始指标ID*/, $CURRENT_RPT);\n $JE.setFieldValue(capF, $CURRENT_DATA, 0, $JE.$STR_UTIL.convertToCaptionNum(parseFloat($JE.getFieldValue(orgF, $CURRENT_DATA, 0, 0)).toFixed(2), true, true));',
                }, {
                    Name: '整理序号 - 1 (简单方式)',
                    Type: 'code',
                    Description: '完全按照索引来显示序号，不考虑父子分层结构。',
                    Template: 'let destField = $JE.F(/*指标ID*/,$CURRENT_RPT);\n  destField[JV.PROP_AD_HOC_DATA] = [];\n  for (let innerFmlIdx = 0; innerFmlIdx < $CURRENT_DATA[JV.DATA_DETAIL_DATA][0].length; innerFmlIdx++) {\n    $JE.setFieldValue(destField, $CURRENT_DATA, innerFmlIdx, (innerFmlIdx + 1));\n}',
                }, {
                    Name: '整理序号 - 2 (依据父节点)',
                    Type: 'code',
                    Description: '类似简单方式，但碰到不同的父节点，序号从头再开始。',
                    Template: 'let destField = $JE.F(/*指标ID*/,$CURRENT_RPT), childField = $JE.F(/*子ID指标ID*/,$CURRENT_RPT);\n    destField[JV.PROP_AD_HOC_DATA] = [];\nlet serialNo = 1;\nlet compareVal = $JE.getFieldValue(childField, $CURRENT_DATA, 0, null);\nfor (let dtlIdx = 0; dtlIdx < $CURRENT_DATA[JV.DATA_DETAIL_DATA][0].length; dtlIdx++) {\n\tlet dtlVal = $JE.getFieldValue(childField, $CURRENT_DATA, dtlIdx, 0);\n\tif (compareVal === dtlVal) {\n\t\t$JE.setFieldValue(destField, $CURRENT_DATA, dtlIdx, serialNo);\n\t} else {\n\t\tserialNo = 1;\n\t\tcompareVal = dtlVal;\n\t\t$JE.setFieldValue(destField, $CURRENT_DATA, dtlIdx, serialNo);\n\t}\n\tserialNo++;\n}',
                }, {
                    Name: '整理序号 - 3 (依据层次)',
                    Type: 'code',
                    Description: '根据层次，序号能体现层次的不同，如 1-1-2 , 目前只有清单有层次这个指标(ID: 3302)',
                    Template: 'let destField = $JE.F(/*显示离散指标ID*/,$CURRENT_RPT), levelField = $JE.F(3302,$CURRENT_RPT);\n    destField[JV.PROP_AD_HOC_DATA] = [];\nlet delimiter = \'.\', serialNoArr = [1,1,1,1,1,1,1,1,1,1];\nlet startLvIdx = 0, preLvVal = -100;\nfor (let dtlIdx = 0; dtlIdx < $CURRENT_DATA[JV.DATA_DETAIL_DATA][0].length; dtlIdx++) {\n\tlet lvVal = $JE.getFieldValue(levelField, $CURRENT_DATA, dtlIdx, 0);\n\tif (lvVal <= preLvVal) {\n\t\tfor (let idx = preLvVal; idx > lvVal; idx--) serialNoArr[idx] = 1;\n\t\tserialNoArr[lvVal]++;\n\t}\n\tpreLvVal = lvVal;\n\tlet snStr = \'\';\n\tfor (let lvIdx = startLvIdx; lvIdx <= lvVal; lvIdx++) {\n\t\tif (lvIdx > startLvIdx) snStr += delimiter;\n\t\tsnStr += serialNoArr[lvIdx];\n\t}\n\t$JE.setFieldValue(destField, $CURRENT_DATA, dtlIdx, snStr);\n}',
                }, {
                    Name: '依据单位调整格式',
                    Type: 'code',
                    Description: '根据单位，自动匹配并调整相关指标的小数位数显示',
                    Template: 'let decimalField = $JE.F(3281,$CURRENT_RPT),\n\tunitField = $JE.F(/*单位指标ID*/,$CURRENT_RPT),\n\ttargetField = $JE.F(/*原始目标指标ID*/,$CURRENT_RPT),\n\toutputField = $JE.F(/*真正输出目标指标ID*/,$CURRENT_RPT);\nlet tmpObj = {}, key_prefix = \'key_\';\nlet dfv = $JE.getFieldValue(decimalField, $CURRENT_DATA, 0, null);\nif (dfv instanceof Array) {\n\tfor (let dcmf of dfv) {\n\t\ttmpObj[key_prefix + dcmf[\'unit\']] = dcmf[\'decimal\'];\n\t}\n\tfor (let dtlIdx = 0; dtlIdx < $CURRENT_DATA[JV.DATA_DETAIL_DATA][0].length; dtlIdx++) {\n\t\tlet ukey = key_prefix + $JE.getFieldValue(unitField, $CURRENT_DATA, dtlIdx, \'其他未列单位\');\n\t\tlet fstr = \'#.####\';\n\t\tif (tmpObj[ukey]) {\n\t\t\tfstr = \'#.\';\n\t\t\tfor (let fIdx = 0; fIdx < tmpObj[ukey]; fIdx++) {\n\t\t\t\tfstr += \'#\';\n\t\t\t}\n\t\t}\n\t\tlet val = $JE.getFieldValue(targetField, $CURRENT_DATA, dtlIdx, \'0\');\n\t\tval = $JE.$STR_UTIL.formatNumber(fstr, val);\n\t\t$JE.setFieldValue(outputField,$CURRENT_DATA,dtlIdx, val);\n\t}\n}',
                }, {
                    Name: '格式化时间指标',
                    Type: 'code',
                    Description: '根据用户的特殊需求，格式化时间指标(如‘编制时间’等)，格式化串放在计算式的‘格式串(format)’里',
                    Template: 'let dtF = $JE.F(/*目标指标ID*/,$CURRENT_RPT);\n let dt = new Date($JE.getFieldValue(dtF, $CURRENT_DATA, 0, 0));\n $JE.setFieldValue(dtF, $CURRENT_DATA, 0, dt.Format($ME.format));',
                },
                ],
            }, {
                Name: '汇总类模板',
                Type: 'folder',
                Description: '',
                Template: '',
                items: [
                    {
                        Name: '总计',
                        Type: 'code',
                        Description: '把一个指标的值全部汇总起来',
                        Template: 'let totalFee = $JE.F(/*目标指标ID*/,$CURRENT_RPT), bill1 = $JE.F(/*原始指标ID*/,$CURRENT_RPT);\n let sumValue = 0.0;\n sumValue += parseFloat($JE.getFieldValue(bill1,$CURRENT_DATA,0,0));\n $JE.setFieldValue(totalFee,$CURRENT_DATA,0,sumValue);',
                    }, {
                        Name: '剔除指标父项汇总数据',
                        Type: 'code',
                        Description: '有些报表显示的时候需要显示完整的数据，但在汇总(页合计、段合计、总合计)的时候则需要剔除父项数据。',
                        Template: 'let parentIDField = $JE.F(3306,$CURRENT_RPT), IDField = $JE.F(3300,$CURRENT_RPT);\nlet sourceFields = [3317, 3319], \n\tdestFields = [12011, 12012];\nfor (let fIdx = 0; fIdx < sourceFields.length; fIdx++) {\n\tsourceFields[fIdx] = $JE.F(sourceFields[fIdx],$CURRENT_RPT);\n\tdestFields[fIdx] = $JE.F(destFields[fIdx],$CURRENT_RPT);\n\tdestFields[fIdx][JV.PROP_AD_HOC_DATA] = [];\n}\nlet parentIDs = [];\nfor (let dtlIdx = 0; dtlIdx < $CURRENT_DATA[JV.DATA_DETAIL_DATA][0].length; dtlIdx++) {\n\tfor (let fIdx = 0; fIdx < sourceFields.length; fIdx++) {\n\t\t$JE.setFieldValue(destFields[fIdx],$CURRENT_DATA, dtlIdx, $JE.getFieldValue(sourceFields[fIdx], $CURRENT_DATA, dtlIdx, 0));\n\t}\n\tlet pID = $JE.getFieldValue(parentIDField, $CURRENT_DATA, dtlIdx, 0);\n\tif (parentIDs.indexOf(pID) < 0) {\n\t\tparentIDs.push(pID);\n\t}\n}\nfor (let dtlIdx = 0; dtlIdx < $CURRENT_DATA[JV.DATA_DETAIL_DATA][0].length; dtlIdx++) {\n\tlet ID = $JE.getFieldValue(IDField, $CURRENT_DATA, dtlIdx, 0);\n\tif (parentIDs.indexOf(ID) >= 0) {\n\t\tfor (let fIdx = 0; fIdx < sourceFields.length; fIdx++) {\n\t\t\t$JE.setFieldValue(destFields[fIdx], $CURRENT_DATA, dtlIdx, 0);\n\t\t}\n\t}\n}',
                    },
                ],
            }, {
                Name: '配置类模板',
                Type: 'folder',
                Description: '',
                Template: '',
                items: [
                    {
                        Name: '统计指标小数位数匹配',
                        Type: 'code',
                        Description: '如果被统计的指标是一个经过处理的离散指标，而且小数位数需要匹配相关source映射指标(如xx合价)，那么就需要做一些处理，把相关小数位数属性copy过来。',
                        Template: 'let pri_func_copy_field_decimal=function(sourceID,destID){let sourceField=null;if(isNaN(parseInt(sourceID))){sourceField=sourceID;}else{sourceField=$JE.F(sourceID,$CURRENT_RPT);}let destField=$JE.F(destID,$CURRENT_RPT);if(sourceField[JV.PROP_PRECISION]){destField[JV.PROP_PRECISION]=sourceField[JV.PROP_PRECISION];destField[JV.PROP_FIXED_PRECISION_AMT]=sourceField[JV.PROP_FIXED_PRECISION_AMT];}} pri_func_copy_field_decimal(,);',
                    },
                ],
            },
        ],
    },
    {
        Name: '标准对象',
        Type: 'folder',
        Description: '计算式(代码拓展)中可以使用的、与报表模板相关的对象',
        items: [
            {
                Name: '$JE',
                Type: 'folder',
                Description: '$JE是计算式功能的核心，预定义了一些基础核心方法',
                Template: '$JE',
                items: [
                    {
                        Name: '$JE.F()',
                        Type: 'code',
                        Description: '通过ID获取指标对象',
                        Template: '$JE.F(/* 指标ID, $CURRENT_RPT*/)',
                    }, {
                        Name: '$JE.P()',
                        Type: 'code',
                        Description: '通过ID获取离散参数对象',
                        Template: '$JE.P(/* 离散参数ID, $CURRENT_RPT */)',
                    }, {
                        Name: '$JE.setFieldValue()',
                        Type: 'code',
                        Description: '设置指标对象的数据，共4个参数：\n1. 传入F()函数得到的指标对象; \n2. $CURRENT_DATA; \n3. 数据所在位置index; \n4. 新的数据值',
                        Template: '$JE.setFieldValue(/* 指标对象, $CURRENT_DATA, index, newValue */)',
                    }, {
                        Name: '$JE.getFieldValue()',
                        Type: 'code',
                        Description: '获取指标对象的数据，共4个参数：\n1. 传入F()函数得到的指标对象; \n2. $CURRENT_DATA; \n3. 数据所在位置index; \n4. default返回数据值',
                        Template: '$JE.getFieldValue(/* 指标对象, $CURRENT_DATA, index, defaultValue */)',
                    }, {
                        Name: '$JE.setFieldValueArray()',
                        Type: 'code',
                        Description: '整体设置指标对象的数据(以数组方式)，共3个参数：\n1. 传入F()函数得到的指标对象; \n2. $CURRENT_DATA; \n3. 新数组值',
                        Template: '$JE.setFieldValueArray(/* 指标对象, $CURRENT_DATA, newArray */)',
                    }, {
                        Name: '$JE.getFieldValueArray()',
                        Type: 'code',
                        Description: '整体获取指标对象的数据(以数组方式)，共2个参数：\n1. 传入F()函数得到的指标对象; \n2. $CURRENT_DATA',
                        Template: '$JE.getFieldValueArray(/* 指标对象, $CURRENT_DATA */)',
                    }, {
                        Name: '$JE.removeFieldValue()',
                        Type: 'code',
                        Description: '移除一条指标对象的数据，共3个参数：\n1. 传入F()函数得到的指标对象; \n2. $CURRENT_DATA; \n3. 数据所在位置index',
                        Template: '$JE.removeFieldValue(/* 指标对象, $CURRENT_DATA, index */)',
                    }, {
                        Name: '$JE.insertFieldValue()',
                        Type: 'code',
                        Description: '插入一条数据到指标对象，共4个参数：\n1. 传入F()函数得到的指标对象; \n2. $CURRENT_DATA; \n3. 数据所在位置index; \n4. 插入的数据值',
                        Template: '$JE.insertFieldValue(/* 指标对象, $CURRENT_DATA, index, insertValue */)',
                    }, {
                        Name: '$JE.getCurrentPage()',
                        Type: 'code',
                        Description: '获得当前页码值,需实时运行才有效',
                        Template: '$JE.getCurrentPage($CURRENT_RPT)',
                    }, {
                        Name: '$JE.getTotalPage()',
                        Type: 'code',
                        Description: '获得报表总页码数,需实时运行才有效',
                        Template: '$JE.getTotalPage($CURRENT_RPT)',
                    },
                ],
            }, {
                Name: 'JV',
                Type: 'code',
                Description: '报表模板预定义常量集合对象，具体得参考 rpt_value_define.js 代码',
                Template: 'JV',
            }, {
                Name: '$CURRENT_RPT',
                Type: 'code',
                Description: '当前报表模板的处理对象，作为参数专递给$JE相关函数用。如有兴趣，可参考 jpc_ex.js 代码',
                Template: '$CURRENT_RPT',
            }, {
                Name: '$CURRENT_DATA',
                Type: 'code',
                Description: '当前报表模板灌注的数据对象，作为参数专递给$JE相关函数用。',
                Template: '$CURRENT_DATA',
            }, {
                Name: '$CURRENT_TEMPLATE',
                Type: 'code',
                Description: '当前报表模板原始对象，作为参数专递给$JE相关函数用。',
                Template: '$CURRENT_TEMPLATE',
            }, {
                Name: '$CTX_HELPER',
                Type: 'code',
                Description: '系统helper',
                Template: '$CURRENT_TEMPLATE',
            }, {
                Name: '$STR_UTIL',
                Type: 'folder',
                Description: '$JE对象下的字符串处理对象，提供了基本字符串处理函数。',
                Template: '$JE.$STR_UTIL',
                items: [
                    {
                        Name: '$JE.STR_UTIL.isEmptyString()',
                        Type: 'code',
                        Description: '判断字符串是否为空',
                        Template: '$JE.STR_UTIL.isEmptyString(/* 字符串值 */)',
                    }, {
                        Name: '$JE.STR_UTIL.trim()',
                        Type: 'code',
                        Description: '修剪字符(左右)，返回修剪后的结果。',
                        Template: '$JE.STR_UTIL.trim(/* 字符串值 */)',
                    }, {
                        Name: '$JE.STR_UTIL.leftTrim()',
                        Type: 'code',
                        Description: '修剪字符(左)，返回修剪后的结果。',
                        Template: '$JE.STR_UTIL.leftTrim(/* 字符串值 */)',
                    }, {
                        Name: '$JE.STR_UTIL.rightTrim()',
                        Type: 'code',
                        Description: '修剪字符(右)，返回修剪后的结果。',
                        Template: '$JE.STR_UTIL.rightTrim(/* 字符串值 */)',
                    }, {
                        Name: '$JE.STR_UTIL.replaceAll()',
                        Type: 'code',
                        Description: '替换字符串，返回替换后的结果。共3个参数：\n1. 目标字符串; \n2. 要被替换的字符串; \n3. 替换成字符串值',
                        Template: '$JE.STR_UTIL.replaceAll(/* targetStr, FindText, ReplaceText */)',
                    }, {
                        Name: '$JE.STR_UTIL.comdify()',
                        Type: 'code',
                        Description: '返回数值的千分位结果',
                        Template: '$JE.STR_UTIL.comdify(/* 数值字符串 */)',
                    }, {
                        Name: '$JE.STR_UTIL.convertToCaptionNum()',
                        Type: 'code',
                        Description: '把正常数值转换成大写，返回转换后的结果。共3个参数: \n1. 目标数值; \n2. 是否为currency，如是，则会转成 元、角、分的形式; \n3. 是否为传统大写格式，如是则转成 壹 贰 叁...格式，否则转成 一 二 三...',
                        Template: '$JE.STR_UTIL.convertToCaptionNum(/* num, isCurrency, isTraditionalCap */)',
                    }, {
                        Name: '$JE.STR_UTIL.formatNumber()',
                        Type: 'code',
                        Description: '格式化字符串，返回转换后的结果。共2个参数: \n1. 格式字符串，目前只支持小数位数与千分位的格式化，如：,.00# ; \n2. 目标数值',
                        Template: '$JE.STR_UTIL.formatNumber(/* formatStr, val */)',
                    },
                ],
            },
        ],
    },
];
