'use strict';

/**
 * 日志列表控制器
 *
 * @author CaiAoLin
 * @date 2017/10/30
 * @version
 */

module.exports = app => {

    class LogController extends app.BaseController {

        /**
         * 日志列表
         *
         * @param {Object} ctx - egg全局变量
         * @return {void}
         */
        async index(ctx) {
            const page = ctx.page;

            // 筛选数据
            ctx.service.log.searchFilter(ctx.request.query);
            const logList = await ctx.service.log.getListWithBuilder();
            const total = await ctx.service.log.count();

            // 分页相关
            const pageInfo = {
                page,
                total: Math.ceil(total / app.config.pageSize),
                queryData: JSON.stringify(ctx.urlInfo.query),
            };
            console.log(pageInfo);

            const renderData = {
                logList,
                pageInfo,
            };

            await this.layout('log/index.ejs', renderData);
        }
    }

    return LogController;
};
