'use strict';

/**
 * sql执行控制器
 *
 * @author CaiAoLin
 * @date 2017/10/13
 * @version
 */

module.exports = app => {

    class SqlExecuteController extends app.BaseController {

        /**
         * sql执行页面
         *
         * @param {Object} ctx - egg全局context
         * @return {void}
         */
        async index(ctx) {
            const renderData = {
                sql: '',
                fieldList: [],
                dataList: [],
            };
            await this.layout('sql_execute/index.ejs', renderData);
        }

        /**
         * 执行sql
         *
         * @param {Object} ctx - egg全局context
         * @return {void}
         */
        async execute(ctx) {
            const sql = ctx.request.body.sql;
            try {
                const [fieldList, result] = await ctx.service.sqlExecute.execute(sql);
                const renderData = {
                    sql,
                    fieldList,
                    dataList: result,
                };
                await this.layout('sql_execute/index.ejs', renderData);
            } catch (error) {
                this.setMessage(error.toString(), this.messageType.ERROR);
                ctx.redirect('/sql');
            }

        }

    }

    return SqlExecuteController;
};
