'use strict';

module.exports = options => {
    /**
     * 白名单过滤器
     *
     * @param {function} next - 中间件继续执行的方法
     * @return {void}
     */
    return function* whiteListFilter(next) {
        // 获取当前ip
        const ip = this.request.ip;
        // 获取白名单数据
        const whiteList = yield this.service.whiteList.getAllData();
        // 判断是否为ajax请求
        if (this.helper.isAjax(this.request)) {
            // 检测token @todo
        } else {
            // 不是ajax请求则判断ip是否为合法
            if (whiteList[ip + ':1'] === undefined) {
                this.status = 404;
                return;
            }
        }

        yield next;
    };
};

