/**
 * 项目相关js
 *
 * @author CaiAoLin
 * @date 2017/11/14
 * @version
 */

$.event.special.valuechange = {
    teardown: function (namespaces) {
        $(this).unbind('.valuechange');
    },

    handler: function (e) {
        $.event.special.valuechange.triggerChanged($(this));
    },

    add: function (obj) {
        $(this).on('keyup.valuechange cut.valuechange paste.valuechange input.valuechange', obj.selector, $.event.special.valuechange.handler)
    },

    triggerChanged: function (element) {
        var current = element[0].contentEditable === 'true' ? element.html() : element.val()
            , previous = typeof element.data('previous') === 'undefined' ? element[0].defaultValue : element.data('previous');
        if (current !== previous) {
            element.trigger('valuechange', [element.data('previous')]);
            element.data('previous', current);
        }
    }
};

$(document).ready(function() {
    // 销售负责人办事处选择
    $("select[name='manager_office']").change(function() {
        let office = $(this).val();
        office = parseInt(office);
        if (isNaN(office) && office <= 0) {
            return false;
        }

        let html = '<option value="">请选择用户</option>';
        const managerSelector = $("select[name='manager_id']");
        if (managerList === undefined || managerList[office] === undefined || managerList[office].length <= 0) {
            managerSelector.html(html);
            return false;
        }

        for (let manager of managerList[office]) {
            html += '<option value="' + manager.id + '">' + manager.username + '</option>'
        }
        managerSelector.html(html);
    });

    // 最大账号数选中
    $('#change_maxuser').click(function () {
        if ($(this).is(':checked')) {
            $('#max_user_input2').show();
            $('#max_user_input2').attr('readonly', true);
            $('#max_user_input2').removeAttr('disabled');
            $('#max_user_input').attr('disabled', true);
            $('#max_user_input').hide();
            $('#max_user_input').val('');
            $('#max_user_input').removeClass('is-invalid');
            $('#max_user_input').parents('div.col-lg-6').next("div.col-lg-4").text('');
        } else {
            $('#max_user_input2').hide();
            $('#max_user_input2').attr('disabled', true);
            $('#max_user_input').show();
            $('#max_user_input').removeAttr('disabled');
            $('#max_user_input').val('');
        }
    });

    // max_user焦点移除
    $('#max_user_input').blur(function () {
        if ($(this).val() === '') {
            $(this).addClass('is-invalid');
            $(this).parents('div.col-lg-6').next("div.col-lg-4").text('请输入最大账号数');
        } else if (!/^\+?[1-9][0-9]*$/.test($('#max_user_input').val())) {
            $(this).addClass('is-invalid');
            $(this).parents('div.col-lg-6').next("div.col-lg-4").text('请输入一个正整数');
        } else if ($('#max_user_input').val() > 10000) {
            $(this).addClass('is-invalid');
            $(this).parents('div.col-lg-6').next("div.col-lg-4").text('不能超过10000个账号');
        } else {
            $(this).removeClass('is-invalid');
            $(this).parents('div.col-lg-6').next("div.col-lg-4").text('');
        }
    });

    $('#upload-qrcode-file').change(function () {
        const file = this.files[0];
        const ext = file.name.toLowerCase().split('.').splice(-1)[0];
        const imgStr = /(jpg|jpeg|png|bmp|BMP|JPG|PNG|JPEG)$/;
        if (!imgStr.test(ext)) {
            toast('请上传正确的图片格式文件','error');
            return
        }
        if ($(this).val()) {
            const formData = new FormData();
            formData.append('file', this.files[0]);
            postDataWithFile('/project/upload/qrcode', formData, function (result) {
                const html = '<tr index="'+ $('#qrcode-tr-show tr').length +'" pic-path="' + result.path + '"><td>' + result.base + '</td><td><input type="text" class="form-control" value="微信交流群"></td><td><a class="text-danger delete-qrcode" href="javascript:void(0);">删除</a></td></tr>';
                const qrhtml = '<div class="col-auto"><img src="/' + result.path + '" width="100"><div class="text-center">微信交流群</div></div>';
                $('#qrcode-show').append(qrhtml);
                $('#qrcode-tr-show').append(html);
                if ($('#qrcode-tr-show tr').length === 3) {
                    $('#upload-qrcode-file').attr('disabled', true);
                } else {
                    $('#upload-qrcode-file').attr('disabled', false);
                }
                $('#upload-qrcode-file').val('');
            });
        }
    });

    $('body').on('valuechange', '#qrcode-tr-show input', function (e, previous) {
        const index = $(this).parents('tr').attr('index');
        $('#qrcode-show .col-auto').eq(parseInt(index) - 1).children('div').html($(this).val());
    });

    $('body').on('click', '.delete-qrcode', function () {
        $(this).parents('tr').remove();
        $('#upload-qrcode-file').attr('disabled', false);
        let qrhtml = '';
        for (let i = 1; i < $('#qrcode-tr-show tr').length; i++) {
            qrhtml += '<div class="col-auto"><img src="/' + $('#qrcode-tr-show tr').eq(i).attr('pic-path') + '" width="100"><div class="text-center">'+ $('#qrcode-tr-show tr').eq(i).find('input').val() +'</div></div>';
            $('#qrcode-tr-show tr').eq(1).attr('index', 1);
        }
        $('#qrcode-show').html(qrhtml);
    })
});

function checkMaxUser() {
    let flag = true;
    if (!$('#change_maxuser').is(':checked')) {
        if ($('#max_user_input').val() === '') {
            $('#max_user_input').addClass('is-invalid');
            $('#max_user_input').parents('div.col-lg-6').next("div.col-lg-4").text('请输入最大账号数');
            flag = false;
        } else if (!/^\+?[1-9][0-9]*$/.test($('#max_user_input').val())) {
            $('#max_user_input').addClass('is-invalid');
            $('#max_user_input').parents('div.col-lg-6').next("div.col-lg-4").text('请输入一个正整数');
            flag = false;
        } else if ($('#max_user_input').val() > 10000) {
            $('#max_user_input').addClass('is-invalid');
            $('#max_user_input').parents('div.col-lg-6').next("div.col-lg-4").text('不能超过10000个账号');
            flag = false;
        }
    }

    if ($('#qrcode-tr-show tr').length > 1) {
        const qrcode = [];
        for (let i = 1; i < $('#qrcode-tr-show tr').length; i++) {
            const qr = {
                base: $('#qrcode-tr-show tr').eq(i).children('td').eq(0).text(),
                path: $('#qrcode-tr-show tr').eq(i).attr('pic-path'),
                name: $('#qrcode-tr-show tr').eq(i).find('input').val()
            };
            qrcode.push(qr);
        }
        $('#qrcode_json').val(JSON.stringify(qrcode));
    } else {
        $('#qrcode_json').val('');
    }
    return flag;
}

/**
 * 设置办事处人员
 *
 * @param {Number} office
 * @param {Number} managerId
 * @return {void}
 */
function setOfficeManager(office, managerId) {
    office = parseInt(office);
    if (isNaN(office) && office <= 0) {
        return;
    }

    if (managerList === undefined || managerList[office] === undefined || managerList[office].length <= 0) {
        return;
    }
    let html = '';
    for (let manager of managerList[office]) {
        const selectedString = manager.id === parseInt(managerId) ? 'selected="selected"' : '';
        html += '<option value="' + manager.id + '" ' + selectedString + '>' + manager.username + '</option>'
    }
    $("select[name='manager_id']").html(html);
}
