'use strict'

const
    IDMark_Switch = "_switch",
    IDMark_Icon = "_ico",
    IDMark_Span = "_span",
    IDMark_Input = "_input",
    IDMark_Check = "_check",
    IDMark_Edit = "_edit",
    IDMark_Remove = "_remove",
    IDMark_Ul = "_ul",
    IDMark_A = "_a",
    //以上的常量是在查找zTree默认生成的dom对象时用到（tID + 后缀）

    NODE_LEVEL_COMPILATION_NEW = 0,
    NODE_LEVEL_USER = 0;

let rptTplObj = {
    iniPage: function() {
        zTreeOprObj.getReportTemplateTreeEx();
        rpt_tpl_cfg_helper.getReportTplCfg();
        selectableFiledTreeOprObj.iniTree();
        // preview_util.drawBorder($("#tplCanvas")[0]);
        calculationTreeOprObj.buildRunType();
        // preHandleObj.buildTypeData();
        calculationTreeOprObj.iniExtCodeTpl(); //延后
    }
};

let zTreeOprObj = {
    treeObj: null,
    currentNode: null,
    moveSrcTopNode: null,
    moveSrcSecondTopNode: null,
    orgMoveSrcNodeLevel: -1,
    dupTplIds: null,
    hasRefreshedDupRefIds: false,
    refreshNodes: function() {
        let me = this;
        let private_setupIsParent = function(node){
            // if (node.nodeType === RT.NodeType.NODE || node.level === 0) {
            if (node.nodeType === RT.NodeType.NODE || node.level <= NODE_LEVEL_COMPILATION_NEW) {
                node.isParent = true;
            } else {
                node.isParent = false;
            }
            if (node.items && node.items.length) {
                for (let i = 0; i < node.items.length; i++) {
                    private_setupIsParent(node.items[i]);
                }
            }
        };
        let topNodes = me.treeObj.getNodes();
        for (let i = 0; i < topNodes.length; i++) {
            private_setupIsParent(topNodes[i]);
        }
        me.treeObj.refresh();
    },
    copyReportTemplates: function(tplIdsForCopy, isAsync, callback, failCallback) {
        let params = {};
        params.tplIdsForCopy = tplIdsForCopy;
        // CommonAjax.postEx("report_tpl_api/copyRptTpl", params, 5000, isAsync, callback, failCallback, null);
        CommonAjax.postXsrfEx("report_tpl_api/copyTreeNodes", params, 5000, isAsync, getCookie('csrfToken'), callback, failCallback, null);
    },
    updateTreeRootNode: function(rawNode, isAsync, callback, failCallback) {
        let params = {};
        params.doc = rawNode;
        //CommonAjax.postEx("report_tpl_api/updateTreeRootNode", params, 5000, isAsync, callback, failCallback, null);
        CommonAjax.postXsrfEx("report_tpl_api/updateTreeRootNode", params, 5000, isAsync, getCookie('csrfToken'), callback, failCallback, null);
    },
    partialUpdateTreeNode: function (topNodeID, pathArray, nodeArray, isAsync, callback, failCallback) {
        // 这个是局部刷新，原理是根据topNodeId找到后台的topNode，根据路径(有多个路径，可以实现多个子节点同时刷新)来替换（nodeArray里的）后台数据库的相关节点
        // 这里需要一个调整，就是新增目录及模板需要加给后缀(new(Date)).getTime() ，以保证不重叠(真重叠了算倒霉)
        // path描述：{ operation_type: '', // 操作类型：‘update’ ‘add’、‘delete’
        //            node_path: [],      // 节点路径：如：['02.广东', '03.增城北绕线项目定制报表']，表示Top节点的items下的那个‘02.广东’子节点(要full scan)的items下的 ‘03.增城北绕线项目定制报表’子节点
        //          }
        // nodeArray： 与pathArray一一对应
        //
        let params = {};
        params.topNodeID = topNodeID;
        params.pathArray = pathArray;
        params.nodeArray = nodeArray;
        CommonAjax.postXsrfEx("report_tpl_api/partialUpdateTreeNode", params, 5000, isAsync, getCookie('csrfToken'), callback, failCallback, null);
    },
    updateSubNode: function (params, isAsync, callback, failCallback) {
        CommonAjax.postXsrfEx("report_tpl_api/updateTreeDetailNode", params, 5000, isAsync, getCookie('csrfToken'), callback, failCallback, null);
    },
    createIniNode: function() {
        return {
            nodeType: RT.NodeType.TEMPLATE,
            refId: -1,
            name: "",
            ID: -1,
            items: null
        };
    },
    buildRootNodeDoc: function(topNode, excludeNode) {
        let me = this, rst = null;
        if (topNode) {
            rst = {
                id: topNode.nodeId,
                rpt_type: topNode.rpt_type,
                pid: topNode.pid,
                last_update_time: topNode.last_update_time,
                items: me.private_build_items(topNode.items, excludeNode),
                name: topNode.name
            };
        }
        return rst;
    },
    getNodePath: function(node, includeCurrentNode, topNode) {
        const rst = [];
        if (includeCurrentNode && node.level >= 1) {
            rst.push(node.name);
        }
        let parentNode = node.getParentNode();
        while (parentNode) {
            rst.unshift(parentNode.name);
            parentNode = parentNode.getParentNode();
            if (parentNode === null || parentNode === undefined) {
                rst.splice(0,1); // 删除头节点（后台不需要）
            }
        }
        return rst;
    },
    buildNodeDoc: function(subNode) {
        let me = this, rst = null;
        if (subNode) {
            let isReleased = false;
            if (subNode.nodeType === RT.NodeType.TEMPLATE) {
                isReleased = subNode.checked;
            }
            rst = {
                nodeType: subNode.nodeType,
                refId: subNode.refId,
                ID: subNode.ID,
                released: isReleased,
                items: me.private_build_items(subNode.items, null),
                name: subNode.name
            };
            if (subNode.hasOwnProperty('flags')) {
                rst.flags = subNode.flags;
            }
        }
        return rst;
    },

    private_build_items: function (items, excludeNode) {
        let me = this, itemRst = null;
        if (items && items.length > 0) {
            itemRst = [];
            for (let item of items) {
                if (item !== excludeNode) {
                    let isReleased = false;
                    if (item.nodeType === RT.NodeType.TEMPLATE) {
                        isReleased = item.checked;
                    }
                    let ir = {};
                    ir.nodeType = item.nodeType;
                    ir.refId = item.refId;
                    ir.name = item.name;
                    ir.ID = item.ID;
                    ir.released = isReleased;
                    if (item.hasOwnProperty('flags')) {
                        ir.flags = item.flags;
                    }
                    ir.items = me.private_build_items(item.items);
                    itemRst.push(ir);
                }
            }
        }
        return itemRst;
    },

    addHoverDom: function(treeId, treeNode) {
        let me = zTreeOprObj, sObj = $("#" + treeNode.tId + "_span");
        if (treeNode.editNameFlag || $("#addBtn_"+treeNode.tId).length > 0 || treeNode.nodeType === RT.NodeType.TEMPLATE) return;
        if (treeNode.level < 0) {
            //计量的目录结构不一样，不需要顶节点这一层了
        } else {
            let addStr = "<span class='button add' id='addBtn_" + treeNode.tId + "' title='新增子目录' onfocus='this.blur();'></span>";
            sObj.after(addStr);
            let btn = $("#addBtn_"+treeNode.tId);
            if (btn) btn.bind("click", function(){
                let rawNode = me.createIniNode();
                rawNode.nodeType = RT.NodeType.NODE;
                rawNode.name = "新增子节点" + (new Date()).getTime();
                rawNode.isParent = true;
                rawNode.ID = -1;
                rawNode.refId = "";
                rawNode.items = [];
                let newNodes = [], isSilent = false;
                newNodes.push(rawNode);
                if (me.treeObj) {
                    let insertIdx = -1;
                    if (treeNode.items && treeNode.items.length > 0) {
                        for (let i = treeNode.items.length - 1; i >= 0; i--) {
                            if (treeNode.items[i].nodeType === RT.NodeType.NODE) {
                                insertIdx = i + 1;
                                break;
                            } else {
                                insertIdx = i;
                            }
                        }
                    }
                    me.treeObj.addNodes(treeNode, insertIdx, newNodes, isSilent);
                    //重写
                    let tn = me.getTopParentNode(treeNode);
                    // let pn = me.buildNodeDoc(treeNode);
                    let pathArr = [];
                    let nodeArr = [];
                    let path = {operation_type: 'add', node_path: []};
                    path.node_path = me.getNodePath(treeNode, true, tn);
                    pathArr.push(path);
                    nodeArr.push(rawNode);
                    me.partialUpdateTreeNode(tn.nodeId, pathArr, nodeArr, false, function (rst) {
                        if (!(rst)) {
                            alert("新增节点失败！");
                        }
                        me.refreshNodes();
                    }, null);
                }
            });
            if (treeNode.level >= 0) {
                //这个判断在计量是没什么意义，只是保留并设置为true
                addStr = "<span class='button blue_core' id='addBtn2_" + treeNode.tId + "' title='新增报表模板' onfocus='this.blur();'></span>";
                sObj.after(addStr);
                btn = $("#addBtn2_"+treeNode.tId + "");
                if (btn) btn.bind("click", function(){
                    // let me = zTreeOprObj;
                    if (treeNode.nodeType === RT.NodeType.NODE || treeNode.level === 0) {
                        let rawNode = me.createIniNode();
                        rawNode.nodeType = RT.NodeType.TEMPLATE;
                        rawNode.name = "新增报表模板" + (new Date()).getTime();
                        rawNode.ID = -1;
                        rawNode.released = false;
                        let newNodes = [], isSilent = false;
                        newNodes.push(rawNode);
                        me.treeObj.addNodes(treeNode, -1, newNodes, isSilent);
                        //重写
                        let tn = me.getTopParentNode(treeNode);
                        // let pn = me.buildNodeDoc(treeNode);
                        let pathArr = [];
                        let nodeArr = [];
                        let path = {operation_type: 'add', node_path: []};
                        path.node_path = me.getNodePath(treeNode, true, tn);
                        pathArr.push(path);
                        nodeArr.push(rawNode);
                        me.partialUpdateTreeNode(tn.nodeId, pathArr, nodeArr, false, function (rst) {
                            if (!(rst)) {
                                alert("新增空白模板失败！");
                            }
                            me.refreshNodes();
                        }, null);
                    }
                });
            }
        }
    },
    removeHoverDom: function(treeId, treeNode) {
        $("#addBtn_"+treeNode.tId).unbind().remove();
        $("#addBtn2_"+treeNode.tId).unbind().remove();
    },
    onCheck: function (event, treeId, treeNode) {
        let me = zTreeOprObj;
        let tn = me.getTopParentNode(treeNode);
        let newTopNode = me.buildRootNodeDoc(tn);
        me.updateTreeRootNode(newTopNode, true, function(rst){
            if (!(rst)) {
                alert("修改发布状态失败！");
            }
        });
    },
    onBeforeDrag: function (treeId, treeNodes) {
        let rst = true;
        for (let node of treeNodes) {
            // if (node.level === 0 || node.nodeType !== RT.NodeType.TEMPLATE) {
            if (node.level === 0) { // 这里放开目录！需要多考虑不同的场景情况
                rst = false;
                break;
            }
        }
        return rst;
    },
    onBeforeDrop: function (treeId, treeNodes, targetNode, moveType, isCopy) {
        let me = zTreeOprObj, rst = true;
        let srcNode = treeNodes[0];
        let sourceTopNode = me.getParentNodeByNodeLevel(srcNode, NODE_LEVEL_COMPILATION_NEW);
        let sourceSecTopNode = me.getParentNodeByNodeLevel(srcNode, 1);
        let targetTopNode = me.getParentNodeByNodeLevel(targetNode, NODE_LEVEL_COMPILATION_NEW);
        me.moveSrcTopNode = null;
        me.moveSrcSecondTopNode = sourceSecTopNode; //这个无论有没有不同的Top，都需要Second Top
        me.orgMoveSrcNodeLevel = srcNode.level;
        if (isCopy) {
            return false; //暂不支持copy!
        }
        if (srcNode.nodeType !== RT.NodeType.TEMPLATE) {
            //操作目录
            if (!isCopy) {
                if (moveType !== 'inner') {
                    if (targetNode.level === 0) {
                        //不能是顶节点的兄弟节点
                        alert('禁止成为顶节点！');
                        rst = false;
                    }
                } else if (targetNode.nodeType === RT.NodeType.TEMPLATE) {
                    // 不能成为模板的子节点
                    alert('模板不能有子节点！');
                    rst = false;
                } else if (!confirm("是否要把模板目录移动到另一个工程类型？")) {
                    rst = false;
                }
            } else {
                //移动目录暂时不支持copy方式（主要是要创建新模板麻烦）
                alert('暂不支持目录的copy模式！');
                rst = false;
            }
        } else {
            //操作模板，保留原来逻辑
            if (moveType === 'inner') {
                if (targetNode.nodeType === RT.NodeType.TEMPLATE) {
                    //模板节点不能成为另一个模板节点的子节点！
                    alert('模板不能有子节点！');
                    rst = false;
                } else {
                    if (sourceTopNode !== targetTopNode) {
                        if (!isCopy) {
                            if (!confirm("是否要把报表模板移动到另一个工程类型？")) {
                                rst = false;
                            }
                        }
                    } else {
                        //同一根节点下，可以随便移动或copy
                    }
                }
            } else {
                if (targetNode.level === 0) {
                    //模板节点不能与顶节点同级！
                    alert('禁止成为顶节点！');
                    rst = false;
                } else {
                    if (sourceTopNode !== targetTopNode) {
                        if (!isCopy) {
                            if (!confirm("是否要把报表模板移动到另一个工程类型？")) {
                                rst = false;
                            }
                        }
                    } else {
                        //同一根节点下，可以随便移动或copy
                    }
                }
            }
        }
        if (rst && !isCopy && sourceTopNode !== targetTopNode) {
            me.moveSrcTopNode = sourceTopNode;
        }
        return rst;
    },
    onDrop: function (event, treeId, treeNodes, targetNode, moveType, isCopy) {
        let me = zTreeOprObj;
        zTreeOprObj.treeObj.checkNode(treeNodes[0], false, false);
        treeNodes[0].released = false;
        let srcNode = treeNodes[0];
        let targetTopNode = me.getParentNodeByNodeLevel(targetNode, 0);
        let newTopNode = null;
        let canContinue = false;
        if (isCopy) {
            //原先的copy逻辑在计量环境不合适了，暂不支持！
        } else {
            //*
            newTopNode = me.buildRootNodeDoc(targetTopNode);
            me.updateTreeRootNode(newTopNode, false, function(rst){
                canContinue = true;
                me.currentNode = treeNodes[0];
            }, function(badResult){
                displayMessage("移动请求失败!", "red", 2000);
                console.log(badResult.toString());
                canContinue = false;
            });
            if (canContinue && !isCopy && me.moveSrcTopNode) {
                let newSrcTopNode = me.buildRootNodeDoc(me.moveSrcTopNode);
                me.updateTreeRootNode(newSrcTopNode, true, function(rst){
                    // canContinue = true;
                }, function(badResult){
                    displayMessage("移动请求失败!", "red", 2000);
                    canContinue = true;
                });
            }
            me.moveSrcTopNode = null;
            /*/
            //移动的场景很多，复杂度高，目前只支持到第2层以下的(不能支持移动到根目录下！)
            const targetSecTopNode = me.getParentNodeByNodeLevel(targetNode, 1);
            const srcSecTopNode = me.moveSrcSecondTopNode;
            const updateNodesArr = [];
            const pathArr = [];
            const nodeArr = [];
            if (srcNode.level === 1) {
                //表示在根目录下，那么局部更新的性质就改变了，是'add'的性质
                updateNodesArr.push(targetTopNode);
            } else {
                //
            }
            updateNodesArr.push(targetSecTopNode);
            if (targetSecTopNode !== srcSecTopNode && me.moveSrcTopNode === null) {
                updateNodesArr.push(srcSecTopNode);
            }
            for (const uNode of updateNodesArr) {
                let nNode = me.buildNodeDoc(uNode);
                let path = {operation_type: 'update', node_path: []};
                path.node_path = me.getNodePath(uNode, true);
                pathArr.push(path);
                nodeArr.push(nNode);
            }
            me.partialUpdateTreeNode(targetTopNode.nodeId, pathArr, nodeArr, true, function (rst) {
                if (!(rst)) {
                    alert("移动请求失败!");
                } else {
                    if (me.moveSrcTopNode !== null) {
                        let nNode = me.buildNodeDoc(srcSecTopNode);
                        let path = {operation_type: 'update', node_path: []};
                        path.node_path = me.getNodePath(srcSecTopNode, true);
                        pathArr.push(path);
                        nodeArr.push(nNode);
                        me.partialUpdateTreeNode(me.moveSrcTopNode.nodeId, pathArr, nodeArr, true, function (rst) {
                            if (!(rst)) {
                                alert("移动请求失败!");
                            }
                        }, null);
                    }
                }
                me.moveSrcTopNode = null;
                me.refreshNodes();
            }, null);
            //*/
        }
    },
    chkAndSetDupRefTplIds: function (tplNodes, selectedRefId) {
        let me = zTreeOprObj, tmpRefIds = [];
        me.dupTplIds = [];
        let private_get_dup_ids = function (tplNode) {
            if (tplNode.refId && tplNode.refId !== -1) {
                let refId = tplNode.refId;
                if (tmpRefIds.indexOf(refId) < 0) {
                    tmpRefIds.push(refId);
                } else {
                    if (me.dupTplIds.indexOf(refId) < 0) {
                        me.dupTplIds.push(refId);
                    } else {
                        //
                    }
                }
            }
            if (tplNode.items && tplNode.items.length > 0) {
                for (let subTplNode of tplNode.items) {
                    private_get_dup_ids(subTplNode);
                }
            }
        };
        let private_set_dup_icon = function (tplNode) {
            if (me.dupTplIds.indexOf(tplNode.refId) >= 0) {
                // tplNode.icon = "../../../../lib/ztree/css/img/diy/3.png"; //or below:
                if (selectedRefId && selectedRefId === tplNode.refId) {
                    tplNode.icon = "/lib/ztree/css/img/diy/5.png";
                } else {
                    tplNode.icon = "/lib/ztree/css/img/diy/3.png";
                }
                // tplNode.style = "background:url(/lib/ztree/css/img/diy/3.png) 0 0 no-repeat;"
            } else {
                //设置白板
                // if (!tplNode.isParent) tplNode.icon = "/lib/ztree/css/img/diy/10.png";
                if (!tplNode.isParent) tplNode.className = "button ico_docu";
            }
            if (tplNode.items && tplNode.items.length > 0) {
                for (let subTplNode of tplNode.items) {
                    private_set_dup_icon(subTplNode);
                }
            }
        };
        for (let tplNodeItem of tplNodes) {
            private_get_dup_ids(tplNodeItem);
        }
        for (let tplNodeItem of tplNodes) {
            private_set_dup_icon(tplNodeItem);
        }
        if (selectedRefId) {
            me.hasRefreshedDupRefIds = true;
        } else {
            me.hasRefreshedDupRefIds = false;
        }
    },
    getReportTemplateTreeEx: function () {
        let me = zTreeOprObj;
        let allTopTplNodes = [];
        //topTreeNodesValue是已经存在的公共对象，在page render的时候就存放好
        for (let item of topTreeNodesValue) {
            allTopTplNodes.push({userId: "-100", nodeId: item.id, name: item.name, items: item.items, isParent: true, refId: "", rpt_type: item.rpt_type, pid: item.pid, last_update_time: item.last_update_time});
        }
        zTreeHelper.createTreeDirectly(allTopTplNodes, setting, "rptTplTree", me);
        let topNodes = me.treeObj.getNodes();
        me.chkAndSetDupRefTplIds(topNodes, null);
        me.refreshNodes();
        let private_setup_checked = function (itemNode) {
            if (itemNode.nodeType === RT.NodeType.NODE) {
                me.treeObj.setChkDisabled(itemNode, true);
            } else if (itemNode.nodeType === RT.NodeType.TEMPLATE) {
                me.treeObj.checkNode(itemNode, !!(itemNode.released));
            }
            if (itemNode.items && itemNode.items.length > 0) {
                for (let subItem of itemNode.items) {
                    private_setup_checked(subItem);
                }
            }
        };
        me.treeObj.expandAll(false);

        // let topNodes = me.treeObj.getNodes();
        for (let topLvItem of topNodes) {
            me.treeObj.expandNode(topLvItem, true, false, false);
            if (topLvItem.items && topLvItem.items.length > 0) {
                for (let secTopLvItem of topLvItem.items) {
                    me.treeObj.expandNode(secTopLvItem, true, false, false);
                }
            }
        }

        for (let node of topNodes) {
            me.treeObj.setChkDisabled(node, true);
            if (node.items && node.items.length > 0) {
                for (let item of node.items) {
                    // me.treeObj.setChkDisabled(item, true);
                    private_setup_checked(item);
                }
            }
        }
    },
    onBeforeRemove: function(treeId, treeNode){
        let canRemove = false;
        if (treeNode.level > NODE_LEVEL_USER) {
            if (!(treeNode.items) || treeNode.items.length < 1) {
                canRemove = confirm("请再确认您要删除！");
            } else {
                alert("含有子项，不能删除！");
            }
        } else {
            alert("不能删除顶级模板！");
        }
        return canRemove;
    },
    onRemove: function(e, treeId, treeNode){
        if (treeNode.level > NODE_LEVEL_USER) {
            let me = zTreeOprObj;
            // let tn = me.getTopParentNode(treeNode);
            // let newTopNode = me.buildRootNodeDoc(tn);
            // me.updateTreeRootNode(newTopNode, true, function(rst){
            //     if (!(rst)) {
            //         alert("删除请求失败！");
            //     }
            // });
            let tn = me.getTopParentNode(treeNode);
            let pathArr = [];
            let nodeArr = [];
            let path = {operation_type: 'delete', node_path: []};
            path.node_path = me.getNodePath(treeNode, true, tn);
            pathArr.push(path);
            nodeArr.push('');
            me.partialUpdateTreeNode(tn.nodeId, pathArr, nodeArr, true, function (rst) {
                if (!(rst)) {
                    alert("删除模板失败！");
                }
            }, null);
            me.refreshNodes();
        }
    },
    beforeEditName: function (treeId, treeNode) {
        if (treeNode.level > NODE_LEVEL_COMPILATION_NEW) {
            setTimeout(function(){
                let ip = $("#" + treeNode.tId + IDMark_Input);
                if (ip.length > 0) {
                    ip[0].className = "individualRename";
                } else {
                    setTimeout(function(){
                        let ip = $("#" + treeNode.tId + IDMark_Input);
                        if (ip.length > 0) {
                            ip[0].className = "individualRename";
                        } else {
                            console.log("sorry!");
                        }
                    }, 50);
                }
            }, 50);
            return true;
        } else {
            return false;
        }
    },
    beforeRename: function(treeId, treeNode, newName, isCancel) {
        if (isCancel) return true;
        if (newName.length === 0) {
            return false;
        } else {
            let parentNode = treeNode.getParentNode();
            if (parentNode) {
                let cnt = 0;
                for (const child of parentNode.items) {
                    if (child.name === newName && child.tId !== treeNode.tId) cnt++;
                }
                if (cnt > 0) {
                    alert('同目录下不能有相同名称！');
                    return false;
                } else {
                    treeNode.oldName = treeNode.name;
                }
            }
        }
        return true;
    },
    onRename : function(e, treeId, treeNode, isCancel) {
        if (!isCancel) {
            let me = zTreeOprObj;
            if (treeNode.level === 0) {
                //因结构变化，已经不允许更改顶节点名字
            } else {
                let tn = me.getTopParentNode(treeNode);
                let nNode = me.buildNodeDoc(treeNode);
                let pathArr = [];
                let nodeArr = [];
                let path = {operation_type: 'update', node_path: []};
                path.node_path = me.getNodePath(treeNode, true, tn);
                path.node_path[path.node_path.length - 1] = treeNode.oldName; //这里调整下路径，需要找original的那个名字
                pathArr.push(path);
                nodeArr.push(nNode);
                me.partialUpdateTreeNode(tn.nodeId, pathArr, nodeArr, true, function (rst) {
                    if (!(rst)) {
                        alert("更新模板ID失败！");
                    }
                    me.refreshNodes();
                }, null);
            }
        }
    },
    onChangeFlag: function(flagProp, flagDom){
        let me = zTreeOprObj;
        if (me.currentNode && me.currentNode.nodeType === RT.NodeType.TEMPLATE) {
            if (!me.currentNode.hasOwnProperty("flags")) {
                me.currentNode.flags = {};
            }
            me.currentNode.flags[flagProp] = (flagDom.selectedOptions[0].value === 'NA')?null:flagDom.selectedOptions[0].value;
            let tn = me.getTopParentNode(me.currentNode);
            let params = {topNodeID: tn.nodeId, ID: me.currentNode.ID, name: me.currentNode.name, refId: me.currentNode.refId, flagProp: flagProp, flagPropValue: me.currentNode.flags[flagProp]};
            me.updateSubNode(params, true, function(rst){
                if (!(rst)) {
                    alert('修改标记：[' + flagProp + '] 失败！');
                }
            });
        }
    },

    createNewTpl: function () {
        let me = zTreeOprObj, params = {};
        if (me.currentNode && me.currentNode.nodeType === RT.NodeType.TEMPLATE) {
            let rptTypeId = common_rpt_type_ids.flow;
            if ($("#crossTypeOpt")[0].checked) rptTypeId = common_rpt_type_ids.cross;
            if ($("#billTypeOpt")[0].checked) rptTypeId = common_rpt_type_ids.bill;
            params.rptDftTplId = rptTypeId;
            params.rptName = me.currentNode.name;
            CommonAjax.postXsrfEx("report_tpl_api/createDftRptTpl", params, 10000, true, getCookie('csrfToken'), function(result){
                    if (result) {
                        // console.log(result);
                        let tplData = JSON.parse(result.data.rpt_content);
                        me.currentNode.ID = result.data.id;
                        me.currentNode.refId = me.currentNode.ID;
                        me.currentNode.rptTpl = tplData;
                        //然后再更节点
                        let tn = me.getTopParentNode(me.currentNode);
                        let nNode = me.buildNodeDoc(me.currentNode);
                        let pathArr = [];
                        let nodeArr = [];
                        let path = {operation_type: 'update', node_path: []};
                        path.node_path = me.getNodePath(me.currentNode, true, tn);
                        pathArr.push(path);
                        nodeArr.push(nNode);
                        me.partialUpdateTreeNode(tn.nodeId, pathArr, nodeArr, true, function (rst) {
                            if (!(rst)) {
                                alert("更新模板ID失败！");
                            }
                            me.refreshNodes();
                        }, null);
                        me.chkAndRreshRefTpl(); //改改顺序，防止js error导致不触发me.updateTreeRootNode
                    } else {
                        alert('update error!');
                    }
                }, null, null
            );
        }
    },
    beforeClick: function (treeId, treeNode, clickFlag) {
        let me = zTreeOprObj;
        if (me.dupTplIds && me.dupTplIds.indexOf(treeNode.refId) >= 0) {
            let topNodes = me.treeObj.getNodes();
            me.chkAndSetDupRefTplIds(topNodes, treeNode.refId);
            me.refreshNodes();
        } else if (me.hasRefreshedDupRefIds) {
            let topNodes = me.treeObj.getNodes();
            me.chkAndSetDupRefTplIds(topNodes, null);
            me.refreshNodes();
        }
        return true;
    },
    onClick: function(event,treeId,treeNode) {
        let me = zTreeOprObj;
        me.currentNode = treeNode;
        bandTreeOprObj.currentNode = null;
        if (treeNode.nodeType === RT.NodeType.TEMPLATE) {
            if (treeNode.refId < 0) {
                //创建新报表模板
                $('#rptTypeSelectionModal').modal('show');
            } else {
                //显示报表模板
                me.chkAndRreshRefTpl(true);
            }
        }
    },
    isFlowTpl: function () {
        let rst = false;
        let me = zTreeOprObj;
        if (me.currentNode && me.currentNode.nodeType === RT.NodeType.TEMPLATE) {
            rst = !!(me.currentNode.rptTpl[JV.NODE_FLOW_INFO]);
        }
        return rst;
    },
    isCrossTpl: function () {
        let rst = false;
        let me = zTreeOprObj;
        if (me.currentNode && me.currentNode.nodeType === RT.NodeType.TEMPLATE) {
            rst = !!(me.currentNode.rptTpl[JV.NODE_CROSS_INFO]);
        }
        return rst;
    },
    isBillTpl: function () {
        let rst = false;
        let me = zTreeOprObj;
        if (me.currentNode && me.currentNode.nodeType === RT.NodeType.TEMPLATE) {
            rst = !!(me.currentNode.rptTpl[JV.NODE_BILL_INFO]);
        }
        return rst;
    },
    getFolderText: function (treeNode, separator) {
        let rst = "";
        if (treeNode) {
            rst = treeNode.name;
            let parentNode = treeNode.getParentNode();
            while (parentNode !== null) {
                rst = parentNode.name + separator + rst;
                parentNode = parentNode.getParentNode();
            }
        }
        return rst;
    },
    chkAndRreshRefTpl: function(forceRefresh) {
        let me = zTreeOprObj, params = {};
        if (me.currentNode && me.currentNode.nodeType === RT.NodeType.TEMPLATE && me.currentNode.refId > 0) {
            if (forceRefresh || !(me.currentNode.rptTpl)) {
                params.rptTplId = me.currentNode.refId;
                CommonAjax.postXsrfEx("report_tpl_api/getRefRptTpl", params, 20000, true, getCookie('csrfToken'),
                    function(result){
                        let tplData = JSON.parse(result.data.rpt_content);
                        me.currentNode.rptTpl = tplData;
                        me.currentNode.rptTpl[JV.NODE_MAIN_INFO][JV.NODE_MAIN_INFO_RPT_NAME] = me.currentNode.name;
                        if (me.currentNode.rptTpl["GROUP_KEY"]) {
                            let grp_keys = me.currentNode.rptTpl["GROUP_KEY"].split('_');
                            if (grp_keys.length > 0) {
                                grp_keys[1] = me.currentNode.name;
                            }
                            me.currentNode.rptTpl["GROUP_KEY"] = grp_keys.join("_");
                        }
                        tplHelper.refreshTplView(me.currentNode.rptTpl);
                        if (me.currentNode.hasOwnProperty('flags')) {
                            if (me.currentNode.flags.hasOwnProperty('sumUpType')) {
                                let val = 0;
                                if (me.currentNode.flags['sumUpType'] === 'normalSummary') {
                                    val = 1;
                                }
                                $("#element_sumFlags_select")[0].selectedIndex = val;
                            } else {
                                $("#element_sumFlags_select")[0].selectedIndex = 0;
                            }
                        } else {
                            $("#element_sumFlags_select")[0].selectedIndex = 0;
                        }

                        if ($("#rpt_tpl_visual_tab")[0].className === "nav-link p-1 active") {
                            setTimeout(function(){visualJumbo.iniSpreadJs(); visualJumbo.setupTpl()}, 50)
                        }
                    }, null, null
                );
            } else {
                me.currentNode.rptTpl[JV.NODE_MAIN_INFO][JV.NODE_MAIN_INFO_RPT_NAME] = me.currentNode.name;
                tplHelper.refreshTplView(me.currentNode.rptTpl);
                if ($("#rpt_tpl_visual_tab")[0].className === "nav-link p-1 active") {
                    setTimeout(function(){visualJumbo.iniSpreadJs(); visualJumbo.setupTpl()}, 50)
                }
            }
        }
    },
    getRefTpl: function() {
        let me = zTreeOprObj, rst = null;
        if (me.currentNode && me.currentNode.nodeType === RT.NodeType.TEMPLATE && me.currentNode.refId > 0) {
            rst = me.currentNode.rptTpl
        }
        return rst;
    },
    changeProperty: function (propStr, dom) {
        let me = zTreeOprObj;
        if (me.currentNode && me.currentNode.rptTpl) {
            let props = propStr.split('.');
            let lastProp = me.currentNode.rptTpl;
            for (let idx = 1; idx < props.length; idx++) {
                lastProp = lastProp[props[idx - 1]];
            }
            lastProp[props[props.length - 1]] = dom.value;
        }
    },
    extractMainInfo: function (rptTpl) {
        //模板信息
        rptTpl[JV.NODE_MAIN_INFO][JV.NODE_MAIN_INFO_RPT_NAME] = $("#rptTplName")[0].value;
        rptTpl[JV.NODE_MAIN_INFO][JV.NODE_PAGE_INFO][JV.PROP_PAGE_SIZE] = JV.PAGES_SIZE_STR[$("#rptTplPageSize")[0].selectedIndex];
        if ($("#rptTplPageOrientation")[0].selectedIndex === 1) {
            rptTpl[JV.NODE_MAIN_INFO][JV.NODE_PAGE_INFO][JV.PROP_ORIENTATION] = JV.ORIENTATION_PORTRAIT;
        } else {
            rptTpl[JV.NODE_MAIN_INFO][JV.NODE_PAGE_INFO][JV.PROP_ORIENTATION] = JV.ORIENTATION_LANDSCAPE;
        }
        if (rptTpl[JV.NODE_FLOW_INFO]) {
            rptTpl[JV.NODE_FLOW_INFO][JV.PROP_MULTI_COLUMN] = parseInt($("#rptTplMultiCols")[0].value);
        }
        //考虑到页边距必然跟用户设置走，所以这里没必要特意去设置了，全部下架
    },
    getParentNodeByNodeLevel: function (currentNode, level) {
        let rst = currentNode;
        while (rst !== null) {
            if (rst.level <= level) {
                break;
            } else {
                rst = rst.getParentNode();
            }
        }
        return rst;
    },
    getTopParentNode: function (currentNode) {
        let rst = currentNode;
        while (rst != null && rst.level > 0) {
            rst = rst.getParentNode();
        }
        return rst;
    }
};

function displayMessage(message, color, disappearTime, id) {
    // let domId = id;
    // if (!domId) domId = "id_after_saved_lbl";
    // $("#" + domId)[0].style.color = color;
    // $("#" + domId)[0].innerHTML = message;
    // setTimeout(function(){
    //     $("#" + domId)[0].innerHTML = "";
    // }, disappearTime);

    console.log(message); //暂时控制台输出
}

