/**
 * Created by Tony on 2017/12/26.
 */

// const defined_handle_options = [
//     {name: '变更令排序', key: 'changeSort', hint: '默认的变更令排序，同时对变更令，变更清单进行排序'}
// ];

let preHandleObj = {
    treeObj: null,
    selectedTreeObj: null,
    selectableTreeObj: null,
    // typeTreeObj: null,
    currentNode: null,
    iniTree: function(rptTpl) {
        let me = this;
        me.buildData(rptTpl);
    },
    iniDataMap: function () {
        let me = this;
        let selectedFieldList = fieldMapTreeOprObj.copySelectedFieldList();
        if (me.selectableTreeObj) {
            let nodes = me.selectableTreeObj.getNodes();
            for (let node of nodes) {
                me.selectableTreeObj.removeNode(node);
            }
            me.selectableTreeObj.refresh();
        }
        me.selectableTreeObj = $.fn.zTree.init($("#pre_handle_data_selectable_fields"), selectableFieldMapSettingForPreDefined, selectedFieldList);
        me.selectableTreeObj.expandAll(true);
        // me.refreshBandSelection();
    },
    buildData: function(rptTpl) {
        let me = this, handles = [];
        if (rptTpl[JV.NODE_MAP_DATA_HANDLE_INFO]) {
            for (let item of rptTpl[JV.NODE_MAP_DATA_HANDLE_INFO]) {
                let hd = {Name: "预处理", Title: "", "映射数据对象": "", "预处理类型": "指定方式", "方式Key": "", hint: '', fields: []};
                me.private_copy_node(item, hd);
                me.private_set_title(hd);
                hd.Operations = []; //考虑到用户可能会换来换去，这样会有冗余的属性出现
                handles.push(hd);
            }
        }
        me.treeObj = $.fn.zTree.init($("#pre_handle_data_info_reversed"), preHandleSetting, handles);
    },
    createNewNode: function () {
        let rst = {Name: "预处理", Title: "", "映射数据对象": "", "预处理类型": "指定方式", "方式Key": "changeSort", hint: '默认的变更令排序，同时对变更令，变更清单进行排序', fields: []};
        //目前就这一种
        return rst;
    },
    addNewNode: function() {
        let me = this, item = me.createNewNode();
        me.private_set_title(item);
        me.treeObj.addNodes(null, -1, [item], true);
    },
    private_copy_node: function(src, dest) {
        dest["方式Key"] = src["方式Key"];
        if (src.fields) {
            for (const field of src.fields) {
                dest.fields.push(field);
            }
        }
        dest.hint = src.hint;
        if (src[JV.PROP_HANDLE_SELF_SETUP]) {
            dest[JV.PROP_HANDLE_SELF_SETUP] = src[JV.PROP_HANDLE_SELF_SETUP];
        }
    },
    private_set_title: function(node) {
        node.Title = node.hint;
    },
    refreshByNode: function(treeNode) {
        //计量的预处理，目前只处理预定义的勾选指标
        let me = this;
        let topNode = {Name: '已选择指标', isParent: true, Title: '', items: []};
        topNode.items = me._createSelectedFieldNodes(treeNode);
        let selectedFieldList = [topNode];
        if (me.selectedTreeObj) {
            let nodes = me.selectedTreeObj.getNodes();
            for (let node of nodes) {
                me.selectedTreeObj.removeNode(node);
            }
            me.selectedTreeObj.refresh();
        }

        me.selectedTreeObj = $.fn.zTree.init($("#pre_handle_data_selected_fields"), selectedFieldMapSettingForPreDefined, selectedFieldList);
        me.selectedTreeObj.expandAll(true);
        if (treeNode[JV.PROP_HANDLE_SELF_SETUP]) {
            $('#pre_handle_setup_content')[0].value = treeNode[JV.PROP_HANDLE_SELF_SETUP];
        } else {
            $('#pre_handle_setup_content')[0].value = '';
        }
        editor.setValue($('#pre_handle_setup_content')[0].value);
        setTimeout(() => {
            editor.refresh();
        }, 1)
        $("#div_pre_handle_field_data")[0].style.display = '';
        $("#div_pre_handle_setup")[0].style.display = '';
    },
    _createSelectedFieldNodes: function (preHdlCfgNode) {
        const rst = [];
        if (preHdlCfgNode.fields) {
            for (const field of preHdlCfgNode.fields) {
                rst.push(field);
            }
        }
        return rst;
    },
    hide_all_dom: function() {
        $("#div_pre_handle_field_data")[0].style.display = 'none';
        $("#div_pre_handle_setup")[0].style.display = 'none';
    },
    onPreHandleSetup: function(dom) {
        let me = preHandleObj;
        if (me.currentNode) {
            me.currentNode[JV.PROP_HANDLE_SELF_SETUP] = dom.value;
        }
    },
    onPreHandleClick: function(event,treeId,treeNode) {
        //点击预处理环节 节点
        let me = preHandleObj;
        me.currentNode = treeNode;
        me.refreshByNode(treeNode);
    },
    changePreHandleType: function (dom, treeNodeId) {
        let me = preHandleObj, treeNode = me.treeObj.getNodeByTId(treeNodeId);
        treeNode.hint = defined_handle_options[dom.selectedIndex].hint;
        treeNode['方式Key'] = defined_handle_options[dom.selectedIndex].key;
        me.private_set_title(treeNode);
        me.treeObj.updateNode(treeNode, false);
        me.refreshByNode(treeNode);
    },
    onBeforeDrag: function (treeId, treeNodes) {
        let rst = true;
        for (let node of treeNodes) {
            if (node.level > 0) {
                rst = false;
                break;
            }
        }
        return rst;
    },
    onBeforeDrop: function(treeId, treeNodes, targetNode, moveType){
        let rst = false;
        if (targetNode.level === 0 && moveType !== "inner") {
            rst = true;
        }
        return rst;
    },
    onFieldBeforeDrag: function (treeId, treeNodes) {
        let rst = true;
        for (let node of treeNodes) {
            if (node.level === 0) {
                rst = false;
                break;
            }
        }
        return rst;
    },
    onFieldBeforeDrop: function(treeId, treeNodes, targetNode, moveType){
        let rst = false;
        if (targetNode.level === 0 && moveType === "inner") {
            rst = true;
        }
        return rst;
    },
    onFieldDrop: function (event, treeId, treeNodes, targetNode, moveType) {
        let me = preHandleObj;
        me._reExtractFields();
    },
    onInnerFieldBeforeDrop: function(treeId, treeNodes, targetNode, moveType){
        let rst = false;
        if (targetNode.level === 1 && moveType !== "inner") {
            rst = true;
        }
        return rst;
    },
    onBeforeRemove: function(treeId, treeNode){
        let rst = true;
        if (treeNode.isParent) {
            rst = false;
        } else {
            //
        }
        return rst;
    },
    onRemove: function (event, treeId, treeNode) {
        let me = preHandleObj;
        me._reExtractFields();
    },
    _reExtractFields: function() {
        let me = preHandleObj;
        if (me.currentNode && me.selectedTreeObj) {
            let newFields = [];
            let topNodes = me.selectedTreeObj.getNodes();
            for (const node of topNodes[0].items) {
                newFields.push({Name: node.Name, FieldID: parseInt(node.ID)});
            }
            me.currentNode.fields = newFields;
        }
    },
    addHoverDom: function(treeId, treeNode) {
        let sObj = $("#" + treeNode.tId + IDMark_A);
        if (treeNode.editNameFlag || $("#diySelect_"+treeNode.tId).length > 0) {
            return;
        } else {
            let addSelectStr = '<select class="selDemo" id="diySelect_' +treeNode.tId + '" onchange="preHandleObj.changePreHandleType(this, \'' + treeNode.tId + '\')">';
            let dftOptionIdx = 0;
            for (let option of defined_handle_options) {
                addSelectStr += '<option value="' + option.key + '">' + option.name + '</option>';
                if (treeNode['方式Key'] === option.key) dftOptionIdx = defined_handle_options.indexOf(option);
            }
            sObj.after(addSelectStr);
            let selector = $("#diySelect_" + treeNode.tId);
            selector[0].selectedIndex = dftOptionIdx;
        }
    },
    removeHoverDom: function (treeId, treeNode) {
        $("#addBtn_"+treeNode.tId).unbind().remove();
    },
    extractTabFields: function (rptTpl) {
        let me = this, nodes = me.treeObj.getNodes();
        let rst = [];
        if (nodes && nodes.length > 0) {
            for (const node of nodes) {
                let exf = {"预处理类型": "指定方式", "映射数据对象": "", "方式Key": "", hint: '', fields: [], "自定义设置": '' };
                me.private_copy_node(node, exf);
                rst.push(exf);
            }
        }
        rptTpl[JV.NODE_MAP_DATA_HANDLE_INFO] = rst;
    }
};

$(document).ready(function () {
    editor.on('change', function () {
        let me = preHandleObj;
        if (me.currentNode) {
            me.currentNode[JV.PROP_HANDLE_SELF_SETUP] = editor.getValue();
        }
    });
});
