/**
 * tree相关
 *
 * @author caiaolin
 * @date 2015-06-10
 * @version
 */
(function($){
    $.fn.tree = function(options){
        var defaults={
            hoverAction: false
        };
        var opts = $.extend(defaults,options);
        var tree = $(this);
        // 展开操作
        var spreadTreeFunction = function(element) {
            element.parent().parent().next('.child').slideToggle('fast');
            var status = element.attr('data-slide');
            status = parseInt(status);
            if(status == 0) {
                element.removeClass('fa-plus').addClass('fa-minus');
                element.attr('data-slide', 1);
            }else{
                element.removeClass('fa-minus').addClass('fa-plus');
                element.attr('data-slide', 0);
            }
        };
        var canSpread = true;

        // 展开树
        tree.find(".tree-folder-header").click(function(event) {
            if (canSpread) {
                var iconElement = $(this).children(".tree-item-name").find(".icon-only").first();
                spreadTreeFunction(iconElement);
            }
        });
        // 点击操作区域不允许展开树
        tree.find(".tree-action").click(function() {
            canSpread = false;
        });
        // hover菜单
        if(opts.hoverAction === true) {
            var treeAction = null;
            tree.find(".tree-folder-header").hover(function(){
                var self = $(this);
                treeAction = self.find('.tree-action');
                if(treeAction == undefined || treeAction == null) {
                    return false;
                }
                treeAction.show();
            }, function(){
                if(treeAction == undefined || treeAction == null) {
                    return false;
                }
                treeAction.hide();
            });
        }
    };
})(jQuery);