/**
 * 计价规范相关js
 *
 * @author EllisRan
 * @date 2019/9/16
 * @version
 */
$(document).ready(function() {
    // 点击modal
    $('.card-link').on('click', function () {
        const title = $(this).attr('title');
        const select = $(this).attr('data-check');
        $('#modal_title').text(title);
        $('#select_btn').attr('add-type', select);
        let list = '';
        switch (select) {
            case 'bill_id': list = billList;break;
            case 'chapter_id': list = projectChapterList;break;
            case 'template_id': list = standardList;break;
            case 'list_bill_id': list = billList;break;
            case 'list_chapter_id': list = projectChapterList;break;
            case 'list_template_id': list = standardList;break;
            default: break;
        }
        if (list !== '') {
            let html = '<option value="0" disabled selected>请选择添加的' + title + '</option>';
            for (const item of list) {
                html += '<option value="'+ item.id +'">'+ item.name +'</option>';
            }
            $('#modal_select').html(html);
        } else {
            $('#modal_select').html('');
        }
    });

    // 添加
    $('#select_btn').on('click', function () {
        const type = $(this).attr('add-type');
        const select = $('#modal_select').val();
        let list = '';
        if (select === null) {
            toast('请选择要添加项', 'error', 'exclamation-circle');
            return false;
        }
        switch (type) {
            case 'chapter_id':
                chapter_array = chapter_id !== '' ? chapter_id.split(',') : [];
                if (chapter_array.indexOf(select) !== -1) {
                    toast('本规范已存在对应的项目节，请不必重复添加', 'error', 'exclamation-circle');
                    return false;
                } else {
                    chapter_array.push(select);
                    list = chapter_array.join(',');
                }
                break;
            case 'template_id':
                template_array = template_id !== '' ? template_id.split(',') : [];
                if (template_array.indexOf(select) !== -1) {
                    toast('本规范已存在对应的台账模板，请不必重复添加', 'error', 'exclamation-circle');
                    return false;
                } else {
                    template_array.push(select);
                    list = template_array.join(',');
                }
                break;
            case 'bill_id':
                bill_array = bill_id !== '' ? bill_id.split(',') : [];
                if (bill_array.indexOf(select) !== -1) {
                    toast('本规范已存在对应的工程量清单，请不必重复添加', 'error', 'exclamation-circle');
                    return false;
                } else {
                    bill_array.push(select);
                    list = bill_array.join(',');
                }
                break;
            case 'list_chapter_id':
                list_chapter_array = list_chapter_id !== '' ? list_chapter_id.split(',') : [];
                if (list_chapter_array.indexOf(select) !== -1) {
                    toast('本规范已存在对应的项目节，请不必重复添加', 'error', 'exclamation-circle');
                    return false;
                } else {
                    list_chapter_array.push(select);
                    list = list_chapter_array.join(',');
                }
                break;
            case 'list_template_id':
                list_template_array = list_template_id !== '' ? list_template_id.split(',') : [];
                if (list_template_array.indexOf(select) !== -1) {
                    toast('本规范已存在对应的台账模板，请不必重复添加', 'error', 'exclamation-circle');
                    return false;
                } else {
                    list_template_array.push(select);
                    list = list_template_array.join(',');
                }
                break;
            case 'list_bill_id':
                list_bill_array = list_bill_id !== '' ? list_bill_id.split(',') : [];
                if (list_bill_array.indexOf(select) !== -1) {
                    toast('本规范已存在对应的工程量清单，请不必重复添加', 'error', 'exclamation-circle');
                    return false;
                } else {
                    list_bill_array.push(select);
                    list = list_bill_array.join(',');
                }
                break;
            default:
                return false;
        }
        saveValuation(type, list);
    });

    // 移除modal
    $('body').on('click', '.delete-list', function () {
        $('#remove_msg').text($(this).attr('data-msg'));
        $('#remove_btn').attr('data-id', $(this).attr('data-id'));
        $('#remove_btn').attr('data-type', $(this).attr('data-type'));
    });

    //移除btn
    $('#remove_btn').on('click', function () {
        const type = $(this).attr('data-type');
        const value = $(this).attr('data-id');
        let list = '';
        switch (type) {
            case 'chapter_id':
                chapter_array = chapter_id.split(',');
                const index = chapter_array.indexOf(value);
                chapter_array.splice(index, 1);
                list = chapter_array.join(',');
                break;
            case 'template_id':
                template_array = template_id.split(',');
                const index2 = template_array.indexOf(value);
                template_array.splice(index2, 1);
                list = template_array.join(',');
                break;
            case 'bill_id':
                bill_array = bill_id.split(',');
                const index3 = bill_array.indexOf(value);
                bill_array.splice(index3, 1);
                list = bill_array.join(',');
                break;
            case 'list_chapter_id':
                list_chapter_array = list_chapter_id.split(',');
                const index4 = list_chapter_array.indexOf(value);
                list_chapter_array.splice(index4, 1);
                list = list_chapter_array.join(',');
                break;
            case 'list_template_id':
                list_template_array = list_template_id.split(',');
                const index5 = list_template_array.indexOf(value);
                list_template_array.splice(index5, 1);
                list = list_template_array.join(',');
                break;
            case 'list_bill_id':
                list_bill_array = list_bill_id.split(',');
                const index6 = list_bill_array.indexOf(value);
                list_bill_array.splice(index6, 1);
                list = list_bill_array.join(',');
                break;
            default:
                return false;
        }
        saveValuation(type, list);
    });

    // 修改名称
    $('#save-name').click(function () {
        const name = $('#valuation-name').val();
        if (name === '') {
            toast('计价规范名称不能为空', 'error', 'exclamation-circle');
            return false;
        }
        postData(window.location.pathname + '/save', { name: name }, function (result) {
            toast('修改成功', 'success', 'check');
        })
    })
});

function saveValuation(type, list) {
    postData(window.location.pathname + '/save', { type: type, list: list }, function (result) {
        switch (type) {
            case 'chapter_id':
                chapter_id = list;
                let html = '';
                for (const cid of chapter_id.split(',')) {
                    const cInfo = projectChapterList.find(function (item) {
                        return item.id === parseInt(cid);
                    });
                    const removeHtml = list.split(',').length > 1 ? '<a href="javascript:void(0);" class="text-danger pull-right delete-list" data-toggle="modal" data-target="#remove" data-msg="'+ cInfo.name +'" data-type="chapter_id" data-id="'+ cid +'">移除</a>' : '';
                    html += '<li class="list-group-item">' + cInfo.name + removeHtml + '</li>';
                }
                $('#chapter_list').html(html);
                break;
            case 'template_id':
                template_id = list;
                let html2 = '';
                for (const tid of template_id.split(',')) {
                    const tInfo = standardList.find(function (item) {
                        return item.id === parseInt(tid);
                    });
                    const removeHtml = list.split(',').length > 1 ? '<a href="javascript:void(0);" class="text-danger pull-right delete-list" data-toggle="modal" data-target="#remove" data-msg="'+ tInfo.name +'" data-type="template_id" data-id="'+ tid +'">移除</a>' : '';
                    html2 += '<li class="list-group-item">' + tInfo.name + removeHtml + '</li>';
                }
                $('#template_list').html(html2);
                break;
            case 'bill_id':
                bill_id = list;
                let html3 = '';
                for (const bid of bill_id.split(',')) {
                    const bInfo = billList.find(function (item) {
                        return item.id === parseInt(bid);
                    });
                    const removeHtml = list.split(',').length > 1 ? '<a href="javascript:void(0);" class="text-danger pull-right delete-list" data-toggle="modal" data-target="#remove" data-msg="'+ bInfo.name +'" data-type="bill_id" data-id="'+ bid +'">移除</a>' : '';
                    html3 += '<li class="list-group-item">' + bInfo.name + removeHtml + '</li>';
                }
                $('#bill_list').html(html3);
                break;
            case 'list_chapter_id':
                list_chapter_id = list;
                let html4 = '';
                for (const cid of list_chapter_id.split(',')) {
                    const cInfo = projectChapterList.find(function (item) {
                        return item.id === parseInt(cid);
                    });
                    const removeHtml = list.split(',').length > 1 ? '<a href="javascript:void(0);" class="text-danger pull-right delete-list" data-toggle="modal" data-target="#remove" data-msg="'+ cInfo.name +'" data-type="list_chapter_id" data-id="'+ cid +'">移除</a>' : '';
                    html4 += '<li class="list-group-item">' + cInfo.name + removeHtml + '</li>';
                }
                $('#list_chapter_list').html(html4);
                break;
            case 'list_template_id':
                list_template_id = list;
                let html5 = '';
                for (const tid of list_template_id.split(',')) {
                    const tInfo = standardList.find(function (item) {
                        return item.id === parseInt(tid);
                    });
                    const removeHtml = list.split(',').length > 1 ? '<a href="javascript:void(0);" class="text-danger pull-right delete-list" data-toggle="modal" data-target="#remove" data-msg="'+ tInfo.name +'" data-type="list_template_id" data-id="'+ tid +'">移除</a>' : '';
                    html5 += '<li class="list-group-item">' + tInfo.name + removeHtml + '</li>';
                }
                $('#list_template_list').html(html5);
                break;
            case 'list_bill_id':
                list_bill_id = list;
                let html6 = '';
                for (const bid of list_bill_id.split(',')) {
                    const bInfo = billList.find(function (item) {
                        return item.id === parseInt(bid);
                    });
                    const removeHtml = list.split(',').length > 1 ? '<a href="javascript:void(0);" class="text-danger pull-right delete-list" data-toggle="modal" data-target="#remove" data-msg="'+ bInfo.name +'" data-type="list_bill_id" data-id="'+ bid +'">移除</a>' : '';
                    html6 += '<li class="list-group-item">' + bInfo.name + removeHtml + '</li>';
                }
                $('#list_bill_list').html(html6);
                break;
            default:break;
        }
    });
}
