'use strict';

const JV = require('./jpc_value_define');
const JpcParam = {
    createNew: function(rptTpl) {
        const JpcParamResult = {};
        JpcParamResult[JV.NODE_DYNAMIC_DATE_PARAMS] = {};
        JpcParamResult[JV.NODE_SIGNATURE_AUDIT_PARAMS] = {};
        const me = this;
        if (rptTpl[JV.NODE_DISCRETE_PARAMS]) {
            for (let i = 0; i < rptTpl[JV.NODE_DISCRETE_PARAMS].length; i++) {
                me.createSingle(rptTpl[JV.NODE_DISCRETE_PARAMS][i], JpcParamResult, rptTpl, i);
            }
        }
        if (rptTpl[JV.NODE_DYNAMIC_DATE_PARAMS]) {
            for (let i = 0; i < rptTpl[JV.NODE_DYNAMIC_DATE_PARAMS].length; i++) {
                me.createSingle(rptTpl[JV.NODE_DYNAMIC_DATE_PARAMS][i], JpcParamResult[JV.NODE_DYNAMIC_DATE_PARAMS], rptTpl, i);
            }
        }
        if (rptTpl[JV.NODE_SIGNATURE_AUDIT_PARAMS]) {
            for (let i = 0; i < rptTpl[JV.NODE_SIGNATURE_AUDIT_PARAMS].length; i++) {
                me.createSingle(rptTpl[JV.NODE_SIGNATURE_AUDIT_PARAMS][i], JpcParamResult[JV.NODE_SIGNATURE_AUDIT_PARAMS], rptTpl, i);
            }
        }
        return JpcParamResult;
    },
    createSingle: function(paramNode, parentObj, rptTpl, sequence) {
        if (paramNode && paramNode[JV.PROP_ID]) {
            const item = {};
            item[JV.PROP_ID] = paramNode[JV.PROP_ID];
            item[JV.PROP_NAME] = paramNode[JV.PROP_NAME];
            item[JV.PROP_DATA_TYPE] = paramNode[JV.PROP_DATA_TYPE];
            if (paramNode[JV.PROP_DFT_VALUE]) item[JV.PROP_DFT_VALUE] = paramNode[JV.PROP_DFT_VALUE];
            item.DataSeq = sequence;
            parentObj[JV.PROP_ID + '_' + paramNode[JV.PROP_ID]] = item;
        }
    },
};

module.exports = JpcParam;
