/**
 * Created by Tony on 2019/12/25.
 */

module.exports = [{
    Name: '项目标段细节信息',
    remark: '项目标段的细节信息,包括台账、期、计量、支付等信息',
    seq: 1,
    items: [
        {
            Name: '项目及标段',
            remark: '项目标段level的相关信息',
            items: [
                {
                    Name: '项目信息(project)',
                    remark: '',
                    items: [
                        {
                            ID: 1000, Name: '项目_ID', DataType: 'int', TableName: 'project', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("project", "id")',
                        },
                        {
                            ID: 1001, Name: '项目_Code', DataType: 'string', TableName: 'project', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("project", "code")',
                        },
                        {
                            ID: 1002, Name: '项目_名称', DataType: 'string', TableName: 'project', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("project", "name")',
                        },
                        {
                            ID: 1099, Name: '项目_空白', DataType: 'string', TableName: 'project', descr: '',
                            mapExpression: '$PROJECT.REPORT.getBlank("project", "")',
                        },
                    ],
                },
                {
                    Name: '标段信息(tender_info)',
                    remark: '',
                    items: [
                        {
                            ID: 1100, Name: '标段_ID', DataType: 'int', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "id")',
                        },
                        {
                            ID: 1101, Name: '标段_项目名称', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "deal_info.buildName")',
                        },
                        {
                            ID: 1107, Name: '标段_标段名称', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "deal_info.name")',
                        },
                        {
                            ID: 1102, Name: '标段_合同编号', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "deal_info.dealCode")',
                        },
                        {
                            ID: 1103, Name: '标段_合同名称', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "deal_info.dealName")',
                        },
                        {
                            ID: 1104, Name: '标段_建设单位', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.build.company")',
                        },
                        {
                            ID: 1105, Name: '标段_建设单位法人代表', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.build.corporation")',
                        },
                        {
                            ID: 1106, Name: '标段_建设时间', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.build.date")',
                        },
                        {
                            ID: 1120, Name: '标段_合同总价', DataType: 'number', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "deal_param.contractPrice")',
                        },
                        {
                            ID: 1121, Name: '标段_暂定金额', DataType: 'number', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "deal_param.zanLiePrice")',
                        },
                        {
                            ID: 1122, Name: '标段_合同总价(不含暂列金)', DataType: 'number', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.COMMON.Minus($PROJECT.REPORT.getProperty("tender_info", "deal_param.contractPrice"), $PROJECT.REPORT.getProperty("tender_info", "deal_param.zanLiePrice"))',
                        },
                        {
                            ID: 1123, Name: '标段_签约开工预付款', DataType: 'number', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "deal_param.startAdvance")',
                        },
                        {
                            ID: 1124, Name: '标段_签约材料预付款', DataType: 'number', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "deal_param.materialAdvance")',
                        },
                        {
                            ID: 1130, Name: '标段_技术参数_起点桩号', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "tech_param.startPeg")',
                        },
                        {
                            ID: 1131, Name: '标段_技术参数_终点桩号', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "tech_param.endPeg")',
                        },
                        {
                            ID: 1146, Name: '标段_技术参数_开工令日期', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "tech_param.startDate")',
                        },
                        {
                            ID: 1150, Name: '标段_技术参数_合同期限', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "tech_param.dealPeriod")',
                        },
                        {
                            ID: 1151, Name: '标段_技术参数_公路等级', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "tech_param.loadLevel")',
                        },
                        {
                            ID: 1152, Name: '标段_技术参数_长度(KM)', DataType: 'double', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "tech_param.loadLength")',
                        },
                        {
                            ID: 1154, Name: '标段_技术参数_车道数', DataType: 'int', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "tech_param.loadLength")',
                        },
                        {
                            ID: 1153, Name: '标段_技术参数_计划完工日期', DataType: 'double', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "tech_param.planEndDate")',
                        },
                        {
                            ID: 1132, Name: '标段_标段清单_章节代码', DataType: 'array', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getArrayProperty("tender_info", "chapter.code")',
                        },
                        {
                            ID: 1133, Name: '标段_标段清单_章节名称', DataType: 'array', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getArrayProperty("tender_info", "chapter.name")',
                        },
                        {
                            ID: 1134, Name: '标段_标段清单_承包单位1_单位名称', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.contract1.company")',
                        },
                        {
                            ID: 1135, Name: '标段_标段清单_承包单位1_法人代表', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.contract1.corporation")',
                        },
                        {
                            ID: 1136, Name: '标段_标段清单_承包单位1_签订日期', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.contract1.date")',
                        },
                        {
                            ID: 1137, Name: '标段_标段清单_承包单位2_单位名称', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.contract2.company")',
                        },
                        {
                            ID: 1138, Name: '标段_标段清单_承包单位2_法人代表', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.contract2.corporation")',
                        },
                        {
                            ID: 1139, Name: '标段_标段清单_承包单位2_签订日期', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.contract2.date")',
                        },
                        {
                            ID: 1140, Name: '标段_标段清单_监理单位1_单位名称', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.supervision1.company")',
                        },
                        {
                            ID: 1141, Name: '标段_标段清单_监理单位1_法人代表', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.supervision1.corporation")',
                        },
                        {
                            ID: 1142, Name: '标段_标段清单_监理单位1_签订日期', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.supervision1.date")',
                        },
                        {
                            ID: 1143, Name: '标段_标段清单_监理单位2_单位名称', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.supervision2.company")',
                        },
                        {
                            ID: 1144, Name: '标段_标段清单_监理单位2_法人代表', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.supervision2.corporation")',
                        },
                        {
                            ID: 1145, Name: '标段_标段清单_监理单位2_签订日期', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "construction_unit.supervision2.date")',
                        },
                        {
                            ID: 1155, Name: '标段_小数位数_单价', DataType: 'int', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.up")',
                        },
                        {
                            ID: 1156, Name: '标段_小数位数_金额', DataType: 'int', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.tp")',
                        },
                        {
                            ID: 1157, Name: '标段_小数位数_是否合同支付', DataType: 'boolean', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.pay")',
                        },
                        {
                            ID: 1158, Name: '标段_小数位数_合同支付', DataType: 'int', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.payTp")',
                        },
                        {
                            ID: 1160, Name: '标段_精度_对象', DataType: 'int', TableName: 'tender_info', descr: '设计上这是一个对象，那就整个对象获取，通过单位来提取相关精度',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "precision")',
                        },
                        {
                            ID: 1161, Name: '标段_工程款账户_开户名称', DataType: 'str', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "pay_account.project.name")',
                        },
                        {
                            ID: 1162, Name: '标段_工程款账户_开户银行', DataType: 'str', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "pay_account.project.bank")',
                        },
                        {
                            ID: 1163, Name: '标段_工程款账户_开户账号', DataType: 'str', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "pay_account.project.account")',
                        },
                        {
                            ID: 1164, Name: '标段_工程款账户_分账划拨比例', DataType: 'str', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "pay_account.project.rate")',
                        },
                        {
                            ID: 1165, Name: '标段_工程款账户_联系人', DataType: 'str', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "pay_account.project.contact")',
                        },
                        {
                            ID: 1166, Name: '标段_工程款账户_联系电话', DataType: 'str', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "pay_account.project.phone")',
                        },
                        {
                            ID: 1167, Name: '标段_农民工工资专用账户_开户名称', DataType: 'str', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "pay_account.worker.name")',
                        },
                        {
                            ID: 1168, Name: '标段_农民工工资专用账户_开户银行', DataType: 'str', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "pay_account.worker.bank")',
                        },
                        {
                            ID: 1169, Name: '标段_农民工工资专用账户_开户账号', DataType: 'str', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "pay_account.worker.account")',
                        },
                        {
                            ID: 1170, Name: '标段_农民工工资专用账户_分账划拨比例', DataType: 'str', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "pay_account.worker.rate")',
                        },
                        {
                            ID: 1171, Name: '标段_农民工工资专用账户_联系人', DataType: 'str', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "pay_account.worker.contact")',
                        },
                        {
                            ID: 1172, Name: '标段_农民工工资专用账户_联系电话', DataType: 'str', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getProperty("tender_info", "pay_account.worker.phone")',
                        },
                        {
                            ID: 1199, Name: '标段_空白', DataType: 'string', TableName: 'tender_info', descr: '',
                            mapExpression: '$PROJECT.REPORT.getBlank("tender_info", "")',
                        },
                    ],
                },
            ],
        },
        {
            Name: '台账清单信息(ledger)',
            remark: '就是用来计量支付的标段清单信息',
            items: [
                {
                    ID: 1290, Name: '台账清单信息_ID', DataType: 'number', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "id")',
                },
                {
                    ID: 1298, Name: '台账清单信息_台账ID', DataType: 'number', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "ledger_id")',
                },
                {
                    ID: 1297, Name: '台账清单信息_台账父ID', DataType: 'number', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "ledger_pid")',
                },
                {
                    ID: 1296, Name: '台账清单信息_台账order', DataType: 'number', TableName: 'ledger', descr: '在平级时候的顺序',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "order")',
                },
                {
                    ID: 1207, Name: '台账清单信息_是否叶子', DataType: 'number', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "is_leaf")',
                },
                {
                    ID: 1206, Name: '台账清单信息_项目节编号', DataType: 'string', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "code")',
                },
                {
                    ID: 1200, Name: '台账清单信息_清单编号', DataType: 'string', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "b_code")',
                },
                {
                    ID: 1201, Name: '台账清单信息_名称', DataType: 'string', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "name")',
                },
                {
                    ID: 1202, Name: '台账清单信息_单位', DataType: 'string', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "unit")',
                },
                {
                    ID: 1203, Name: '台账清单信息_数量', DataType: 'number', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "quantity")',
                    Precision: { type: 'flexible', flexibleRefFieldID: 1202, flexibleMapExpression: '$PROJECT.REPORT.getProperty("tender_info", "precision")' },
                },
                {
                    ID: 1204, Name: '台账清单信息_单价', DataType: 'currency', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "unit_price")',
                    Precision: { type: 'fixed', fixedMapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.up")' },
                },
                {
                    ID: 1205, Name: '台账清单信息_合价', DataType: 'currency', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "total_price")',
                    Precision: { type: 'fixed', fixedMapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.tp")' },
                },
                {
                    ID: 1208, Name: '台账清单信息_节点类型', DataType: 'int', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("ledger", "node_type")',
                },
                {
                    ID: 1299, Name: '台账清单信息_空白', DataType: 'currency', TableName: 'ledger', descr: '',
                    mapExpression: '$PROJECT.REPORT.getBlank("ledger", "")',
                },
            ],
        },
        {
            Name: '签约清单信息(deal_bills)',
            remark: '',
            items: [
                {
                    ID: 1698, Name: '签约清单信息_ID(id)', DataType: 'number', TableName: 'deal_bills', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("deal_bills", "id")',
                },
                {
                    ID: 1600, Name: '签约清单信息_清单编号(code)', DataType: 'string', TableName: 'deal_bills', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("deal_bills", "code")',
                },
                {
                    ID: 1601, Name: '签约清单信息_名称(name)', DataType: 'string', TableName: 'deal_bills', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("deal_bills", "name")',
                },
                {
                    ID: 1602, Name: '签约清单信息_单位(unit)', DataType: 'string', TableName: 'deal_bills', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("deal_bills", "unit")',
                },
                {
                    ID: 1603, Name: '签约清单信息_数量(quantity)', DataType: 'number', TableName: 'deal_bills', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("deal_bills", "quantity")',
                    Precision: { type: 'flexible', flexibleRefFieldID: 1602, flexibleMapExpression: '$PROJECT.REPORT.getProperty("tender_info", "precision")' },
                },
                {
                    ID: 1604, Name: '签约清单信息_单价(unit_price)', DataType: 'currency', TableName: 'deal_bills', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("deal_bills", "unit_price")',
                    Precision: { type: 'fixed', fixedMapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.up")' },
                },
                {
                    ID: 1605, Name: '签约清单信息_合价(total_price)', DataType: 'currency', TableName: 'deal_bills', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("deal_bills", "total_price")',
                    Precision: { type: 'fixed', fixedMapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.tp")' },
                },
                {
                    ID: 1699, Name: '签约清单信息_空白', DataType: 'currency', TableName: 'deal_bills', descr: '',
                    mapExpression: '$PROJECT.REPORT.getBlank("deal_bills", "")',
                },
            ],
        },
        {
            Name: '期计量信息(stage)',
            remark: '期计量的总体相关信息',
            items: [
                {
                    ID: 1300, Name: '期计量信息_期数', DataType: 'number', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("stage", "order")',
                },
                {
                    ID: 1301, Name: '期计量信息_计量时间', DataType: 'string', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("stage", "s_time")',
                },
                {
                    ID: 1302, Name: '期计量信息_本期合同金额', DataType: 'number', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("stage", "contract_tp")',
                    Precision: { type: 'fixed', fixedMapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.tp")' },
                },
                {
                    ID: 1303, Name: '期计量信息_本期变更金额', DataType: 'number', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("stage", "qc_tp")',
                    Precision: { type: 'fixed', fixedMapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.tp")' },
                },
                {
                    ID: 1304, Name: '期计量信息_本期完成金额', DataType: 'number', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.COMMON.Plus($PROJECT.REPORT.getProperty("stage", "contract_tp"),$PROJECT.REPORT.getProperty("stage", "qc_tp"),6)',
                    Precision: { type: 'fixed', fixedMapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.tp")' },
                },
                {
                    ID: 1305, Name: '期计量信息_截止上期合同金额', DataType: 'number', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("stage", "pre_contract_tp")',
                    Precision: { type: 'fixed', fixedMapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.tp")' },
                },
                {
                    ID: 1306, Name: '期计量信息_截止上期变更金额', DataType: 'number', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("stage", "pre_qc_tp")',
                    Precision: { type: 'fixed', fixedMapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.tp")' },
                },
                {
                    ID: 1307, Name: '期计量信息_截止上期完成金额', DataType: 'number', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.COMMON.Plus($PROJECT.REPORT.getProperty("stage", "pre_contract_tp"),$PROJECT.REPORT.getProperty("stage", "pre_qc_tp"),6)',
                    Precision: { type: 'fixed', fixedMapExpression: '$PROJECT.REPORT.getProperty("tender_info", "decimal.tp")' },
                },
                {
                    ID: 1308, Name: '期计量信息_审批状态', DataType: 'number', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("stage", "status")',
                },
                {
                    ID: 1309, Name: '期计量信息_审批次数', DataType: 'number', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("stage", "times")',
                },
                {
                    ID: 1310, Name: '期计量信息_开始截至日期', DataType: 'string', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.REPORT.getProperty("stage", "period")',
                },
                {
                    ID: 1311, Name: '期计量信息_开始日期', DataType: 'string', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.REPORT.getSplitProperty("stage", "period", " ~ ", 0, "")',
                },
                {
                    ID: 1312, Name: '期计量信息_截至日期', DataType: 'string', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.REPORT.getSplitProperty("stage", "period", " ~ ", 1, "")',
                },
                {
                    ID: 1399, Name: '期计量信息_空白', DataType: 'string', TableName: 'stage', descr: '',
                    mapExpression: '$PROJECT.REPORT.getBlank("stage", "")',
                },
            ],
        },
        {
            Name: '内存表',
            remark: '报表内存表，按指定方式预计算、拼接部分数据',
            items: [
                {
                    Name: '中间计量',
                    remark: '中间计量(台账及总量)内存表相关信息',
                    items: [
                        {
                            Name: "期-中间计量-台账-数据(mem_stage_im_tz)",
                            remark: "",
                            items: [
                                {
                                    ID: 1901,
                                    Name: "期-中间计量-台账-id(id)(id: 1901)",
                                    DataType: "int",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'id')"
                                },
                                {
                                    ID: 1902,
                                    Name: "期-中间计量-台账-台账id(lid)(id: 1902)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'lid')"
                                },
                                {
                                    ID: 1903,
                                    Name: "期-中间计量-台账-部位id(pid)(id: 1903)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'pid')"
                                },
                                {
                                    ID: 1904,
                                    Name: "期-中间计量-台账-编号(code)(id: 1904)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'code')"
                                },
                                {
                                    ID: 1905,
                                    Name: "期-中间计量-台账-本期金额(jl)(id: 1905)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'jl')"
                                },
                                {
                                    ID: 1906,
                                    Name: "期-中间计量-台账-本期合同金额(contract_jl)(id: 1906)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'contract_jl')"
                                },
                                {
                                    ID: 1907,
                                    Name: "期-中间计量-台账-本期变更金额(qc_jl)(id: 1907)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'qc_jl')"
                                },
                                {
                                    ID: 1908,
                                    Name: "期-中间计量-台账-桩号(peg)(id: 1908)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'peg')"
                                },
                                {
                                    ID: 1909,
                                    Name: "期-中间计量-台账-图册号(drawing_code)(id: 1909)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'drawing_code')"
                                },
                                {
                                    ID: 1910,
                                    Name: "期-中间计量-台账-部位(bw)(id: 1910)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'bw')"
                                },
                                {
                                    ID: 1911,
                                    Name: "期-中间计量-台账-细目(xm)(id: 1911)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'xm')"
                                },
                                {
                                    ID: 1912,
                                    Name: "期-中间计量-台账-勾选标记 - 勿用(check)(id: 1912)",
                                    DataType: "int",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'check')"
                                },
                                {
                                    ID: 1913,
                                    Name: "期-中间计量-台账-计算式说明(calc_memo)(id: 1913)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'calc_memo')"
                                },
                                {
                                    ID: 1914,
                                    Name: "期-中间计量-台账-变更令号(bgl_code)(id: 1914)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'bgl_code')"
                                },
                                {
                                    ID: 1915,
                                    Name: "期-中间计量-台账-变更图号(bgl_drawing_code)(id: 1915)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'bgl_drawing_code')"
                                },
                                {
                                    ID: 1916,
                                    Name: "期-中间计量-台账-中间计量表号(im_code)(id: 1916)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'im_code')"
                                },
                                {
                                    ID: 1917,
                                    Name: "期-中间计量-台账-凭证号(doc_code)(id: 1917)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'doc_code')"
                                },
                                {
                                    ID: 1918,
                                    Name: "期-中间计量-台账-草图(calc_img)(id: 1918)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'calc_img')",
                                    "isPic": true
                                },
                                {
                                    ID: 1919,
                                    Name: "期-中间计量-台账-截止上期 - 金额(pre_jl)(id: 1919)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'pre_jl')"
                                },
                                {
                                    ID: 1920,
                                    Name: "期-中间计量-台账-截止上期 - 合同金额(pre_contract_jl)(id: 1920)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'pre_contract_jl')"
                                },
                                {
                                    ID: 1921,
                                    Name: "期-中间计量-台账-截止上期 - 变更金额(pre_qc_jl)(id: 1921)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'pre_qc_jl')"
                                },
                                {
                                    ID: 1922,
                                    Name: "期-中间计量-台账-截止本期 - 金额(end_jl)(id: 1922)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'end_jl')"
                                },
                                {
                                    ID: 1923,
                                    Name: "期-中间计量-台账-截止本期 - 合同金额(end_contract_jl)(id: 1923)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'end_contract_jl')"
                                },
                                {
                                    ID: 1924,
                                    Name: "期-中间计量-台账-截止本期 - 变更金额(end_qc_jl)(id: 1924)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'end_qc_jl')"
                                },
                                {
                                    ID: 1925,
                                    Name: "期-中间计量-台账-位置(position)(id: 1925)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'position')"
                                },
                                {
                                    ID: 1926,
                                    Name: "期-中间计量-台账-计量单元(jldy)(id: 1926)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'jldy')"
                                },
                                {
                                    ID: 1927,
                                    Name: "期-中间计量-台账-草图备注(calc_img_remark)(id: 1927)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', 'calc_img_remark')"
                                },
                                {
                                    ID: 1999,
                                    Name: "期-中间计量-台账-空白(id: 1999)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz', '')"
                                }
                            ]
                        },
                        {
                            Name: "期-中间计量-台账清单-数据(mem_stage_im_tz_bills)",
                            remark: "",
                            items: [
                                {
                                    ID: 2001,
                                    Name: "期-中间计量-台账清单-中间计量id(imid)(id: 2001)",
                                    DataType: "int",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'imid')"
                                },
                                {
                                    ID: 2002,
                                    Name: "期-中间计量-台账清单-清单id(bid)(id: 2002)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'bid')"
                                },
                                {
                                    ID: 2003,
                                    Name: "期-中间计量-台账清单-清单编号(b_code)(id: 2003)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'b_code')"
                                },
                                {
                                    ID: 2004,
                                    Name: "期-中间计量-台账清单-名称(name)(id: 2004)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'name')"
                                },
                                {
                                    ID: 2005,
                                    Name: "期-中间计量-台账清单-单位(unit)(id: 2005)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'unit')"
                                },
                                {
                                    ID: 2006,
                                    Name: "期-中间计量-台账清单-单价(unit_price)(id: 2006)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'unit_price')"
                                },
                                {
                                    ID: 2007,
                                    Name: "期-中间计量-台账清单-本期数量(jl)(id: 2007)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'jl')"
                                },
                                {
                                    ID: 2008,
                                    Name: "期-中间计量-台账清单-本期合同数量(contract_jl)(id: 2008)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'contract_jl')"
                                },
                                {
                                    ID: 2009,
                                    Name: "期-中间计量-台账清单-本期变更数量(qc_jl)(id: 2009)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'qc_jl')"
                                },
                                {
                                    ID: 2010,
                                    Name: "期-中间计量-台账清单-中间计量表号(im_code)(id: 2010)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'im_code')"
                                },
                                {
                                    ID: 2011,
                                    Name: "期-中间计量-台账清单-截止上期 - 数量(pre_jl)(id: 2011)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'pre_jl')"
                                },
                                {
                                    ID: 2012,
                                    Name: "期-中间计量-台账清单-截止上期 - 合同数量(pre_contract_jl)(id: 2012)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'pre_contract_jl')"
                                },
                                {
                                    ID: 2013,
                                    Name: "期-中间计量-台账清单-截止上期 - 变更数量(pre_qc_jl)(id: 2013)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'pre_qc_jl')"
                                },
                                {
                                    ID: 2014,
                                    Name: "期-中间计量-台账清单-截止本期 - 数量(end_jl)(id: 2014)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'end_jl')"
                                },
                                {
                                    ID: 2015,
                                    Name: "期-中间计量-台账清单-截止本期 - 合同数量(end_contract_jl)(id: 2015)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'end_contract_jl')"
                                },
                                {
                                    ID: 2016,
                                    Name: "期-中间计量-台账清单-截止本期 - 变更数量(end_qc_jl)(id: 2016)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'end_qc_jl')"
                                },
                                {
                                    ID: 2017,
                                    Name: "期-中间计量-台账清单-本期金额(tp)(id: 2017)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'tp')"
                                },
                                {
                                    ID: 2018,
                                    Name: "期-中间计量-台账清单-本期合同金额(contract_tp)(id: 2018)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'contract_tp')"
                                },
                                {
                                    ID: 2019,
                                    Name: "期-中间计量-台账清单-本期变更金额(qc_tp)(id: 2019)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'qc_tp')"
                                },
                                {
                                    ID: 2020,
                                    Name: "期-中间计量-台账清单-截止上期 - 金额(pre_tp)(id: 2020)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'pre_tp')"
                                },
                                {
                                    ID: 2021,
                                    Name: "期-中间计量-台账清单-截止上期 - 合同金额(pre_contract_tp)(id: 2021)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'pre_contract_tp')"
                                },
                                {
                                    ID: 2022,
                                    Name: "期-中间计量-台账清单-截止上期 - 变更金额(pre_qc_tp)(id: 2022)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'pre_qc_tp')"
                                },
                                {
                                    ID: 2023,
                                    Name: "期-中间计量-台账清单-截止本期 - 金额(end_tp)(id: 2023)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'end_tp')"
                                },
                                {
                                    ID: 2024,
                                    Name: "期-中间计量-台账清单-截止本期 - 合同金额(end_contract_tp)(id: 2024)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'end_contract_tp')"
                                },
                                {
                                    ID: 2025,
                                    Name: "期-中间计量-台账清单-截止本期 - 变更金额(end_qc_tp)(id: 2025)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'end_qc_tp')"
                                },
                                {
                                    ID: 2026,
                                    Name: "期-中间计量-台账清单-台账数量(quantity)(id: 2026)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'quantity')"
                                },
                                {
                                    ID: 2027,
                                    Name: "期-中间计量-台账清单-台账金额(total_price)(id: 2027)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', 'total_price')"
                                },
                                {
                                    ID: 2099,
                                    Name: "期-中间计量-台账清单-空白(id: 2099)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_tz_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_tz_bills', '')"
                                }
                            ]
                        },
                        {
                            Name: "期-中间计量-总量-数据(mem_stage_im_zl)",
                            remark: "",
                            items: [
                                {
                                    ID: 2101,
                                    Name: "期-中间计量-总量-台账id(lid)(id: 2101)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'lid')"
                                },
                                {
                                    ID: 2102,
                                    Name: "期-中间计量-总量-部位id(pid)(id: 2102)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'pid')"
                                },
                                {
                                    ID: 2103,
                                    Name: "期-中间计量-总量-编号(code)(id: 2103)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'code')"
                                },
                                {
                                    ID: 2104,
                                    Name: "期-中间计量-总量-名称(name)(id: 2104)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'name')"
                                },
                                {
                                    ID: 2105,
                                    Name: "期-中间计量-总量-单位(unit)(id: 2105)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'unit')"
                                },
                                {
                                    ID: 2106,
                                    Name: "期-中间计量-总量-单价(unit_price)(id: 2106)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'unit_price')"
                                },
                                {
                                    ID: 2107,
                                    Name: "期-中间计量-总量-本期数量(jl)(id: 2107)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'jl')"
                                },
                                {
                                    ID: 2108,
                                    Name: "期-中间计量-总量-本期合同数量(contract_jl)(id: 2108)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'contract_jl')"
                                },
                                {
                                    ID: 2109,
                                    Name: "期-中间计量-总量-本期变更数量(qc_jl)(id: 2109)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'qc_jl')"
                                },
                                {
                                    ID: 2110,
                                    Name: "期-中间计量-总量-桩号(peg)(id: 2110)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'peg')"
                                },
                                {
                                    ID: 2111,
                                    Name: "期-中间计量-总量-图册号(drawing_code)(id: 2111)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'drawing_code')"
                                },
                                {
                                    ID: 2112,
                                    Name: "期-中间计量-总量-勾选标记 - 勿用(check)(id: 2112)",
                                    DataType: "int",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'check')"
                                },
                                {
                                    ID: 2113,
                                    Name: "期-中间计量-总量-部位(bw)(id: 2113)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'bw')"
                                },
                                {
                                    ID: 2114,
                                    Name: "期-中间计量-总量-细目(xm)(id: 2114)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'xm')"
                                },
                                {
                                    ID: 2115,
                                    Name: "期-中间计量-总量-凭证号(doc_code)(id: 2115)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'doc_code')"
                                },
                                {
                                    ID: 2116,
                                    Name: "期-中间计量-总量-计算式说明(calc_memo)(id: 2116)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'calc_memo')"
                                },
                                {
                                    ID: 2117,
                                    Name: "期-中间计量-总量-草图(calc_img)(id: 2117)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'calc_img')",
                                    "isPic": true
                                },
                                {
                                    ID: 2118,
                                    Name: "期-中间计量-总量-变更令号(bgl_code)(id: 2118)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'bgl_code')"
                                },
                                {
                                    ID: 2119,
                                    Name: "期-中间计量-总量-变更图号(bgl_drawing_code)(id: 2119)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'bgl_drawing_code')"
                                },
                                {
                                    ID: 2120,
                                    Name: "期-中间计量-总量-中间计量表号(im_code)(id: 2120)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'im_code')"
                                },
                                {
                                    ID: 2121,
                                    Name: "期-中间计量-总量-截止上期 - 数量(pre_jl)(id: 2121)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'pre_jl')"
                                },
                                {
                                    ID: 2122,
                                    Name: "期-中间计量-总量-截止上期 - 合同数量(pre_contract_jl)(id: 2122)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'pre_contract_jl')"
                                },
                                {
                                    ID: 2123,
                                    Name: "期-中间计量-总量-截止上期 - 变更数量(pre_qc_jl)(id: 2123)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'pre_qc_jl')"
                                },
                                {
                                    ID: 2124,
                                    Name: "期-中间计量-总量-截止本期 - 数量(end_jl)(id: 2124)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'end_jl')"
                                },
                                {
                                    ID: 2125,
                                    Name: "期-中间计量-总量-截止本期 - 合同数量(end_contract_jl)(id: 2125)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'end_contract_jl')"
                                },
                                {
                                    ID: 2126,
                                    Name: "期-中间计量-总量-截止本期 - 变更数量(end_qc_jl)(id: 2126)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'end_qc_jl')"
                                },
                                {
                                    ID: 2127,
                                    Name: "期-中间计量-总量-本期金额(tp)(id: 2127)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'tp')"
                                },
                                {
                                    ID: 2128,
                                    Name: "期-中间计量-总量-本期合同金额(contract_tp)(id: 2128)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'contract_tp')"
                                },
                                {
                                    ID: 2129,
                                    Name: "期-中间计量-总量-本期变更金额(qc_tp)(id: 2129)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'qc_tp')"
                                },
                                {
                                    ID: 2130,
                                    Name: "期-中间计量-总量-截止上期 - 金额(pre_tp)(id: 2130)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'pre_tp')"
                                },
                                {
                                    ID: 2131,
                                    Name: "期-中间计量-总量-截止上期 - 合同金额(pre_contract_tp)(id: 2131)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'pre_contract_tp')"
                                },
                                {
                                    ID: 2132,
                                    Name: "期-中间计量-总量-截止上期 - 变更金额(pre_qc_tp)(id: 2132)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'pre_qc_tp')"
                                },
                                {
                                    ID: 2133,
                                    Name: "期-中间计量-总量-截止本期 - 金额(end_tp)(id: 2133)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'end_tp')"
                                },
                                {
                                    ID: 2134,
                                    Name: "期-中间计量-总量-截止本期 - 合同金额(end_contract_tp)(id: 2134)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'end_contract_tp')"
                                },
                                {
                                    ID: 2135,
                                    Name: "期-中间计量-总量-截止本期 - 变更金额(end_qc_tp)(id: 2135)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'end_qc_tp')"
                                },
                                {
                                    ID: 2136,
                                    Name: "期-中间计量-总量-台账数量(quantity)(id: 2136)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'quantity')"
                                },
                                {
                                    ID: 2137,
                                    Name: "期-中间计量-总量-台账金额(total_price)(id: 2137)",
                                    DataType: "currency",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'total_price')"
                                },
                                {
                                    ID: 2138,
                                    Name: "期-中间计量-总量-位置(position)(id: 2138)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'position')"
                                },
                                {
                                    ID: 2139,
                                    Name: "期-中间计量-总量-计量单元(jldy)(id: 2139)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'jldy')"
                                },
                                {
                                    ID: 2140,
                                    Name: "期-中间计量-总量-草图备注(calc_img_remark)(id: 2140)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', 'calc_img_remark')"
                                },
                                {
                                    ID: 2199,
                                    Name: "期-中间计量-总量-空白(id: 2199)",
                                    DataType: "string",
                                    TableName: "mem_stage_im_zl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_im_zl', '')"
                                }
                            ]
                        },
                    ],
                },
                {
                    Name: "工程进度 数据表(mem_month_progress)",
                    remark: "",
                    items: [
                        {
                            ID: 2201,
                            Name: "工程进度-计量年月(month)(id: 2201)",
                            DataType: "string",
                            TableName: "mem_month_progress",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_month_progress', 'month')"
                        },
                        {
                            ID: 2202,
                            Name: "工程进度-本月计量(tp)(id: 2202)",
                            DataType: "currency",
                            TableName: "mem_month_progress",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_month_progress', 'tp')"
                        },
                        {
                            ID: 2203,
                            Name: "工程进度-本月完成度(ratio)(id: 2203)",
                            DataType: "double",
                            TableName: "mem_month_progress",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_month_progress', 'ratio')"
                        },
                        {
                            ID: 2204,
                            Name: "工程进度-累计计量(end_tp)(id: 2204)",
                            DataType: "currency",
                            TableName: "mem_month_progress",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_month_progress', 'end_tp')"
                        },
                        {
                            ID: 2205,
                            Name: "工程进度-累计完成度(end_ratio)(id: 2205)",
                            DataType: "double",
                            TableName: "mem_month_progress",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_month_progress', 'end_ratio')"
                        },
                        {
                            ID: 2299,
                            Name: "工程进度-空白(id: 2299)",
                            DataType: "string",
                            TableName: "mem_month_progress",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_month_progress', '')"
                        }
                    ]
                },
                {
                    Name: '期数据',
                    remark: '拼接主数据和期数据',
                    items: [
                        {
                            Name: "期-清单 数据表(mem_stage_bills)",
                            remark: "",
                            items: [
                                {
                                    ID: 2501,
                                    Name: "期-清单-台账ID(id)(id: 2501)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'id')"
                                },
                                {
                                    ID: 2502,
                                    Name: "期-清单-标段ID(tender_id)(id: 2502)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'tender_id')"
                                },
                                {
                                    ID: 2503,
                                    Name: "期-清单-树结构-ID(ledger_id)(id: 2503)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'ledger_id')"
                                },
                                {
                                    ID: 2504,
                                    Name: "期-清单-树结构-父项ID(ledger_pid)(id: 2504)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'ledger_pid')"
                                },
                                {
                                    ID: 2505,
                                    Name: "期-清单-树结构-层级(level)(id: 2505)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'level')"
                                },
                                {
                                    ID: 2506,
                                    Name: "期-清单-树结构-同层排序(order)(id: 2506)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'order')"
                                },
                                {
                                    ID: 2507,
                                    Name: "期-清单-树结构-完整路径(full_path)(id: 2507)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'full_path')"
                                },
                                {
                                    ID: 2508,
                                    Name: "期-清单-树结构-是否子项(is_leaf)(id: 2508)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'is_leaf')"
                                },
                                {
                                    ID: 2509,
                                    Name: "期-清单-项目节编号(code)(id: 2509)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'code')"
                                },
                                {
                                    ID: 2510,
                                    Name: "期-清单-清单编号(b_code)(id: 2510)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'b_code')"
                                },
                                {
                                    ID: 2511,
                                    Name: "期-清单-名称(name)(id: 2511)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'name')"
                                },
                                {
                                    ID: 2512,
                                    Name: "期-清单-单位(unit)(id: 2512)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'unit')"
                                },
                                {
                                    ID: 2513,
                                    Name: "期-清单-单价(unit_price)(id: 2513)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'unit_price')"
                                },
                                {
                                    ID: 2514,
                                    Name: "期-清单-签约-数量(deal_qty)(id: 2514)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'deal_qty')"
                                },
                                {
                                    ID: 2515,
                                    Name: "期-清单-签约-金额(deal_tp)(id: 2515)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'deal_tp')"
                                },
                                {
                                    ID: 2516,
                                    Name: "期-清单-施工复核-数量(sgfh_qty)(id: 2516)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'sgfh_qty')"
                                },
                                {
                                    ID: 2517,
                                    Name: "期-清单-施工复核-金额(sgfh_tp)(id: 2517)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'sgfh_tp')"
                                },
                                {
                                    ID: 2518,
                                    Name: "期-清单-设计错漏-数量(sjcl_qty)(id: 2518)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'sjcl_qty')"
                                },
                                {
                                    ID: 2519,
                                    Name: "期-清单-设计错漏-金额(sjcl_tp)(id: 2519)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'sjcl_tp')"
                                },
                                {
                                    ID: 2520,
                                    Name: "期-清单-其他错漏-数量(qtcl_qty)(id: 2520)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'qtcl_qty')"
                                },
                                {
                                    ID: 2521,
                                    Name: "期-清单-其他错漏-金额(qtcl_tp)(id: 2521)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'qtcl_tp')"
                                },
                                {
                                    ID: 2522,
                                    Name: "期-清单-台账-数量(quantity)(id: 2522)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'quantity')"
                                },
                                {
                                    ID: 2523,
                                    Name: "期-清单-台账-金额(total_price)(id: 2523)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'total_price')"
                                },
                                {
                                    ID: 2524,
                                    Name: "期-清单-项目节-数量1(dgn_qty1)(id: 2524)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'dgn_qty1')"
                                },
                                {
                                    ID: 2525,
                                    Name: "期-清单-项目节-数量2(dgn_qty2)(id: 2525)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'dgn_qty2')"
                                },
                                {
                                    ID: 2526,
                                    Name: "期-清单-图册号(drawing_code)(id: 2526)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'drawing_code')"
                                },
                                {
                                    ID: 2527,
                                    Name: "期-清单-备注(memo)(id: 2527)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'memo')"
                                },
                                {
                                    ID: 2528,
                                    Name: "期-清单-节点类型(node_type)(id: 2528)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'node_type')"
                                },
                                {
                                    ID: 2529,
                                    Name: "期-清单-总额计量(is_tp)(id: 2529)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'is_tp')"
                                },
                                {
                                    ID: 2530,
                                    Name: "期-清单-本期-合同-数量(contract_qty)(id: 2530)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'contract_qty')"
                                },
                                {
                                    ID: 2531,
                                    Name: "期-清单-本期-合同-金额(contract_tp)(id: 2531)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'contract_tp')"
                                },
                                {
                                    ID: 2532,
                                    Name: "期-清单-本期-数量变更-数量(qc_qty)(id: 2532)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'qc_qty')"
                                },
                                {
                                    ID: 2533,
                                    Name: "期-清单-本期-数量变更-金额(qc_tp)(id: 2533)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'qc_tp')"
                                },
                                {
                                    ID: 2534,
                                    Name: "期-清单-本期-完成-数量(gather_qty)(id: 2534)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'gather_qty')"
                                },
                                {
                                    ID: 2535,
                                    Name: "期-清单-本期-完成-金额(gather_tp)(id: 2535)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'gather_tp')"
                                },
                                {
                                    ID: 2536,
                                    Name: "期-清单-本期批注(postil)(id: 2536)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'postil')"
                                },
                                {
                                    ID: 2537,
                                    Name: "期-清单-截止上期-合同-数量(pre_contract_qty)(id: 2537)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'pre_contract_qty')"
                                },
                                {
                                    ID: 2538,
                                    Name: "期-清单-截止上期-合同-金额(pre_contract_tp)(id: 2538)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'pre_contract_tp')"
                                },
                                {
                                    ID: 2539,
                                    Name: "期-清单-截止上期-数量变更-数量(pre_qc_qty)(id: 2539)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'pre_qc_qty')"
                                },
                                {
                                    ID: 2540,
                                    Name: "期-清单-截止上期-数量变更-金额(pre_qc_tp)(id: 2540)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'pre_qc_tp')"
                                },
                                {
                                    ID: 2541,
                                    Name: "期-清单-截止上期-完成-数量(pre_gather_qty)(id: 2541)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'pre_gather_qty')"
                                },
                                {
                                    ID: 2542,
                                    Name: "期-清单-截止上期-完成-金额(pre_gather_tp)(id: 2542)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'pre_gather_tp')"
                                },
                                {
                                    ID: 2543,
                                    Name: "期-清单-截止本期-合同-数量(end_contract_qty)(id: 2543)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'end_contract_qty')"
                                },
                                {
                                    ID: 2544,
                                    Name: "期-清单-截止本期-合同-金额(end_contract_tp)(id: 2544)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'end_contract_tp')"
                                },
                                {
                                    ID: 2545,
                                    Name: "期-清单-截止本期-数量变更-数量(end_qc_qty)(id: 2545)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'end_qc_qty')"
                                },
                                {
                                    ID: 2546,
                                    Name: "期-清单-截止本期-数量变更-金额(end_qc_tp)(id: 2546)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'end_qc_tp')"
                                },
                                {
                                    ID: 2547,
                                    Name: "期-清单-截止本期-完成-数量(end_gather_qty)(id: 2547)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'end_gather_qty')"
                                },
                                {
                                    ID: 2548,
                                    Name: "期-清单-截止本期-完成-金额(end_gather_tp)(id: 2548)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'end_gather_tp')"
                                },
                                {
                                    ID: 2549,
                                    Name: "期-清单-(台账 + 截止本期变更)-金额(final_tp)(id: 2549)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'final_tp')"
                                },
                                {
                                    ID: 2550,
                                    Name: "期-清单-截止本期完成率(%)(final_ratio)(id: 2550)",
                                    DataType: "double",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'final_ratio')"
                                },
                                {
                                    ID: 2551,
                                    Name: "期-清单-本期-数量变更-变更令(qc_bgl_code)(id: 2551)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'qc_bgl_code')"
                                },
                                {
                                    ID: 2552,
                                    Name: "期-清单-章节编号(chapter)(id: 2552)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'chapter')"
                                },
                                {
                                    ID: 2553,
                                    Name: "期-清单-预留扩展字段_1(ex_value1)(id: 2553)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'ex_value1')"
                                },
                                {
                                    ID: 2554,
                                    Name: "期-清单-预留扩展字段_2(ex_value1)(id: 2554)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'ex_value1')"
                                },
                                {
                                    ID: 2555,
                                    Name: "期-清单-最底层项目节id(leaf_xmj_id)(id: 2555)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'leaf_xmj_id')"
                                },
                                {
                                    ID: 2556,
                                    Name: "期-清单-施工复核-公式(sgfh_expr)(id: 2556)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'sgfh_expr')"
                                },
                                {
                                    ID: 2557,
                                    Name: "期-清单-设计错漏-公式(sjcl_expr)(id: 2557)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'sjcl_expr')"
                                },
                                {
                                    ID: 2558,
                                    Name: "期-清单-其他错漏-公式(qtcl_expr)(id: 2558)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'qtcl_expr')"
                                },
                                {
                                    ID: 2559,
                                    Name: "期-清单-本期-合同-公式(contract_expr)(id: 2559)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'contract_expr')"
                                },
                                {
                                    ID: 2560,
                                    Name: "期-清单-合同-设计数量1(deal_dgn_qty1)(id: 2560)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'deal_dgn_qty1')"
                                },
                                {
                                    ID: 2561,
                                    Name: "期-清单-合同-设计数量2(deal_dgn_qty2)(id: 2561)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'deal_dgn_qty2')"
                                },
                                {
                                    ID: 2562,
                                    Name: "期-清单-变更-设计数量1(c_dgn_qty1)(id: 2562)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'c_dgn_qty1')"
                                },
                                {
                                    ID: 2563,
                                    Name: "期-清单-变更-设计数量2(c_dgn_qty2)(id: 2563)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', 'c_dgn_qty2')"
                                },
                                {
                                    ID: 2599,
                                    Name: "期-清单-空白(id: 2599)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills', '')"
                                }
                            ]
                        },
                        {
                            Name: "期-清单-全参与人 数据表(mem_stage_bills_compare)",
                            remark: "",
                            items: [
                                {
                                    ID: 2601,
                                    Name: "期-清单-全参与人-台账ID(id)(id: 2601)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'id')"
                                },
                                {
                                    ID: 2602,
                                    Name: "期-清单-全参与人-标段ID(tender_id)(id: 2602)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'tender_id')"
                                },
                                {
                                    ID: 2603,
                                    Name: "期-清单-全参与人-树结构-ID(ledger_id)(id: 2603)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'ledger_id')"
                                },
                                {
                                    ID: 2604,
                                    Name: "期-清单-全参与人-树结构-父项ID(ledger_pid)(id: 2604)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'ledger_pid')"
                                },
                                {
                                    ID: 2605,
                                    Name: "期-清单-全参与人-树结构-层级(level)(id: 2605)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'level')"
                                },
                                {
                                    ID: 2606,
                                    Name: "期-清单-全参与人-树结构-同层排序(order)(id: 2606)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'order')"
                                },
                                {
                                    ID: 2607,
                                    Name: "期-清单-全参与人-树结构-完整路径(full_path)(id: 2607)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'full_path')"
                                },
                                {
                                    ID: 2608,
                                    Name: "期-清单-全参与人-树结构-是否子项(is_leaf)(id: 2608)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'is_leaf')"
                                },
                                {
                                    ID: 2609,
                                    Name: "期-清单-全参与人-项目节编号(code)(id: 2609)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'code')"
                                },
                                {
                                    ID: 2610,
                                    Name: "期-清单-全参与人-清单编号(b_code)(id: 2610)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'b_code')"
                                },
                                {
                                    ID: 2611,
                                    Name: "期-清单-全参与人-名称(name)(id: 2611)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'name')"
                                },
                                {
                                    ID: 2612,
                                    Name: "期-清单-全参与人-单位(unit)(id: 2612)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'unit')"
                                },
                                {
                                    ID: 2613,
                                    Name: "期-清单-全参与人-单价(unit_price)(id: 2613)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'unit_price')"
                                },
                                {
                                    ID: 2614,
                                    Name: "期-清单-全参与人-签约-数量(deal_qty)(id: 2614)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'deal_qty')"
                                },
                                {
                                    ID: 2615,
                                    Name: "期-清单-全参与人-签约-金额(deal_tp)(id: 2615)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'deal_tp')"
                                },
                                {
                                    ID: 2616,
                                    Name: "期-清单-全参与人-施工复核-数量(sgfh_qty)(id: 2616)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'sgfh_qty')"
                                },
                                {
                                    ID: 2617,
                                    Name: "期-清单-全参与人-施工复核-金额(sgfh_tp)(id: 2617)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'sgfh_tp')"
                                },
                                {
                                    ID: 2618,
                                    Name: "期-清单-全参与人-设计错漏-数量(sjcl_qty)(id: 2618)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'sjcl_qty')"
                                },
                                {
                                    ID: 2619,
                                    Name: "期-清单-全参与人-设计错漏-金额(sjcl_tp)(id: 2619)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'sjcl_tp')"
                                },
                                {
                                    ID: 2620,
                                    Name: "期-清单-全参与人-其他错漏-数量(qtcl_qty)(id: 2620)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'qtcl_qty')"
                                },
                                {
                                    ID: 2621,
                                    Name: "期-清单-全参与人-其他错漏-金额(qtcl_tp)(id: 2621)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'qtcl_tp')"
                                },
                                {
                                    ID: 2622,
                                    Name: "期-清单-全参与人-台账-数量(quantity)(id: 2622)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'quantity')"
                                },
                                {
                                    ID: 2623,
                                    Name: "期-清单-全参与人-台账-金额(total_price)(id: 2623)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'total_price')"
                                },
                                {
                                    ID: 2624,
                                    Name: "期-清单-全参与人-项目节-数量1(dgn_qty1)(id: 2624)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'dgn_qty1')"
                                },
                                {
                                    ID: 2625,
                                    Name: "期-清单-全参与人-项目节-数量2(dgn_qty2)(id: 2625)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'dgn_qty2')"
                                },
                                {
                                    ID: 2626,
                                    Name: "期-清单-全参与人-图册号(drawing_code)(id: 2626)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'drawing_code')"
                                },
                                {
                                    ID: 2627,
                                    Name: "期-清单-全参与人-备注(memo)(id: 2627)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'memo')"
                                },
                                {
                                    ID: 2628,
                                    Name: "期-清单-全参与人-节点类型(node_type)(id: 2628)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'node_type')"
                                },
                                {
                                    ID: 2629,
                                    Name: "期-清单-全参与人-总额计量(is_tp)(id: 2629)",
                                    DataType: "int",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'is_tp')"
                                },
                                {
                                    ID: 2630,
                                    Name: "期-清单-全参与人-截止上期-合同-数量(pre_contract_qty)(id: 2630)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'pre_contract_qty')"
                                },
                                {
                                    ID: 2631,
                                    Name: "期-清单-全参与人-截止上期-合同-金额(pre_contract_tp)(id: 2631)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'pre_contract_tp')"
                                },
                                {
                                    ID: 2632,
                                    Name: "期-清单-全参与人-截止上期-数量变更-数量(pre_qc_qty)(id: 2632)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'pre_qc_qty')"
                                },
                                {
                                    ID: 2633,
                                    Name: "期-清单-全参与人-截止上期-数量变更-金额(pre_qc_tp)(id: 2633)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'pre_qc_tp')"
                                },
                                {
                                    ID: 2634,
                                    Name: "期-清单-全参与人-截止上期-完成-数量(pre_gather_qty)(id: 2634)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'pre_gather_qty')"
                                },
                                {
                                    ID: 2635,
                                    Name: "期-清单-全参与人-截止上期-完成-金额(pre_gather_tp)(id: 2635)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'pre_gather_tp')"
                                },
                                {
                                    ID: 2636,
                                    Name: "期-清单-全参与人-本期-合同-数量_0(r0_contract_qty)(id: 2636)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r0_contract_qty')"
                                },
                                {
                                    ID: 2637,
                                    Name: "期-清单-全参与人-本期-合同-金额_0(r0_contract_tp)(id: 2637)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r0_contract_tp')"
                                },
                                {
                                    ID: 2638,
                                    Name: "期-清单-全参与人-本期-数量变更-数量_0(r0_qc_qty)(id: 2638)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r0_qc_qty')"
                                },
                                {
                                    ID: 2639,
                                    Name: "期-清单-全参与人-本期-数量变更-金额_0(r0_qc_tp)(id: 2639)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r0_qc_tp')"
                                },
                                {
                                    ID: 2640,
                                    Name: "期-清单-全参与人-本期-完成-数量_0(r0_gather_qty)(id: 2640)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r0_gather_qty')"
                                },
                                {
                                    ID: 2641,
                                    Name: "期-清单-全参与人-本期-完成-金额_0(r0_gather_tp)(id: 2641)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r0_gather_tp')"
                                },
                                {
                                    ID: 2642,
                                    Name: "期-清单-全参与人-本期-合同-数量_1(r1_contract_qty)(id: 2642)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r1_contract_qty')"
                                },
                                {
                                    ID: 2643,
                                    Name: "期-清单-全参与人-本期-合同-金额_1(r1_contract_tp)(id: 2643)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r1_contract_tp')"
                                },
                                {
                                    ID: 2644,
                                    Name: "期-清单-全参与人-本期-数量变更-数量_1(r1_qc_qty)(id: 2644)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r1_qc_qty')"
                                },
                                {
                                    ID: 2645,
                                    Name: "期-清单-全参与人-本期-数量变更-金额_1(r1_qc_tp)(id: 2645)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r1_qc_tp')"
                                },
                                {
                                    ID: 2646,
                                    Name: "期-清单-全参与人-本期-完成-数量_1(r1_gather_qty)(id: 2646)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r1_gather_qty')"
                                },
                                {
                                    ID: 2647,
                                    Name: "期-清单-全参与人-本期-完成-金额_1(r1_gather_tp)(id: 2647)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r1_gather_tp')"
                                },
                                {
                                    ID: 2648,
                                    Name: "期-清单-全参与人-本期-合同-数量_2(r2_contract_qty)(id: 2648)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r2_contract_qty')"
                                },
                                {
                                    ID: 2649,
                                    Name: "期-清单-全参与人-本期-合同-金额_2(r2_contract_tp)(id: 2649)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r2_contract_tp')"
                                },
                                {
                                    ID: 2650,
                                    Name: "期-清单-全参与人-本期-数量变更-数量_2(r2_qc_qty)(id: 2650)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r2_qc_qty')"
                                },
                                {
                                    ID: 2651,
                                    Name: "期-清单-全参与人-本期-数量变更-金额_2(r2_qc_tp)(id: 2651)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r2_qc_tp')"
                                },
                                {
                                    ID: 2652,
                                    Name: "期-清单-全参与人-本期-完成-数量_2(r2_gather_qty)(id: 2652)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r2_gather_qty')"
                                },
                                {
                                    ID: 2653,
                                    Name: "期-清单-全参与人-本期-完成-金额_2(r2_gather_tp)(id: 2653)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r2_gather_tp')"
                                },
                                {
                                    ID: 2654,
                                    Name: "期-清单-全参与人-本期-合同-数量_3(r3_contract_qty)(id: 2654)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r3_contract_qty')"
                                },
                                {
                                    ID: 2655,
                                    Name: "期-清单-全参与人-本期-合同-金额_3(r3_contract_tp)(id: 2655)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r3_contract_tp')"
                                },
                                {
                                    ID: 2656,
                                    Name: "期-清单-全参与人-本期-数量变更-数量_3(r3_qc_qty)(id: 2656)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r3_qc_qty')"
                                },
                                {
                                    ID: 2657,
                                    Name: "期-清单-全参与人-本期-数量变更-金额_3(r3_qc_tp)(id: 2657)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r3_qc_tp')"
                                },
                                {
                                    ID: 2658,
                                    Name: "期-清单-全参与人-本期-完成-数量_3(r3_gather_qty)(id: 2658)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r3_gather_qty')"
                                },
                                {
                                    ID: 2659,
                                    Name: "期-清单-全参与人-本期-完成-金额_3(r3_gather_tp)(id: 2659)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r3_gather_tp')"
                                },
                                {
                                    ID: 2660,
                                    Name: "期-清单-全参与人-本期-合同-数量_4(r4_contract_qty)(id: 2660)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r4_contract_qty')"
                                },
                                {
                                    ID: 2661,
                                    Name: "期-清单-全参与人-本期-合同-金额_4(r4_contract_tp)(id: 2661)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r4_contract_tp')"
                                },
                                {
                                    ID: 2662,
                                    Name: "期-清单-全参与人-本期-数量变更-数量_4(r4_qc_qty)(id: 2662)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r4_qc_qty')"
                                },
                                {
                                    ID: 2663,
                                    Name: "期-清单-全参与人-本期-数量变更-金额_4(r4_qc_tp)(id: 2663)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r4_qc_tp')"
                                },
                                {
                                    ID: 2664,
                                    Name: "期-清单-全参与人-本期-完成-数量_4(r4_gather_qty)(id: 2664)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r4_gather_qty')"
                                },
                                {
                                    ID: 2665,
                                    Name: "期-清单-全参与人-本期-完成-金额_4(r4_gather_tp)(id: 2665)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r4_gather_tp')"
                                },
                                {
                                    ID: 2666,
                                    Name: "期-清单-全参与人-本期-合同-数量_5(r5_contract_qty)(id: 2666)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r5_contract_qty')"
                                },
                                {
                                    ID: 2667,
                                    Name: "期-清单-全参与人-本期-合同-金额_5(r5_contract_tp)(id: 2667)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r5_contract_tp')"
                                },
                                {
                                    ID: 2668,
                                    Name: "期-清单-全参与人-本期-数量变更-数量_5(r5_qc_qty)(id: 2668)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r5_qc_qty')"
                                },
                                {
                                    ID: 2669,
                                    Name: "期-清单-全参与人-本期-数量变更-金额_5(r5_qc_tp)(id: 2669)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r5_qc_tp')"
                                },
                                {
                                    ID: 2670,
                                    Name: "期-清单-全参与人-本期-完成-数量_5(r5_gather_qty)(id: 2670)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r5_gather_qty')"
                                },
                                {
                                    ID: 2671,
                                    Name: "期-清单-全参与人-本期-完成-金额_5(r5_gather_tp)(id: 2671)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r5_gather_tp')"
                                },
                                {
                                    ID: 2672,
                                    Name: "期-清单-全参与人-本期-合同-数量_6(r6_contract_qty)(id: 2672)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r6_contract_qty')"
                                },
                                {
                                    ID: 2673,
                                    Name: "期-清单-全参与人-本期-合同-金额_6(r6_contract_tp)(id: 2673)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r6_contract_tp')"
                                },
                                {
                                    ID: 2674,
                                    Name: "期-清单-全参与人-本期-数量变更-数量_6(r6_qc_qty)(id: 2674)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r6_qc_qty')"
                                },
                                {
                                    ID: 2675,
                                    Name: "期-清单-全参与人-本期-数量变更-金额_6(r6_qc_tp)(id: 2675)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r6_qc_tp')"
                                },
                                {
                                    ID: 2676,
                                    Name: "期-清单-全参与人-本期-完成-数量_6(r6_gather_qty)(id: 2676)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r6_gather_qty')"
                                },
                                {
                                    ID: 2677,
                                    Name: "期-清单-全参与人-本期-完成-金额_6(r6_gather_tp)(id: 2677)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r6_gather_tp')"
                                },
                                {
                                    ID: 2678,
                                    Name: "期-清单-全参与人-本期-合同-数量_7(r7_contract_qty)(id: 2678)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r7_contract_qty')"
                                },
                                {
                                    ID: 2679,
                                    Name: "期-清单-全参与人-本期-合同-金额_7(r7_contract_tp)(id: 2679)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r7_contract_tp')"
                                },
                                {
                                    ID: 2680,
                                    Name: "期-清单-全参与人-本期-数量变更-数量_7(r7_qc_qty)(id: 2680)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r7_qc_qty')"
                                },
                                {
                                    ID: 2681,
                                    Name: "期-清单-全参与人-本期-数量变更-金额_7(r7_qc_tp)(id: 2681)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r7_qc_tp')"
                                },
                                {
                                    ID: 2682,
                                    Name: "期-清单-全参与人-本期-完成-数量_7(r7_gather_qty)(id: 2682)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r7_gather_qty')"
                                },
                                {
                                    ID: 2683,
                                    Name: "期-清单-全参与人-本期-完成-金额_7(r7_gather_tp)(id: 2683)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r7_gather_tp')"
                                },
                                {
                                    ID: 2684,
                                    Name: "期-清单-全参与人-本期-合同-数量_8(r8_contract_qty)(id: 2684)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r8_contract_qty')"
                                },
                                {
                                    ID: 2685,
                                    Name: "期-清单-全参与人-本期-合同-金额_8(r8_contract_tp)(id: 2685)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r8_contract_tp')"
                                },
                                {
                                    ID: 2686,
                                    Name: "期-清单-全参与人-本期-数量变更-数量_8(r8_qc_qty)(id: 2686)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r8_qc_qty')"
                                },
                                {
                                    ID: 2687,
                                    Name: "期-清单-全参与人-本期-数量变更-金额_8(r8_qc_tp)(id: 2687)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r8_qc_tp')"
                                },
                                {
                                    ID: 2688,
                                    Name: "期-清单-全参与人-本期-完成-数量_8(r8_gather_qty)(id: 2688)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r8_gather_qty')"
                                },
                                {
                                    ID: 2689,
                                    Name: "期-清单-全参与人-本期-完成-金额_8(r8_gather_tp)(id: 2689)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r8_gather_tp')"
                                },
                                {
                                    ID: 2690,
                                    Name: "期-清单-全参与人-本期-合同-数量_9(r9_contract_qty)(id: 2690)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r9_contract_qty')"
                                },
                                {
                                    ID: 2691,
                                    Name: "期-清单-全参与人-本期-合同-金额_9(r9_contract_tp)(id: 2691)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r9_contract_tp')"
                                },
                                {
                                    ID: 2692,
                                    Name: "期-清单-全参与人-本期-数量变更-数量_9(r9_qc_qty)(id: 2692)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r9_qc_qty')"
                                },
                                {
                                    ID: 2693,
                                    Name: "期-清单-全参与人-本期-数量变更-金额_9(r9_qc_tp)(id: 2693)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r9_qc_tp')"
                                },
                                {
                                    ID: 2694,
                                    Name: "期-清单-全参与人-本期-完成-数量_9(r9_gather_qty)(id: 2694)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r9_gather_qty')"
                                },
                                {
                                    ID: 2695,
                                    Name: "期-清单-全参与人-本期-完成-金额_9(r9_gather_tp)(id: 2695)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'r9_gather_tp')"
                                },
                                {
                                    ID: 2696,
                                    Name: "期-清单-全参与人-章节编号(chapter)(id: 2696)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'chapter')"
                                },
                                {
                                    ID: 2697,
                                    Name: "期-清单-全参与人-最底层项目节id(leaf_xmj_id)(id: 2697)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', 'leaf_xmj_id')"
                                },
                                {
                                    ID: 2699,
                                    Name: "期-清单-全参与人-空白(id: 2699)",
                                    DataType: "string",
                                    TableName: "mem_stage_bills_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bills_compare', '')"
                                }
                            ]
                        },
                        {
                            Name: "期-计量单元(mem_stage_pos)",
                            remark: "",
                            items: [
                                {
                                    ID: 3401,
                                    Name: "期-计量单元-id(id)(id: 3401)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'id')"
                                },
                                {
                                    ID: 3402,
                                    Name: "期-计量单元-所属标段id(tid)(id: 3402)",
                                    DataType: "int",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'tid')"
                                },
                                {
                                    ID: 3403,
                                    Name: "期-计量单元-所属清单id(lid)(id: 3403)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'lid')"
                                },
                                {
                                    ID: 3404,
                                    Name: "期-计量单元-名称(name)(id: 3404)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'name')"
                                },
                                {
                                    ID: 3405,
                                    Name: "期-计量单元-位置(position)(id: 3405)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'position')"
                                },
                                {
                                    ID: 3406,
                                    Name: "期-计量单元-施工复核-数量(sgfh_qty)(id: 3406)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'sgfh_qty')"
                                },
                                {
                                    ID: 3407,
                                    Name: "期-计量单元-其他错漏-数量(qtcl_qty)(id: 3407)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'qtcl_qty')"
                                },
                                {
                                    ID: 3408,
                                    Name: "期-计量单元-设计错漏-数量(sjcl_qty)(id: 3408)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'sjcl_qty')"
                                },
                                {
                                    ID: 3409,
                                    Name: "期-计量单元-台账-数量(quantity)(id: 3409)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'quantity')"
                                },
                                {
                                    ID: 3410,
                                    Name: "期-计量单元-图号(drawing_code)(id: 3410)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'drawing_code')"
                                },
                                {
                                    ID: 3411,
                                    Name: "期-计量单元-排序(p_order)(id: 3411)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'p_order')"
                                },
                                {
                                    ID: 3412,
                                    Name: "期-计量单元-本期-合同计量-数量(contract_qty)(id: 3412)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'contract_qty')"
                                },
                                {
                                    ID: 3413,
                                    Name: "期-计量单元-本期-数量变更-数量(qc_qty)(id: 3413)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'qc_qty')"
                                },
                                {
                                    ID: 3414,
                                    Name: "期-计量单元-本期-数量变更-变更令(qc_bgl_code)(id: 3414)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'qc_bgl_code')"
                                },
                                {
                                    ID: 3415,
                                    Name: "期-计量单元-本期-完成计量-数量(gather_qty)(id: 3415)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'gather_qty')"
                                },
                                {
                                    ID: 3416,
                                    Name: "期-计量单元-本期批注(postil)(id: 3416)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'postil')"
                                },
                                {
                                    ID: 3417,
                                    Name: "期-计量单元-截止上期-合同计量-数量(pre_contract_qty)(id: 3417)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'pre_contract_qty')"
                                },
                                {
                                    ID: 3418,
                                    Name: "期-计量单元-截止上期-数量变更-数量(pre_qc_qty)(id: 3418)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'pre_qc_qty')"
                                },
                                {
                                    ID: 3419,
                                    Name: "期-计量单元-截止上期-完成计量-数量(pre_gather_qty)(id: 3419)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'pre_gather_qty')"
                                },
                                {
                                    ID: 3420,
                                    Name: "期-计量单元-截止本期-合同计量-数量(end_contract_qty)(id: 3420)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'end_contract_qty')"
                                },
                                {
                                    ID: 3421,
                                    Name: "期-计量单元-截止本期-数量变更-数量(end_qc_qty)(id: 3421)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'end_qc_qty')"
                                },
                                {
                                    ID: 3422,
                                    Name: "期-计量单元-截止本期-完成计量-数量(end_gather_qty)(id: 3422)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'end_gather_qty')"
                                },
                                {
                                    ID: 3423,
                                    Name: "期-计量单元-截止本期-完成率(final_ratio)(id: 3423)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'final_ratio')"
                                },
                                {
                                    ID: 3424,
                                    Name: "期-计量单元-施工复核-公式(sgfh_expr)(id: 3424)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'sgfh_expr')"
                                },
                                {
                                    ID: 3425,
                                    Name: "期-计量单元-设计错漏-公式(sjcl_expr)(id: 3425)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'sjcl_expr')"
                                },
                                {
                                    ID: 3426,
                                    Name: "期-计量单元-其他错漏-公式(qtcl_expr)(id: 3426)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'qtcl_expr')"
                                },
                                {
                                    ID: 3427,
                                    Name: "期-计量单元-本期-合同-公式(contract_expr)(id: 3427)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', 'contract_expr')"
                                },
                                {
                                    ID: 3499,
                                    Name: "期-计量单元-空白(id: 3499)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos', '')"
                                }
                            ]
                        },
                        {
                            Name: "期-计量单元-全参与人(mem_stage_pos_compare)",
                            remark: "",
                            items: [
                                {
                                    ID: 3501,
                                    Name: "期-计量单元-全参与人-id(id)(id: 3501)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'id')"
                                },
                                {
                                    ID: 3502,
                                    Name: "期-计量单元-全参与人-所属标段id(tid)(id: 3502)",
                                    DataType: "int",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'tid')"
                                },
                                {
                                    ID: 3503,
                                    Name: "期-计量单元-全参与人-所属清单id(lid)(id: 3503)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'lid')"
                                },
                                {
                                    ID: 3504,
                                    Name: "期-计量单元-全参与人-名称(name)(id: 3504)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'name')"
                                },
                                {
                                    ID: 3505,
                                    Name: "期-计量单元-全参与人-位置(position)(id: 3505)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'position')"
                                },
                                {
                                    ID: 3506,
                                    Name: "期-计量单元-全参与人-施工复核-数量(sgfh_qty)(id: 3506)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'sgfh_qty')"
                                },
                                {
                                    ID: 3507,
                                    Name: "期-计量单元-全参与人-其他错漏-数量(qtcl_qty)(id: 3507)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'qtcl_qty')"
                                },
                                {
                                    ID: 3508,
                                    Name: "期-计量单元-全参与人-设计错漏-数量(sjcl_qty)(id: 3508)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'sjcl_qty')"
                                },
                                {
                                    ID: 3509,
                                    Name: "期-计量单元-全参与人-台账-数量(quantity)(id: 3509)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'quantity')"
                                },
                                {
                                    ID: 3510,
                                    Name: "期-计量单元-全参与人-图号(drawing_code)(id: 3510)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'drawing_code')"
                                },
                                {
                                    ID: 3511,
                                    Name: "期-计量单元-全参与人-排序(p_order)(id: 3511)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'p_order')"
                                },
                                {
                                    ID: 3512,
                                    Name: "期-计量单元-全参与人-截止上期-合同计量-数量(pre_contract_qty)(id: 3512)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'pre_contract_qty')"
                                },
                                {
                                    ID: 3513,
                                    Name: "期-计量单元-全参与人-截止上期-数量变更-数量(pre_qc_qty)(id: 3513)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'pre_qc_qty')"
                                },
                                {
                                    ID: 3514,
                                    Name: "期-计量单元-全参与人-截止上期-完成计量-数量(pre_gather_qty)(id: 3514)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'pre_gather_qty')"
                                },
                                {
                                    ID: 3515,
                                    Name: "期-计量单元-全参与人-本期-合同计量-数量_0(r0_contract_qty)(id: 3515)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r0_contract_qty')"
                                },
                                {
                                    ID: 3516,
                                    Name: "期-计量单元-全参与人-本期-数量变更-数量_0(r0_qc_qty)(id: 3516)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r0_qc_qty')"
                                },
                                {
                                    ID: 3517,
                                    Name: "期-计量单元-全参与人-本期-完成计量-数量_0(r0_gather_qty)(id: 3517)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r0_gather_qty')"
                                },
                                {
                                    ID: 3518,
                                    Name: "期-计量单元-全参与人-本期-合同计量-数量_1(r1_contract_qty)(id: 3518)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r1_contract_qty')"
                                },
                                {
                                    ID: 3519,
                                    Name: "期-计量单元-全参与人-本期-数量变更-数量_1(r1_qc_qty)(id: 3519)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r1_qc_qty')"
                                },
                                {
                                    ID: 3520,
                                    Name: "期-计量单元-全参与人-本期-完成计量-数量_1(r1_gather_qty)(id: 3520)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r1_gather_qty')"
                                },
                                {
                                    ID: 3521,
                                    Name: "期-计量单元-全参与人-本期-合同计量-数量_2(r2_contract_qty)(id: 3521)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r2_contract_qty')"
                                },
                                {
                                    ID: 3522,
                                    Name: "期-计量单元-全参与人-本期-数量变更-数量_2(r2_qc_qty)(id: 3522)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r2_qc_qty')"
                                },
                                {
                                    ID: 3523,
                                    Name: "期-计量单元-全参与人-本期-完成计量-数量_2(r2_gather_qty)(id: 3523)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r2_gather_qty')"
                                },
                                {
                                    ID: 3524,
                                    Name: "期-计量单元-全参与人-本期-合同计量-数量_3(r3_contract_qty)(id: 3524)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r3_contract_qty')"
                                },
                                {
                                    ID: 3525,
                                    Name: "期-计量单元-全参与人-本期-数量变更-数量_3(r3_qc_qty)(id: 3525)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r3_qc_qty')"
                                },
                                {
                                    ID: 3526,
                                    Name: "期-计量单元-全参与人-本期-完成计量-数量_3(r3_gather_qty)(id: 3526)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r3_gather_qty')"
                                },
                                {
                                    ID: 3527,
                                    Name: "期-计量单元-全参与人-本期-合同计量-数量_4(r4_contract_qty)(id: 3527)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r4_contract_qty')"
                                },
                                {
                                    ID: 3528,
                                    Name: "期-计量单元-全参与人-本期-数量变更-数量_4(r4_qc_qty)(id: 3528)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r4_qc_qty')"
                                },
                                {
                                    ID: 3529,
                                    Name: "期-计量单元-全参与人-本期-完成计量-数量_4(r4_gather_qty)(id: 3529)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r4_gather_qty')"
                                },
                                {
                                    ID: 3530,
                                    Name: "期-计量单元-全参与人-本期-合同计量-数量_5(r5_contract_qty)(id: 3530)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r5_contract_qty')"
                                },
                                {
                                    ID: 3531,
                                    Name: "期-计量单元-全参与人-本期-数量变更-数量_5(r5_qc_qty)(id: 3531)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r5_qc_qty')"
                                },
                                {
                                    ID: 3532,
                                    Name: "期-计量单元-全参与人-本期-完成计量-数量_5(r5_gather_qty)(id: 3532)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r5_gather_qty')"
                                },
                                {
                                    ID: 3533,
                                    Name: "期-计量单元-全参与人-本期-合同计量-数量_6(r6_contract_qty)(id: 3533)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r6_contract_qty')"
                                },
                                {
                                    ID: 3534,
                                    Name: "期-计量单元-全参与人-本期-数量变更-数量_6(r6_qc_qty)(id: 3534)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r6_qc_qty')"
                                },
                                {
                                    ID: 3535,
                                    Name: "期-计量单元-全参与人-本期-完成计量-数量_6(r6_gather_qty)(id: 3535)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r6_gather_qty')"
                                },
                                {
                                    ID: 3536,
                                    Name: "期-计量单元-全参与人-本期-合同计量-数量_7(r7_contract_qty)(id: 3536)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r7_contract_qty')"
                                },
                                {
                                    ID: 3537,
                                    Name: "期-计量单元-全参与人-本期-数量变更-数量_7(r7_qc_qty)(id: 3537)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r7_qc_qty')"
                                },
                                {
                                    ID: 3538,
                                    Name: "期-计量单元-全参与人-本期-完成计量-数量_7(r7_gather_qty)(id: 3538)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r7_gather_qty')"
                                },
                                {
                                    ID: 3539,
                                    Name: "期-计量单元-全参与人-本期-合同计量-数量_8(r8_contract_qty)(id: 3539)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r8_contract_qty')"
                                },
                                {
                                    ID: 3540,
                                    Name: "期-计量单元-全参与人-本期-数量变更-数量_8(r8_qc_qty)(id: 3540)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r8_qc_qty')"
                                },
                                {
                                    ID: 3541,
                                    Name: "期-计量单元-全参与人-本期-完成计量-数量_8(r8_gather_qty)(id: 3541)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r8_gather_qty')"
                                },
                                {
                                    ID: 3542,
                                    Name: "期-计量单元-全参与人-本期-合同计量-数量_9(r9_contract_qty)(id: 3542)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r9_contract_qty')"
                                },
                                {
                                    ID: 3543,
                                    Name: "期-计量单元-全参与人-本期-数量变更-数量_9(r9_qc_qty)(id: 3543)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r9_qc_qty')"
                                },
                                {
                                    ID: 3544,
                                    Name: "期-计量单元-全参与人-本期-完成计量-数量_9(r9_gather_qty)(id: 3544)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', 'r9_gather_qty')"
                                },
                                {
                                    ID: 3599,
                                    Name: "期-计量单元-全参与人-空白(id: 3599)",
                                    DataType: "string",
                                    TableName: "mem_stage_pos_compare",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pos_compare', '')"
                                }
                            ]
                        },
                        {
                            Name: "期-合同支付-数据(mem_stage_pay)",
                            remark: "",
                            items: [
                                {
                                    ID: 2701,
                                    Name: "期-合同支付-名称(name)(id: 2701)",
                                    DataType: "string",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'name')"
                                },
                                {
                                    ID: 2702,
                                    Name: "期-合同支付-计算公式(expr)(id: 2702)",
                                    DataType: "string",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'expr')"
                                },
                                {
                                    ID: 2703,
                                    Name: "期-合同支付-金额(tp)(id: 2703)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'tp')"
                                },
                                {
                                    ID: 2704,
                                    Name: "期-合同支付-截止上期-金额(pre_tp)(id: 2704)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'pre_tp')"
                                },
                                {
                                    ID: 2705,
                                    Name: "期-合同支付-截止本期-金额(end_tp)(id: 2705)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'end_tp')"
                                },
                                {
                                    ID: 2706,
                                    Name: "期-合同支付-排序(order)(id: 2706)",
                                    DataType: "int",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'order')"
                                },
                                {
                                    ID: 2707,
                                    Name: "期-合同支付-是否扣款项(minus)(id: 2707)",
                                    DataType: "int",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'minus')"
                                },
                                {
                                    ID: 2708,
                                    Name: "期-合同支付-支付类型(ptype)(id: 2708)",
                                    DataType: "int",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'ptype')"
                                },
                                {
                                    ID: 2709,
                                    Name: "期-合同支付-起扣金额(sprice)(id: 2709)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'sprice')"
                                },
                                {
                                    ID: 2710,
                                    Name: "期-合同支付-扣款限额(rprice)(id: 2710)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'rprice')"
                                },
                                {
                                    ID: 2711,
                                    Name: "期-合同支付-流程-本期-金额_0(r0_tp)(id: 2711)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'r0_tp')"
                                },
                                {
                                    ID: 2712,
                                    Name: "期-合同支付-流程-本期-金额_1(r1_tp)(id: 2712)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'r1_tp')"
                                },
                                {
                                    ID: 2713,
                                    Name: "期-合同支付-流程-本期-金额_2(r2_tp)(id: 2713)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'r2_tp')"
                                },
                                {
                                    ID: 2714,
                                    Name: "期-合同支付-流程-本期-金额_3(r3_tp)(id: 2714)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'r3_tp')"
                                },
                                {
                                    ID: 2715,
                                    Name: "期-合同支付-流程-本期-金额_4(r4_tp)(id: 2715)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'r4_tp')"
                                },
                                {
                                    ID: 2716,
                                    Name: "期-合同支付-流程-本期-金额_5(r5_tp)(id: 2716)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'r5_tp')"
                                },
                                {
                                    ID: 2717,
                                    Name: "期-合同支付-流程-本期-金额_6(r6_tp)(id: 2717)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'r6_tp')"
                                },
                                {
                                    ID: 2718,
                                    Name: "期-合同支付-流程-本期-金额_7(r7_tp)(id: 2718)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'r7_tp')"
                                },
                                {
                                    ID: 2719,
                                    Name: "期-合同支付-流程-本期-金额_8(r8_tp)(id: 2719)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'r8_tp')"
                                },
                                {
                                    ID: 2720,
                                    Name: "期-合同支付-流程-本期-金额_9(r9_tp)(id: 2720)",
                                    DataType: "currency",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'r9_tp')"
                                },
                                {
                                    ID: 2721,
                                    Name: "期-合同支付-第几期开始计量(start_stage_order)(id: 2721)",
                                    DataType: "int",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', 'start_stage_order')"
                                },
                                {
                                    ID: 2799,
                                    Name: "期-合同支付-空白(id: 2799)",
                                    DataType: "string",
                                    TableName: "mem_stage_pay",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_pay', '')"
                                }
                            ]
                        },
                    ],
                },
                {
                    Name: '变更令相关',
                    remark: '变更令（&变更清单）内存表相关信息',
                    items: [
                        {
                            Name: "变更令(mem_change)",
                            remark: "",
                            items: [
                                {
                                    ID: 3301,
                                    Name: "变更令-变更令id(cid)(id: 3301)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'cid')"
                                },
                                {
                                    ID: 3302,
                                    Name: "变更令-变更令号(code)(id: 3302)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'code')"
                                },
                                {
                                    ID: 3303,
                                    Name: "变更令-批复文号(w_code)(id: 3303)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'w_code')"
                                },
                                {
                                    ID: 3304,
                                    Name: "变更令-批复编号(p_code)(id: 3304)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'p_code')"
                                },
                                {
                                    ID: 3305,
                                    Name: "变更令-变更名称(name)(id: 3305)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'name')"
                                },
                                {
                                    ID: 3306,
                                    Name: "变更令-桩号(peg)(id: 3306)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'peg')"
                                },
                                {
                                    ID: 3307,
                                    Name: "变更令-原设计图名称(org_name)(id: 3307)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'org_name')"
                                },
                                {
                                    ID: 3308,
                                    Name: "变更令-原图号(org_code)(id: 3308)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'org_code')"
                                },
                                {
                                    ID: 3309,
                                    Name: "变更令-变更设计图名称(new_name)(id: 3309)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'new_name')"
                                },
                                {
                                    ID: 3310,
                                    Name: "变更令-变更图号(new_code)(id: 3310)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'new_code')"
                                },
                                {
                                    ID: 3311,
                                    Name: "变更令-工程变更理由及内容(content)(id: 3311)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'content')"
                                },
                                {
                                    ID: 3312,
                                    Name: "变更令-工程变更合同依据(basis)(id: 3312)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'basis')"
                                },
                                {
                                    ID: 3313,
                                    Name: "变更令-变更工程量数量计算式(expr)(id: 3313)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'expr')"
                                },
                                {
                                    ID: 3314,
                                    Name: "变更令-备注(memo)(id: 3314)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'memo')"
                                },
                                {
                                    ID: 3315,
                                    Name: "变更令-变更类型(type)(id: 3315)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'type')"
                                },
                                {
                                    ID: 3316,
                                    Name: "变更令-变更类别(class)(id: 3316)",
                                    DataType: "int",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'class')"
                                },
                                {
                                    ID: 3317,
                                    Name: "变更令-变更性质(quality)(id: 3317)",
                                    DataType: "int",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'quality')"
                                },
                                {
                                    ID: 3318,
                                    Name: "变更令-变更提出单位(company)(id: 3318)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'company')"
                                },
                                {
                                    ID: 3319,
                                    Name: "变更令-费用承担方(charge)(id: 3319)",
                                    DataType: "int",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'charge')"
                                },
                                {
                                    ID: 3320,
                                    Name: "变更令-金额(total_price)(id: 3320)",
                                    DataType: "currency",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'total_price')"
                                },
                                {
                                    ID: 3321,
                                    Name: "变更令-变更状态发生时间（时间戳）(cin_time)(id: 3321)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'cin_time')"
                                },
                                {
                                    ID: 3322,
                                    Name: "变更令-完成审批时间（时间戳）(sin—_ime)(id: 3322)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'sin—_ime')"
                                },
                                {
                                    ID: 3323,
                                    Name: "变更令-金额_1(tp_1)(id: 3323)",
                                    DataType: "currency",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'tp_1')"
                                },
                                {
                                    ID: 3324,
                                    Name: "变更令-金额_2(tp_2)(id: 3324)",
                                    DataType: "currency",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'tp_2')"
                                },
                                {
                                    ID: 3325,
                                    Name: "变更令-金额_3(tp_3)(id: 3325)",
                                    DataType: "currency",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'tp_3')"
                                },
                                {
                                    ID: 3326,
                                    Name: "变更令-金额_4(tp_4)(id: 3326)",
                                    DataType: "currency",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'tp_4')"
                                },
                                {
                                    ID: 3327,
                                    Name: "变更令-金额_5(tp_5)(id: 3327)",
                                    DataType: "currency",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'tp_5')"
                                },
                                {
                                    ID: 3328,
                                    Name: "变更令-金额_6(tp_6)(id: 3328)",
                                    DataType: "currency",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'tp_6')"
                                },
                                {
                                    ID: 3329,
                                    Name: "变更令-金额_7(tp_7)(id: 3329)",
                                    DataType: "currency",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'tp_7')"
                                },
                                {
                                    ID: 3330,
                                    Name: "变更令-金额_8(tp_8)(id: 3330)",
                                    DataType: "currency",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'tp_8')"
                                },
                                {
                                    ID: 3331,
                                    Name: "变更令-金额_9(tp_9)(id: 3331)",
                                    DataType: "currency",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'tp_9')"
                                },
                                {
                                    ID: 3332,
                                    Name: "变更令-附件名称列表(attNames)(id: 3332)",
                                    DataType: "currency",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', 'attNames')"
                                },
                                {
                                    ID: 3399,
                                    Name: "变更令-空白(id: 3399)",
                                    DataType: "string",
                                    TableName: "mem_change",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change', '')"
                                }
                            ]
                        },
                        {
                            Name: "变更清单(mem_change_bills)",
                            remark: "",
                            items: [
                                {
                                    ID: 2901,
                                    Name: "变更清单-变更令id(cid)(id: 2901)",
                                    DataType: "string",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'cid')"
                                },
                                {
                                    ID: 2902,
                                    Name: "变更清单-签约清单id或台账id(lid)(id: 2902)",
                                    DataType: "string",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'lid')"
                                },
                                {
                                    ID: 2903,
                                    Name: "变更清单-清单编号(code)(id: 2903)",
                                    DataType: "string",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'code')"
                                },
                                {
                                    ID: 2904,
                                    Name: "变更清单-名称(name)(id: 2904)",
                                    DataType: "string",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'name')"
                                },
                                {
                                    ID: 2905,
                                    Name: "变更清单-单位(unit)(id: 2905)",
                                    DataType: "string",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'unit')"
                                },
                                {
                                    ID: 2906,
                                    Name: "变更清单-单价(unit_price)(id: 2906)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'unit_price')"
                                },
                                {
                                    ID: 2907,
                                    Name: "变更清单-原-数量(o_qty)(id: 2907)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'o_qty')"
                                },
                                {
                                    ID: 2908,
                                    Name: "变更清单-原-金额(o_tp)(id: 2908)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'o_tp')"
                                },
                                {
                                    ID: 2909,
                                    Name: "变更清单-变更-数量(c_qty)(id: 2909)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'c_qty')"
                                },
                                {
                                    ID: 2910,
                                    Name: "变更清单-变更-金额(c_tp)(id: 2910)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'c_tp')"
                                },
                                {
                                    ID: 2911,
                                    Name: "变更清单-审批变更后-数量(s_qty)(id: 2911)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 's_qty')"
                                },
                                {
                                    ID: 2912,
                                    Name: "变更清单-审批变更后-金额(s_tp)(id: 2912)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 's_tp')"
                                },
                                {
                                    ID: 2913,
                                    Name: "变更清单-部位明细(bwmx)(id: 2913)",
                                    DataType: "string",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'bwmx')"
                                },
                                {
                                    ID: 2914,
                                    Name: "变更清单-变更详情(detail)(id: 2914)",
                                    DataType: "string",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'detail')"
                                },
                                {
                                    ID: 2915,
                                    Name: "变更清单-数量_1(qty_1)(id: 2915)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'qty_1')"
                                },
                                {
                                    ID: 2916,
                                    Name: "变更清单-金额_1(tp_1)(id: 2916)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'tp_1')"
                                },
                                {
                                    ID: 2917,
                                    Name: "变更清单-数量_2(qty_2)(id: 2917)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'qty_2')"
                                },
                                {
                                    ID: 2918,
                                    Name: "变更清单-金额_2(tp_2)(id: 2918)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'tp_2')"
                                },
                                {
                                    ID: 2919,
                                    Name: "变更清单-数量_3(qty_3)(id: 2919)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'qty_3')"
                                },
                                {
                                    ID: 2920,
                                    Name: "变更清单-金额_3(tp_3)(id: 2920)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'tp_3')"
                                },
                                {
                                    ID: 2921,
                                    Name: "变更清单-数量_4(qty_4)(id: 2921)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'qty_4')"
                                },
                                {
                                    ID: 2922,
                                    Name: "变更清单-金额_4(tp_4)(id: 2922)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'tp_4')"
                                },
                                {
                                    ID: 2923,
                                    Name: "变更清单-数量_5(qty_5)(id: 2923)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'qty_5')"
                                },
                                {
                                    ID: 2924,
                                    Name: "变更清单-金额_5(tp_5)(id: 2924)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'tp_5')"
                                },
                                {
                                    ID: 2925,
                                    Name: "变更清单-数量_6(qty_6)(id: 2925)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'qty_6')"
                                },
                                {
                                    ID: 2926,
                                    Name: "变更清单-金额_6(tp_6)(id: 2926)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'tp_6')"
                                },
                                {
                                    ID: 2927,
                                    Name: "变更清单-数量_7(qty_7)(id: 2927)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'qty_7')"
                                },
                                {
                                    ID: 2928,
                                    Name: "变更清单-金额_7(tp_7)(id: 2928)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'tp_7')"
                                },
                                {
                                    ID: 2929,
                                    Name: "变更清单-数量_8(qty_8)(id: 2929)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'qty_8')"
                                },
                                {
                                    ID: 2930,
                                    Name: "变更清单-金额_8(tp_8)(id: 2930)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'tp_8')"
                                },
                                {
                                    ID: 2931,
                                    Name: "变更清单-数量_9(qty_9)(id: 2931)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'qty_9')"
                                },
                                {
                                    ID: 2932,
                                    Name: "变更清单-金额_9(tp_9)(id: 2932)",
                                    DataType: "currency",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', 'tp_9')"
                                },
                                {
                                    ID: 2999,
                                    Name: "变更清单-空白(id: 2999)",
                                    DataType: "string",
                                    TableName: "mem_change_bills",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_change_bills', '')"
                                }
                            ]
                        },
                    ]
                },
                {
                    Name: "预留扩展-合并 数据表(mem_union_data)",
                    remark: "",
                    items: [
                        {
                            ID: 2801,
                            Name: "预留扩展-合并-字符串1(str1)(id: 2801)",
                            DataType: "string",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'str1')"
                        },
                        {
                            ID: 2802,
                            Name: "预留扩展-合并-字符串2(str2)(id: 2802)",
                            DataType: "string",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'str2')"
                        },
                        {
                            ID: 2803,
                            Name: "预留扩展-合并-字符串3(str3)(id: 2803)",
                            DataType: "string",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'str3')"
                        },
                        {
                            ID: 2804,
                            Name: "预留扩展-合并-字符串4(str4)(id: 2804)",
                            DataType: "string",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'str4')"
                        },
                        {
                            ID: 2805,
                            Name: "预留扩展-合并-字符串5(str5)(id: 2805)",
                            DataType: "string",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'str5')"
                        },
                        {
                            ID: 2806,
                            Name: "预留扩展-合并-字符串6(str6)(id: 2806)",
                            DataType: "string",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'str6')"
                        },
                        {
                            ID: 2807,
                            Name: "预留扩展-合并-字符串7(str7)(id: 2807)",
                            DataType: "string",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'str7')"
                        },
                        {
                            ID: 2808,
                            Name: "预留扩展-合并-字符串8(str8)(id: 2808)",
                            DataType: "string",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'str8')"
                        },
                        {
                            ID: 2809,
                            Name: "预留扩展-合并-字符串9(str9)(id: 2809)",
                            DataType: "string",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'str9')"
                        },
                        {
                            ID: 2810,
                            Name: "预留扩展-合并-字符串10(str10)(id: 2810)",
                            DataType: "string",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'str10')"
                        },
                        {
                            ID: 2811,
                            Name: "预留扩展-合并-整数1(int1)(id: 2811)",
                            DataType: "int",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'int1')"
                        },
                        {
                            ID: 2812,
                            Name: "预留扩展-合并-整数2(int2)(id: 2812)",
                            DataType: "int",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'int2')"
                        },
                        {
                            ID: 2813,
                            Name: "预留扩展-合并-整数3(int3)(id: 2813)",
                            DataType: "int",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'int3')"
                        },
                        {
                            ID: 2814,
                            Name: "预留扩展-合并-整数4(int4)(id: 2814)",
                            DataType: "int",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'int4')"
                        },
                        {
                            ID: 2815,
                            Name: "预留扩展-合并-整数5(int5)(id: 2815)",
                            DataType: "int",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'int5')"
                        },
                        {
                            ID: 2816,
                            Name: "预留扩展-合并-整数6(int6)(id: 2816)",
                            DataType: "int",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'int6')"
                        },
                        {
                            ID: 2817,
                            Name: "预留扩展-合并-数量1(qty1)(id: 2817)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'qty1')"
                        },
                        {
                            ID: 2818,
                            Name: "预留扩展-合并-数量2(qty2)(id: 2818)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'qty2')"
                        },
                        {
                            ID: 2819,
                            Name: "预留扩展-合并-数量3(qty3)(id: 2819)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'qty3')"
                        },
                        {
                            ID: 2820,
                            Name: "预留扩展-合并-数量4(qty4)(id: 2820)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'qty4')"
                        },
                        {
                            ID: 2821,
                            Name: "预留扩展-合并-数量5(qty5)(id: 2821)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'qty5')"
                        },
                        {
                            ID: 2822,
                            Name: "预留扩展-合并-数量6(qty6)(id: 2822)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'qty6')"
                        },
                        {
                            ID: 2823,
                            Name: "预留扩展-合并-数量7(qty7)(id: 2823)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'qty7')"
                        },
                        {
                            ID: 2824,
                            Name: "预留扩展-合并-数量8(qty8)(id: 2824)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'qty8')"
                        },
                        {
                            ID: 2825,
                            Name: "预留扩展-合并-数量9(qty9)(id: 2825)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'qty9')"
                        },
                        {
                            ID: 2826,
                            Name: "预留扩展-合并-数量10(qty10)(id: 2826)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'qty10')"
                        },
                        {
                            ID: 2827,
                            Name: "预留扩展-合并-金额1(tp1)(id: 2827)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'tp1')"
                        },
                        {
                            ID: 2828,
                            Name: "预留扩展-合并-金额2(tp2)(id: 2828)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'tp2')"
                        },
                        {
                            ID: 2829,
                            Name: "预留扩展-合并-金额3(tp3)(id: 2829)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'tp3')"
                        },
                        {
                            ID: 2830,
                            Name: "预留扩展-合并-金额4(tp4)(id: 2830)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'tp4')"
                        },
                        {
                            ID: 2831,
                            Name: "预留扩展-合并-金额5(tp5)(id: 2831)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'tp5')"
                        },
                        {
                            ID: 2832,
                            Name: "预留扩展-合并-金额6(tp6)(id: 2832)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'tp6')"
                        },
                        {
                            ID: 2833,
                            Name: "预留扩展-合并-金额7(tp7)(id: 2833)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'tp7')"
                        },
                        {
                            ID: 2834,
                            Name: "预留扩展-合并-金额8(tp8)(id: 2834)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'tp8')"
                        },
                        {
                            ID: 2835,
                            Name: "预留扩展-合并-金额9(tp9)(id: 2835)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'tp9')"
                        },
                        {
                            ID: 2836,
                            Name: "预留扩展-合并-金额10(tp10)(id: 2836)",
                            DataType: "currency",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', 'tp10')"
                        },
                        {
                            ID: 2899,
                            Name: "预留扩展-合并-空白(id: 2899)",
                            DataType: "string",
                            TableName: "mem_union_data",
                            descr: "",
                            mapExpression: "$PROJECT.REPORT.getProperty('mem_union_data', '')"
                        }
                    ]
                },
                {
                    Name: '其他台账',
                    remark: '期-其他台账相关数据',
                    items: [
                        {
                            Name: "期-甲供材料(mem_stage_jgcl)",
                            remark: "",
                            items: [
                                {
                                    ID: 3001,
                                    Name: "期-甲供材料-id(id)(id: 3001)",
                                    DataType: "int",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'id')"
                                },
                                {
                                    ID: 3002,
                                    Name: "期-甲供材料-uuid(uuid)(id: 3002)",
                                    DataType: "string",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'uuid')"
                                },
                                {
                                    ID: 3003,
                                    Name: "期-甲供材料-名称(name)(id: 3003)",
                                    DataType: "string",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'name')"
                                },
                                {
                                    ID: 3004,
                                    Name: "期-甲供材料-单位(unit)(id: 3004)",
                                    DataType: "string",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'unit')"
                                },
                                {
                                    ID: 3005,
                                    Name: "期-甲供材料-单价(unit_price)(id: 3005)",
                                    DataType: "currency",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'unit_price')"
                                },
                                {
                                    ID: 3006,
                                    Name: "期-甲供材料-本期到场-数量(arrive_qty)(id: 3006)",
                                    DataType: "currency",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'arrive_qty')"
                                },
                                {
                                    ID: 3007,
                                    Name: "期-甲供材料-本期到场-金额(arrive_tp)(id: 3007)",
                                    DataType: "currency",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'arrive_tp')"
                                },
                                {
                                    ID: 3008,
                                    Name: "期-甲供材料-本期扣回-数量(deduct_qty)(id: 3008)",
                                    DataType: "currency",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'deduct_qty')"
                                },
                                {
                                    ID: 3009,
                                    Name: "期-甲供材料-本期扣回-金额(deduct_tp)(id: 3009)",
                                    DataType: "currency",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'deduct_tp')"
                                },
                                {
                                    ID: 3010,
                                    Name: "期-甲供材料-材料来源(source)(id: 3010)",
                                    DataType: "string",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'source')"
                                },
                                {
                                    ID: 3011,
                                    Name: "期-甲供材料-单据号(bills_code)(id: 3011)",
                                    DataType: "string",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'bills_code')"
                                },
                                {
                                    ID: 3012,
                                    Name: "期-甲供材料-检验单编号(check_code)(id: 3012)",
                                    DataType: "string",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'check_code')"
                                },
                                {
                                    ID: 3013,
                                    Name: "期-甲供材料-新增人id(add_uid)(id: 3013)",
                                    DataType: "int",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'add_uid')"
                                },
                                {
                                    ID: 3014,
                                    Name: "期-甲供材料-新增期id(add_sid)(id: 3014)",
                                    DataType: "int",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'add_sid')"
                                },
                                {
                                    ID: 3015,
                                    Name: "期-甲供材料-所属期id(sid)(id: 3015)",
                                    DataType: "int",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'sid')"
                                },
                                {
                                    ID: 3016,
                                    Name: "期-甲供材料-期历史记录(shistory)(id: 3016)",
                                    DataType: "string",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'shistory')"
                                },
                                {
                                    ID: 3017,
                                    Name: "期-甲供材料-排序(order)(id: 3017)",
                                    DataType: "int",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'order')"
                                },
                                {
                                    ID: 3018,
                                    Name: "期-甲供材料-往期是否已用(pre_used)(id: 3018)",
                                    DataType: "int",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'pre_used')"
                                },
                                {
                                    ID: 3019,
                                    Name: "期-甲供材料-截止上期到场-数量(pre_arrive_qty)(id: 3019)",
                                    DataType: "currency",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'pre_arrive_qty')"
                                },
                                {
                                    ID: 3020,
                                    Name: "期-甲供材料-截止上期到场-金额(pre_arrive_tp)(id: 3020)",
                                    DataType: "currency",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'pre_arrive_tp')"
                                },
                                {
                                    ID: 3021,
                                    Name: "期-甲供材料-截止上期扣回-数量(pre_deduct_qty)(id: 3021)",
                                    DataType: "currency",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'pre_deduct_qty')"
                                },
                                {
                                    ID: 3022,
                                    Name: "期-甲供材料-截止上期扣回-金额(pre_deduct_tp)(id: 3022)",
                                    DataType: "currency",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'pre_deduct_tp')"
                                },
                                {
                                    ID: 3023,
                                    Name: "期-甲供材料-备注(memo)(id: 3023)",
                                    DataType: "string",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', 'memo')"
                                },
                                {
                                    ID: 3099,
                                    Name: "期-甲供材料-空白(id: 3099)",
                                    DataType: "string",
                                    TableName: "mem_stage_jgcl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_jgcl', '')"
                                }
                            ]
                        },
                        {
                            Name: "期-奖罚金(mem_stage_bonus)",
                            remark: "",
                            items: [
                                {
                                    ID: 3101,
                                    Name: "期-奖罚金-id(id)(id: 3101)",
                                    DataType: "string",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'id')"
                                },
                                {
                                    ID: 3102,
                                    Name: "期-奖罚金-所属标段id(tid)(id: 3102)",
                                    DataType: "int",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'tid')"
                                },
                                {
                                    ID: 3103,
                                    Name: "期-奖罚金-所属期id(sid)(id: 3103)",
                                    DataType: "int",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'sid')"
                                },
                                {
                                    ID: 3104,
                                    Name: "期-奖罚金-所属第几期(sorder)(id: 3104)",
                                    DataType: "int",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'sorder')"
                                },
                                {
                                    ID: 3105,
                                    Name: "期-奖罚金-新增人id(uid)(id: 3105)",
                                    DataType: "int",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'uid')"
                                },
                                {
                                    ID: 3106,
                                    Name: "期-奖罚金-名称(name)(id: 3106)",
                                    DataType: "string",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'name')"
                                },
                                {
                                    ID: 3107,
                                    Name: "期-奖罚金-金额(tp)(id: 3107)",
                                    DataType: "currency",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'tp')"
                                },
                                {
                                    ID: 3108,
                                    Name: "期-奖罚金-证明材料(proof)(id: 3108)",
                                    DataType: "string",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'proof')"
                                },
                                {
                                    ID: 3109,
                                    Name: "期-奖罚金-创建时间(create_time)(id: 3109)",
                                    DataType: "string",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'create_time')"
                                },
                                {
                                    ID: 3110,
                                    Name: "期-奖罚金-时间(real_time)(id: 3110)",
                                    DataType: "string",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'real_time')"
                                },
                                {
                                    ID: 3111,
                                    Name: "期-奖罚金-备注(memo)(id: 3111)",
                                    DataType: "string",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'memo')"
                                },
                                {
                                    ID: 3112,
                                    Name: "期-奖罚金-期历史记录(shistory)(id: 3112)",
                                    DataType: "string",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'shistory')"
                                },
                                {
                                    ID: 3113,
                                    Name: "期-奖罚金-排序(order)(id: 3113)",
                                    DataType: "int",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'order')"
                                },
                                {
                                    ID: 3114,
                                    Name: "期-奖罚金-编号(code)(id: 3114)",
                                    DataType: "string",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'code')"
                                },
                                {
                                    ID: 3115,
                                    Name: "期-奖罚金-发文单位(doc_co)(id: 3115)",
                                    DataType: "string",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'doc_co')"
                                },
                                {
                                    ID: 3116,
                                    Name: "期-奖罚金-类型(b_type)(id: 3116)",
                                    DataType: "string",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', 'b_type')"
                                },
                                {
                                    ID: 3199,
                                    Name: "期-奖罚金-空白(id: 3199)",
                                    DataType: "string",
                                    TableName: "mem_stage_bonus",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_bonus', '')"
                                }
                            ]
                        },
                        {
                            Name: "期-其他(mem_stage_other)",
                            remark: "",
                            items: [
                                {
                                    ID: 3201,
                                    Name: "期-其他-id(id)(id: 3201)",
                                    DataType: "int",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'id')"
                                },
                                {
                                    ID: 3202,
                                    Name: "期-其他-uuid(uuid)(id: 3202)",
                                    DataType: "string",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'uuid')"
                                },
                                {
                                    ID: 3203,
                                    Name: "期-其他-所属标段id(tid)(id: 3203)",
                                    DataType: "int",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'tid')"
                                },
                                {
                                    ID: 3204,
                                    Name: "期-其他-所属期id(sid)(id: 3204)",
                                    DataType: "int",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'sid')"
                                },
                                {
                                    ID: 3205,
                                    Name: "期-其他-所属第几期(sorder)(id: 3205)",
                                    DataType: "int",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'sorder')"
                                },
                                {
                                    ID: 3206,
                                    Name: "期-其他-新增人id(add_uid)(id: 3206)",
                                    DataType: "int",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'add_uid')"
                                },
                                {
                                    ID: 3207,
                                    Name: "期-其他-新增期id(add_sid)(id: 3207)",
                                    DataType: "int",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'add_sid')"
                                },
                                {
                                    ID: 3208,
                                    Name: "期-其他-创建时间(add_time)(id: 3208)",
                                    DataType: "string",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'add_time')"
                                },
                                {
                                    ID: 3209,
                                    Name: "期-其他-名称(name)(id: 3209)",
                                    DataType: "string",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'name')"
                                },
                                {
                                    ID: 3210,
                                    Name: "期-其他-金额(total_price)(id: 3210)",
                                    DataType: "currency",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'total_price')"
                                },
                                {
                                    ID: 3211,
                                    Name: "期-其他-本期金额(tp)(id: 3211)",
                                    DataType: "currency",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'tp')"
                                },
                                {
                                    ID: 3212,
                                    Name: "期-其他-时间(real_time)(id: 3212)",
                                    DataType: "string",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'real_time')"
                                },
                                {
                                    ID: 3213,
                                    Name: "期-其他-备注(memo)(id: 3213)",
                                    DataType: "string",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'memo')"
                                },
                                {
                                    ID: 3214,
                                    Name: "期-其他-期历史记录(shistory)(id: 3214)",
                                    DataType: "string",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'shistory')"
                                },
                                {
                                    ID: 3215,
                                    Name: "期-其他-排序(order)(id: 3215)",
                                    DataType: "int",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'order')"
                                },
                                {
                                    ID: 3216,
                                    Name: "期-其他-往期是否已用(pre_used)(id: 3216)",
                                    DataType: "int",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'pre_used')"
                                },
                                {
                                    ID: 3217,
                                    Name: "期-其他-截止上期-金额(pre_tp)(id: 3217)",
                                    DataType: "currency",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'pre_tp')"
                                },
                                {
                                    ID: 3218,
                                    Name: "期-其他-类型(o_type)(id: 3218)",
                                    DataType: "string",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', 'o_type')"
                                },
                                {
                                    ID: 3299,
                                    Name: "期-其他-空白(id: 3299)",
                                    DataType: "string",
                                    TableName: "mem_stage_other",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_other', '')"
                                }
                            ]
                        }
                    ]
                },
                {
                    Name: '材料调差',
                    remark: '',
                    items: [
                        {
                            Name: "材料调差-期列表-数据(mem_material)",
                            remark: "",
                            items: [
                                {
                                    ID: 4001,
                                    Name: "材料调差-期列表-id(id)(id: 4001)",
                                    DataType: "int",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', 'id')"
                                },
                                {
                                    ID: 4002,
                                    Name: "材料调差-期列表-标段id(tid)(id: 4002)",
                                    DataType: "int",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', 'tid')"
                                },
                                {
                                    ID: 4003,
                                    Name: "材料调差-期列表-创建者id(user_id)(id: 4003)",
                                    DataType: "int",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', 'user_id')"
                                },
                                {
                                    ID: 4004,
                                    Name: "材料调差-期列表-审批次数(times)(id: 4004)",
                                    DataType: "int",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', 'times')"
                                },
                                {
                                    ID: 4005,
                                    Name: "材料调差-期列表-审批状态(status)(id: 4005)",
                                    DataType: "int",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', 'status')"
                                },
                                {
                                    ID: 4006,
                                    Name: "材料调差-期列表-期id列表(stage_id)(id: 4006)",
                                    DataType: "string",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', 'stage_id')"
                                },
                                {
                                    ID: 4007,
                                    Name: "材料调差-期列表-期order列表(s_order)(id: 4007)",
                                    DataType: "string",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', 's_order')"
                                },
                                {
                                    ID: 4008,
                                    Name: "材料调差-期列表-材料调差期数(order)(id: 4008)",
                                    DataType: "int",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', 'order')"
                                },
                                {
                                    ID: 4009,
                                    Name: "材料调差-期列表-本期金额(m_tp)(id: 4009)",
                                    DataType: "currency",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', 'm_tp')"
                                },
                                {
                                    ID: 4010,
                                    Name: "材料调差-期列表-截止上期金额(pre_tp)(id: 4010)",
                                    DataType: "currency",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', 'pre_tp')"
                                },
                                {
                                    ID: 4011,
                                    Name: "材料调差-期列表-税率(rate)(id: 4011)",
                                    DataType: "int",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', 'rate')"
                                },
                                {
                                    ID: 4012,
                                    Name: "材料调差-期列表-创建时间(in_time)(id: 4012)",
                                    DataType: "string",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', 'in_time')"
                                },
                                {
                                    ID: 4099,
                                    Name: "材料调差-期列表-空白(id: 4099)",
                                    DataType: "string",
                                    TableName: "mem_material",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material', '')"
                                }
                            ]
                        },
                        {
                            Name: "材料调差-期-调差工料-数据(mem_material_gl)",
                            remark: "",
                            items: [
                                {
                                    ID: 4101,
                                    Name: "材料调差-期-调差工料-id(id)(id: 4101)",
                                    DataType: "int",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'id')"
                                },
                                {
                                    ID: 4102,
                                    Name: "材料调差-期-调差工料-标段id(tid)(id: 4102)",
                                    DataType: "int",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'tid')"
                                },
                                {
                                    ID: 4103,
                                    Name: "材料调差-期-调差工料-创建期id(mid)(id: 4103)",
                                    DataType: "int",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'mid')"
                                },
                                {
                                    ID: 4104,
                                    Name: "材料调差-期-调差工料-调差类型(t_type)(id: 4104)",
                                    DataType: "int",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 't_type')"
                                },
                                {
                                    ID: 4105,
                                    Name: "材料调差-期-调差工料-调差类型s(t_type_str)(id: 4105)",
                                    DataType: "string",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 't_type_str')"
                                },
                                {
                                    ID: 4106,
                                    Name: "材料调差-期-调差工料-工料分类(m_type)(id: 4106)",
                                    DataType: "int",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'm_type')"
                                },
                                {
                                    ID: 4107,
                                    Name: "材料调差-期-调差工料-工料分类s(m_type_str)(id: 4107)",
                                    DataType: "string",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'm_type_str')"
                                },
                                {
                                    ID: 4108,
                                    Name: "材料调差-期-调差工料-编号(code)(id: 4108)",
                                    DataType: "string",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'code')"
                                },
                                {
                                    ID: 4109,
                                    Name: "材料调差-期-调差工料-名称(name)(id: 4109)",
                                    DataType: "string",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'name')"
                                },
                                {
                                    ID: 4110,
                                    Name: "材料调差-期-调差工料-单位(unit)(id: 4110)",
                                    DataType: "string",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'unit')"
                                },
                                {
                                    ID: 4111,
                                    Name: "材料调差-期-调差工料-规格(spec)(id: 4111)",
                                    DataType: "string",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'spec')"
                                },
                                {
                                    ID: 4112,
                                    Name: "材料调差-期-调差工料-基准价(basic_price)(id: 4112)",
                                    DataType: "currency",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'basic_price')"
                                },
                                {
                                    ID: 4113,
                                    Name: "材料调差-期-调差工料-基准时间(basic_time)(id: 4113)",
                                    DataType: "string",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'basic_time')"
                                },
                                {
                                    ID: 4114,
                                    Name: "材料调差-期-调差工料-本期信息价-单价(msg_tp)(id: 4114)",
                                    DataType: "currency",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'msg_tp')"
                                },
                                {
                                    ID: 4115,
                                    Name: "材料调差-期-调差工料-本期信息价-时间(msg_times)(id: 4115)",
                                    DataType: "string",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'msg_times')"
                                },
                                {
                                    ID: 4116,
                                    Name: "材料调差-期-调差工料-本期信息价-价差(msg_spread)(id: 4116)",
                                    DataType: "currency",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'msg_spread')"
                                },
                                {
                                    ID: 4117,
                                    Name: "材料调差-期-调差工料-本期材料调差-上涨幅度(m_up_risk)(id: 4117)",
                                    DataType: "int",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'm_up_risk')"
                                },
                                {
                                    ID: 4118,
                                    Name: "材料调差-期-调差工料-本期材料调差-下跌幅度(m_down_risk)(id: 4118)",
                                    DataType: "int",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'm_down_risk')"
                                },
                                {
                                    ID: 4119,
                                    Name: "材料调差-期-调差工料-本期材料调差-有效价差(m_spread)(id: 4119)",
                                    DataType: "currency",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'm_spread')"
                                },
                                {
                                    ID: 4120,
                                    Name: "材料调差-期-调差工料-本期应耗数据(quantity)(id: 4120)",
                                    DataType: "currency",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'quantity')"
                                },
                                {
                                    ID: 4121,
                                    Name: "材料调差-期-调差工料-计算式(expr)(id: 4121)",
                                    DataType: "string",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'expr')"
                                },
                                {
                                    ID: 4122,
                                    Name: "材料调差-期-调差工料-本期-调差金额(tp)(id: 4122)",
                                    DataType: "currency",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'tp')"
                                },
                                {
                                    ID: 4123,
                                    Name: "材料调差-期-调差工料-截止上期-调差金额(pre_tp)(id: 4123)",
                                    DataType: "currency",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'pre_tp')"
                                },
                                {
                                    ID: 4124,
                                    Name: "材料调差-期-调差工料-截止本期-调差金额(end_tp)(id: 4124)",
                                    DataType: "currency",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'end_tp')"
                                },
                                {
                                    ID: 4125,
                                    Name: "材料调差-期-调差工料-创建时间(in_time)(id: 4125)",
                                    DataType: "string",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'in_time')"
                                },
                                {
                                    ID: 4126,
                                    Name: "材料调差-期-调差工料-备注(remark)(id: 4126)",
                                    DataType: "string",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', 'remark')"
                                },
                                {
                                    ID: 4199,
                                    Name: "材料调差-期-调差工料-空白(id: 4199)",
                                    DataType: "string",
                                    TableName: "mem_material_gl",
                                    descr: "",
                                    mapExpression: "$PROJECT.REPORT.getProperty('mem_material_gl', '')"
                                }
                            ]
                        }
                    ],
                }
            ]
        },
    ],
}, {
    Name: '汇总表',
    remark: '使用用户交互进行汇总的数据',
    seq: 2,
    items: [
        {
            Name: "汇总-清单数据表(mem_gather_stage_bills)",
            remark: "",
            items: [
                {
                    ID: 3601,
                    Name: "汇总-清单数据-项目节编号(code)(id: 3601)",
                    DataType: "string",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'code')"
                },
                {
                    ID: 3602,
                    Name: "汇总-清单数据-清单编号(b_code)(id: 3602)",
                    DataType: "string",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'b_code')"
                },
                {
                    ID: 3603,
                    Name: "汇总-清单数据-名称(name)(id: 3603)",
                    DataType: "string",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'name')"
                },
                {
                    ID: 3604,
                    Name: "汇总-清单数据-单位(unit)(id: 3604)",
                    DataType: "string",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'unit')"
                },
                {
                    ID: 3605,
                    Name: "汇总-清单数据-单价(unit_price)(id: 3605)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'unit_price')"
                },
                {
                    ID: 3606,
                    Name: "汇总-清单数据-标段id(t_id)(id: 3606)",
                    DataType: "int",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_id')"
                },
                {
                    ID: 3607,
                    Name: "汇总-清单数据-标段-名称(t_name)(id: 3607)",
                    DataType: "string",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_name')"
                },
                {
                    ID: 3608,
                    Name: "汇总-清单数据-(标段)台账-数量(t_qty)(id: 3608)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_qty')"
                },
                {
                    ID: 3609,
                    Name: "汇总-清单数据-(标段)台账-金额(t_tp)(id: 3609)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_tp')"
                },
                {
                    ID: 3610,
                    Name: "汇总-清单数据-(标段)本期-合同-数量(t_contract_qty)(id: 3610)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_contract_qty')"
                },
                {
                    ID: 3611,
                    Name: "汇总-清单数据-(标段)本期-合同-金额(t_contract_tp)(id: 3611)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_contract_tp')"
                },
                {
                    ID: 3612,
                    Name: "汇总-清单数据-(标段)本期-变更-数量(t_qc_qty)(id: 3612)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_qc_qty')"
                },
                {
                    ID: 3613,
                    Name: "汇总-清单数据-(标段)本期-变更-金额(t_qc_tp)(id: 3613)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_qc_tp')"
                },
                {
                    ID: 3614,
                    Name: "汇总-清单数据-(标段)本期-完成-数量(t_gather_qty)(id: 3614)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_gather_qty')"
                },
                {
                    ID: 3615,
                    Name: "汇总-清单数据-(标段)本期-完成-金额(t_gather_tp)(id: 3615)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_gather_tp')"
                },
                {
                    ID: 3616,
                    Name: "汇总-清单数据-(标段)截止上期-合同-数量(t_pre_contract_qty)(id: 3616)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_pre_contract_qty')"
                },
                {
                    ID: 3617,
                    Name: "汇总-清单数据-(标段)截止上期-合同-金额(t_pre_contract_tp)(id: 3617)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_pre_contract_tp')"
                },
                {
                    ID: 3618,
                    Name: "汇总-清单数据-(标段)截止上期-变更-数量(t_pre_qc_qty)(id: 3618)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_pre_qc_qty')"
                },
                {
                    ID: 3619,
                    Name: "汇总-清单数据-(标段)截止上期-变更-金额(t_pre_qc_tp)(id: 3619)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_pre_qc_tp')"
                },
                {
                    ID: 3620,
                    Name: "汇总-清单数据-(标段)截止上期-完成-数量(t_pre_gather_qty)(id: 3620)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_pre_gather_qty')"
                },
                {
                    ID: 3621,
                    Name: "汇总-清单数据-(标段)截止上期-完成-金额(t_pre_gather_tp)(id: 3621)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_pre_gather_tp')"
                },
                {
                    ID: 3622,
                    Name: "汇总-清单数据-(标段)截止本期-合同-数量(t_end_contract_qty)(id: 3622)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_end_contract_qty')"
                },
                {
                    ID: 3623,
                    Name: "汇总-清单数据-(标段)截止本期-合同-金额(t_end_contract_tp)(id: 3623)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_end_contract_tp')"
                },
                {
                    ID: 3624,
                    Name: "汇总-清单数据-(标段)截止本期-变更-数量(t_end_qc_qty)(id: 3624)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_end_qc_qty')"
                },
                {
                    ID: 3625,
                    Name: "汇总-清单数据-(标段)截止本期-变更-金额(t_end_qc_tp)(id: 3625)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_end_qc_tp')"
                },
                {
                    ID: 3626,
                    Name: "汇总-清单数据-(标段)截止本期-完成-数量(t_end_gather_qty)(id: 3626)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_end_gather_qty')"
                },
                {
                    ID: 3627,
                    Name: "汇总-清单数据-(标段)截止本期-完成-金额(t_end_gather_tp)(id: 3627)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_end_gather_tp')"
                },
                {
                    ID: 3628,
                    Name: "汇总-清单数据-(合计)台账-数量(s_qty)(id: 3628)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_qty')"
                },
                {
                    ID: 3629,
                    Name: "汇总-清单数据-(合计)台账-金额(s_tp)(id: 3629)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_tp')"
                },
                {
                    ID: 3630,
                    Name: "汇总-清单数据-(合计)本期-合同-数量(s_contract_qty)(id: 3630)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_contract_qty')"
                },
                {
                    ID: 3631,
                    Name: "汇总-清单数据-(合计)本期-合同-金额(s_contract_tp)(id: 3631)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_contract_tp')"
                },
                {
                    ID: 3632,
                    Name: "汇总-清单数据-(合计)本期-变更-数量(s_qc_qty)(id: 3632)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_qc_qty')"
                },
                {
                    ID: 3633,
                    Name: "汇总-清单数据-(合计)本期-变更-金额(s_qc_tp)(id: 3633)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_qc_tp')"
                },
                {
                    ID: 3634,
                    Name: "汇总-清单数据-(合计)本期-完成-数量(s_gather_qty)(id: 3634)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_gather_qty')"
                },
                {
                    ID: 3635,
                    Name: "汇总-清单数据-(合计)本期-完成-金额(s_gather_tp)(id: 3635)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_gather_tp')"
                },
                {
                    ID: 3636,
                    Name: "汇总-清单数据-(合计)截止上期-合同-数量(s_pre_contract_qty)(id: 3636)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_pre_contract_qty')"
                },
                {
                    ID: 3637,
                    Name: "汇总-清单数据-(合计)截止上期-合同-金额(s_pre_contract_tp)(id: 3637)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_pre_contract_tp')"
                },
                {
                    ID: 3638,
                    Name: "汇总-清单数据-(合计)截止上期-变更-数量(s_pre_qc_qty)(id: 3638)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_pre_qc_qty')"
                },
                {
                    ID: 3639,
                    Name: "汇总-清单数据-(合计)截止上期-变更-金额(s_pre_qc_tp)(id: 3639)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_pre_qc_tp')"
                },
                {
                    ID: 3640,
                    Name: "汇总-清单数据-(合计)截止上期-完成-数量(s_pre_gather_qty)(id: 3640)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_pre_gather_qty')"
                },
                {
                    ID: 3641,
                    Name: "汇总-清单数据-(合计)截止上期-完成-金额(s_pre_gather_tp)(id: 3641)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_pre_gather_tp')"
                },
                {
                    ID: 3642,
                    Name: "汇总-清单数据-(合计)截止本期-合同-数量(s_end_contract_qty)(id: 3642)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_end_contract_qty')"
                },
                {
                    ID: 3643,
                    Name: "汇总-清单数据-(合计)截止本期-合同-金额(s_end_contract_tp)(id: 3643)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_end_contract_tp')"
                },
                {
                    ID: 3644,
                    Name: "汇总-清单数据-(合计)截止本期-变更-数量(s_end_qc_qty)(id: 3644)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_end_qc_qty')"
                },
                {
                    ID: 3645,
                    Name: "汇总-清单数据-(合计)截止本期-变更-金额(s_end_qc_tp)(id: 3645)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_end_qc_tp')"
                },
                {
                    ID: 3646,
                    Name: "汇总-清单数据-(合计)截止本期-完成-数量(s_end_gather_qty)(id: 3646)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_end_gather_qty')"
                },
                {
                    ID: 3647,
                    Name: "汇总-清单数据-(合计)截止本期-完成-金额(s_end_gather_tp)(id: 3647)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 's_end_gather_tp')"
                },
                {
                    ID: 3648,
                    Name: "汇总-清单数据-(特殊1-需替换key1)台账-数量(ts_key1_qty)(id: 3648)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'ts_key1_qty')"
                },
                {
                    ID: 3649,
                    Name: "汇总-清单数据-(特殊1-需替换key1)台账-金额(ts_key1_tp)(id: 3649)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'ts_key1_tp')"
                },
                {
                    ID: 3650,
                    Name: "汇总-清单数据-(特殊2-需替换key2)台账-数量(ts_key2_qty)(id: 3650)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'ts_key2_qty')"
                },
                {
                    ID: 3651,
                    Name: "汇总-清单数据-(特殊2-需替换key2)台账-金额(ts_key2_tp)(id: 3651)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'ts_key2_tp')"
                },
                {
                    ID: 3652,
                    Name: "汇总-清单数据-(特殊3-需替换key3)台账-数量(ts_key3_qty)(id: 3652)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'ts_key3_qty')"
                },
                {
                    ID: 3653,
                    Name: "汇总-清单数据-(特殊3-需替换key3)台账-金额(ts_key3_tp)(id: 3653)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'ts_key3_tp')"
                },
                {
                    ID: 3654,
                    Name: "汇总-清单数据-交叉排序(cross_index)(id: 3654)",
                    DataType: "int",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'cross_index')"
                },
                {
                    ID: 3655,
                    Name: "汇总-清单数据-树结构-id(id: 3655)",
                    DataType: "int",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'undefined')"
                },
                {
                    ID: 3656,
                    Name: "汇总-清单数据-树结构-父项id(id: 3656)",
                    DataType: "int",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'undefined')"
                },
                {
                    ID: 3657,
                    Name: "汇总-清单数据-树结构-层次(id: 3657)",
                    DataType: "int",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'undefined')"
                },
                {
                    ID: 3658,
                    Name: "汇总-清单数据-树结构-排序(id: 3658)",
                    DataType: "int",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'undefined')"
                },
                {
                    ID: 3659,
                    Name: "汇总-清单数据-树结构-完整路径(id: 3659)",
                    DataType: "string",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'undefined')"
                },
                {
                    ID: 3660,
                    Name: "汇总-清单数据-(特殊1-需替换key1)台账-设计数量1(ts_key1_dgn_qty1)(id: 3660)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'ts_key1_dgn_qty1')"
                },
                {
                    ID: 3661,
                    Name: "汇总-清单数据-(特殊1-需替换key1)台账-设计数量2(ts_key1_dgn_qty2)(id: 3661)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'ts_key1_dgn_qty2')"
                },
                {
                    ID: 3662,
                    Name: "汇总-清单数据-(特殊2-需替换key2)台账-设计数量1(ts_key2_dgn_qty1)(id: 3662)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'ts_key2_dgn_qty1')"
                },
                {
                    ID: 3663,
                    Name: "汇总-清单数据-(特殊2-需替换key2)台账-设计数量2(ts_key2_dgn_qty2)(id: 3663)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'ts_key2_dgn_qty2')"
                },
                {
                    ID: 3664,
                    Name: "汇总-清单数据-(特殊3-需替换key3)台账-设计数量1(ts_key3_dgn_qty1)(id: 3664)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'ts_key3_dgn_qty1')"
                },
                {
                    ID: 3665,
                    Name: "汇总-清单数据-(特殊3-需替换key3)台账-设计数量2(ts_key3_dgn_qty2)(id: 3665)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'ts_key3_dgn_qty2')"
                },
                {
                    ID: 3666,
                    Name: "汇总-清单数据-(标段)台账-设计数量1(t_dgn_qty1)(id: 3666)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_dgn_qty1')"
                },
                {
                    ID: 3667,
                    Name: "汇总-清单数据-(标段)台账-设计数量2(t_dgn_qty2)(id: 3667)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_dgn_qty2')"
                },
                {
                    ID: 3668,
                    Name: "汇总-清单数据-(标段)合同-设计数量1(t_deal_dgn_qty1)(id: 3668)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_deal_dgn_qty1')"
                },
                {
                    ID: 3669,
                    Name: "汇总-清单数据-(标段)合同-设计数量2(t_deal_dgn_qty2)(id: 3669)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_deal_dgn_qty2')"
                },
                {
                    ID: 3670,
                    Name: "汇总-清单数据-(标段)变更-设计数量1(t_c_dgn_qty1)(id: 3670)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_c_dgn_qty1')"
                },
                {
                    ID: 3671,
                    Name: "汇总-清单数据-(标段)变更-设计数量2(t_c_dgn_qty2)(id: 3671)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 't_c_dgn_qty2')"
                },
                {
                    ID: 3672,
                    Name: "汇总-清单数据-树结构-是否子项(is_leaf)(id: 3672)",
                    DataType: "int",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', 'is_leaf')"
                },
                {
                    ID: 3699,
                    Name: "汇总-清单数据-空白(id: 3699)",
                    DataType: "string",
                    TableName: "mem_gather_stage_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_bills', '')"
                }
            ]
        },
        {
            Name: "汇总-标段信息(mem_gather_tender_info)",
            remark: "",
            items: [
                {
                    ID: 3701,
                    Name: "汇总-标段信息-id(id)(id: 3701)",
                    DataType: "int",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'id')"
                },
                {
                    ID: 3702,
                    Name: "汇总-标段信息-名称(name)(id: 3702)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'name')"
                },
                {
                    ID: 3703,
                    Name: "汇总-标段信息-是否特殊标(spec)(id: 3703)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'spec')"
                },
                {
                    ID: 3704,
                    Name: "汇总-标段信息-台账-金额(tp)(id: 3704)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'tp')"
                },
                {
                    ID: 3705,
                    Name: "汇总-标段信息-签约-金额(deal_tp)(id: 3705)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'deal_tp')"
                },
                {
                    ID: 3706,
                    Name: "汇总-标段信息-本期-合同-金额(contract_tp)(id: 3706)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'contract_tp')"
                },
                {
                    ID: 3707,
                    Name: "汇总-标段信息-本期-变更-金额(qc_tp)(id: 3707)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'qc_tp')"
                },
                {
                    ID: 3708,
                    Name: "汇总-标段信息-本期-完成-金额(gather_tp)(id: 3708)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'gather_tp')"
                },
                {
                    ID: 3709,
                    Name: "汇总-标段信息-截止上期-合同-金额(pre_contract_tp)(id: 3709)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pre_contract_tp')"
                },
                {
                    ID: 3710,
                    Name: "汇总-标段信息-截止上期-变更-金额(pre_qc_tp)(id: 3710)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pre_qc_tp')"
                },
                {
                    ID: 3711,
                    Name: "汇总-标段信息-截止上期-完成-金额(pre_gather_tp)(id: 3711)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pre_gather_tp')"
                },
                {
                    ID: 3712,
                    Name: "汇总-标段信息-截止本期-合同-金额(end_contract_tp)(id: 3712)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'end_contract_tp')"
                },
                {
                    ID: 3713,
                    Name: "汇总-标段信息-截止本期-变更-金额(end_qc_tp)(id: 3713)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'end_qc_tp')"
                },
                {
                    ID: 3714,
                    Name: "汇总-标段信息-截止本期-完成-金额(end_gather_tp)(id: 3714)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'end_gather_tp')"
                },
                {
                    ID: 3715,
                    Name: "汇总-标段信息-截止上期-应付(pre_yf_tp)(id: 3715)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pre_yf_tp')"
                },
                {
                    ID: 3716,
                    Name: "汇总-标段信息-本期-应付(yf_tp)(id: 3716)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'yf_tp')"
                },
                {
                    ID: 3717,
                    Name: "汇总-标段信息-截止本期-应付(end_yf_tp)(id: 3717)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'end_yf_tp')"
                },
                {
                    ID: 3718,
                    Name: "汇总-标段信息-签约清单-金额(deal_bills_tp)(id: 3718)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'deal_bills_tp')"
                },
                {
                    ID: 3719,
                    Name: "汇总-标段信息-合同信息-建设项目名称(deal_info.buildName)(id: 3719)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'deal_info.buildName')"
                },
                {
                    ID: 3720,
                    Name: "汇总-标段信息-合同信息-合同编号(deal_info.dealCode)(id: 3720)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'deal_info.dealCode')"
                },
                {
                    ID: 3721,
                    Name: "汇总-标段信息-合同信息-合同名称(deal_info.dealName)(id: 3721)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'deal_info.dealName')"
                },
                {
                    ID: 3722,
                    Name: "汇总-标段信息-参建单位-建设单位-单位名称(construction_unit.build.company)(id: 3722)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.build.company')"
                },
                {
                    ID: 3723,
                    Name: "汇总-标段信息-参建单位-建设单位-法人代表(construction_unit.build.corporation)(id: 3723)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.build.corporation')"
                },
                {
                    ID: 3724,
                    Name: "汇总-标段信息-参建单位-建设单位-签订日期(construction_unit.build.date)(id: 3724)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.build.date')"
                },
                {
                    ID: 3725,
                    Name: "汇总-标段信息-参建单位-承包单位1-单位名称(construction_unit.contract1.company)(id: 3725)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.contract1.company')"
                },
                {
                    ID: 3726,
                    Name: "汇总-标段信息-参建单位-承包单位1-法人代表(construction_unit.contract1.corporation)(id: 3726)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.contract1.corporation')"
                },
                {
                    ID: 3727,
                    Name: "汇总-标段信息-参建单位-承包单位1-签订日期(construction_unit.contract1.date)(id: 3727)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.contract1.date')"
                },
                {
                    ID: 3728,
                    Name: "汇总-标段信息-参建单位-承包单位2-单位名称(construction_unit.contract2.company)(id: 3728)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.contract2.company')"
                },
                {
                    ID: 3729,
                    Name: "汇总-标段信息-参建单位-承包单位2-法人代表(construction_unit.contract2.corporation)(id: 3729)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.contract2.corporation')"
                },
                {
                    ID: 3730,
                    Name: "汇总-标段信息-参建单位-承包单位2-签订日期(construction_unit.contract2.date)(id: 3730)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.contract2.date')"
                },
                {
                    ID: 3731,
                    Name: "汇总-标段信息-参建单位-监理单位1-单位名称(construction_unit.supervision1.company)(id: 3731)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.supervision1.company')"
                },
                {
                    ID: 3732,
                    Name: "汇总-标段信息-参建单位-监理单位1-法人代表(construction_unit.supervision1.corporation)(id: 3732)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.supervision1.corporation')"
                },
                {
                    ID: 3733,
                    Name: "汇总-标段信息-参建单位-监理单位1-签订日期(construction_unit.supervision1.date)(id: 3733)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.supervision1.date')"
                },
                {
                    ID: 3734,
                    Name: "汇总-标段信息-参建单位-监理单位2-单位名称(construction_unit.supervision2.company)(id: 3734)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.supervision2.company')"
                },
                {
                    ID: 3735,
                    Name: "汇总-标段信息-参建单位-监理单位2-法人代表(construction_unit.supervision2.corporation)(id: 3735)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.supervision2.corporation')"
                },
                {
                    ID: 3736,
                    Name: "汇总-标段信息-参建单位-监理单位2-签订日期(construction_unit.supervision2.date)(id: 3736)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'construction_unit.supervision2.date')"
                },
                {
                    ID: 3737,
                    Name: "汇总-标段信息-技术参数-公路等级(tech_param.loadLevel)(id: 3737)",
                    DataType: "int",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'tech_param.loadLevel')"
                },
                {
                    ID: 3738,
                    Name: "汇总-标段信息-技术参数-长度(KM)(tech_param.loadLength)(id: 3738)",
                    DataType: "int",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'tech_param.loadLength')"
                },
                {
                    ID: 3739,
                    Name: "汇总-标段信息-技术参数-起始桩号(tech_param.startPeg)(id: 3739)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'tech_param.startPeg')"
                },
                {
                    ID: 3740,
                    Name: "汇总-标段信息-技术参数-终止桩号(tech_param.endPeg)(id: 3740)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'tech_param.endPeg')"
                },
                {
                    ID: 3741,
                    Name: "汇总-标段信息-技术参数-车道数(tech_param.laneCount)(id: 3741)",
                    DataType: "int",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'tech_param.laneCount')"
                },
                {
                    ID: 3742,
                    Name: "汇总-标段信息-技术参数-合同工期(tech_param.dealPeriod)(id: 3742)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'tech_param.dealPeriod')"
                },
                {
                    ID: 3743,
                    Name: "汇总-标段信息-技术参数-开工日期(tech_param.startDate)(id: 3743)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'tech_param.startDate')"
                },
                {
                    ID: 3744,
                    Name: "汇总-标段信息-技术参数-计划完工日期(tech_param.planEndDate)(id: 3744)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'tech_param.planEndDate')"
                },
                {
                    ID: 3745,
                    Name: "汇总-标段信息-合同参数-签约合同价(deal_param.contractPrice)(id: 3745)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'deal_param.contractPrice')"
                },
                {
                    ID: 3746,
                    Name: "汇总-标段信息-合同参数-暂列金额(deal_param.zanLiePrice)(id: 3746)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'deal_param.zanLiePrice')"
                },
                {
                    ID: 3747,
                    Name: "汇总-标段信息-合同参数-签约合同价(不含暂列金额)(deal_param.contractPriceWithoutZL)(id: 3747)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'deal_param.contractPriceWithoutZL')"
                },
                {
                    ID: 3748,
                    Name: "汇总-标段信息-合同参数-签约开工预付款(deal_param.startAdvance)(id: 3748)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'deal_param.startAdvance')"
                },
                {
                    ID: 3749,
                    Name: "汇总-标段信息-合同参数-签约材料预付款(deal_param.materialAdvance)(id: 3749)",
                    DataType: "currency",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'deal_param.materialAdvance')"
                },
                {
                    ID: 3750,
                    Name: "汇总-标段信息-付款账号-工程款账户-开户名称(pay_account.project.name)(id: 3750)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pay_account.project.name')"
                },
                {
                    ID: 3751,
                    Name: "汇总-标段信息-付款账号-工程款账户-开户银行(pay_account.project.bank)(id: 3751)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pay_account.project.bank')"
                },
                {
                    ID: 3752,
                    Name: "汇总-标段信息-付款账号-工程款账户-开户账号(pay_account.project.account)(id: 3752)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pay_account.project.account')"
                },
                {
                    ID: 3753,
                    Name: "汇总-标段信息-付款账号-工程款账户-分账划拨比例(%)(pay_account.project.rate)(id: 3753)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pay_account.project.rate')"
                },
                {
                    ID: 3754,
                    Name: "汇总-标段信息-付款账号-工程款账户-联系人(pay_account.project.contact)(id: 3754)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pay_account.project.contact')"
                },
                {
                    ID: 3755,
                    Name: "汇总-标段信息-付款账号-工程款账户-联系电话(pay_account.project.phone)(id: 3755)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pay_account.project.phone')"
                },
                {
                    ID: 3756,
                    Name: "汇总-标段信息-付款账号-农民工工资专用账户-开户名称(pay_account.worker.name)(id: 3756)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pay_account.worker.name')"
                },
                {
                    ID: 3757,
                    Name: "汇总-标段信息-付款账号-农民工工资专用账户-开户银行(pay_account.worker.bank)(id: 3757)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pay_account.worker.bank')"
                },
                {
                    ID: 3758,
                    Name: "汇总-标段信息-付款账号-农民工工资专用账户-开户账号(pay_account.worker.account)(id: 3758)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pay_account.worker.account')"
                },
                {
                    ID: 3759,
                    Name: "汇总-标段信息-付款账号-农民工工资专用账户-分账划拨比例(%)(pay_account.worker.rate)(id: 3759)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pay_account.worker.rate')"
                },
                {
                    ID: 3760,
                    Name: "汇总-标段信息-付款账号-农民工工资专用账户-联系人(pay_account.worker.contact)(id: 3760)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pay_account.worker.contact')"
                },
                {
                    ID: 3761,
                    Name: "汇总-标段信息-付款账号-农民工工资专用账户-联系电话(pay_account.worker.phone)(id: 3761)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', 'pay_account.worker.phone')"
                },
                {
                    ID: 3799,
                    Name: "汇总-标段信息-空白(id: 3799)",
                    DataType: "string",
                    TableName: "mem_gather_tender_info",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_tender_info', '')"
                }
            ]
        },
        {
            Name: "汇总-期-合同支付 数据表(mem_gather_stage_pay)",
            remark: "",
            items: [
                {
                    ID: 3801,
                    Name: "汇总-期-合同支付-名称(name)(id: 3801)",
                    DataType: "string",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 'name')"
                },
                {
                    ID: 3802,
                    Name: "汇总-期-合同支付-类型(ptype)(id: 3802)",
                    DataType: "int",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 'ptype')"
                },
                {
                    ID: 3803,
                    Name: "汇总-期-合同支付-是否扣款项(minus)(id: 3803)",
                    DataType: "int",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 'minus')"
                },
                {
                    ID: 3804,
                    Name: "汇总-期-合同支付-是否参与本期应付计算(is_yf)(id: 3804)",
                    DataType: "int",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 'is_yf')"
                },
                {
                    ID: 3805,
                    Name: "汇总-期-合同支付-标段id(t_id)(id: 3805)",
                    DataType: "int",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 't_id')"
                },
                {
                    ID: 3806,
                    Name: "汇总-期-合同支付-标段-名称(t_name)(id: 3806)",
                    DataType: "string",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 't_name')"
                },
                {
                    ID: 3807,
                    Name: "汇总-期-合同支付-(标段)本期-金额(t_tp)(id: 3807)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 't_tp')"
                },
                {
                    ID: 3808,
                    Name: "汇总-期-合同支付-(标段)截止上期-金额(t_pre_tp)(id: 3808)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 't_pre_tp')"
                },
                {
                    ID: 3809,
                    Name: "汇总-期-合同支付-(标段)截止本期-金额(t_end_tp)(id: 3809)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 't_end_tp')"
                },
                {
                    ID: 3810,
                    Name: "汇总-期-合同支付-(合计)本期-金额(s_tp)(id: 3810)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 's_tp')"
                },
                {
                    ID: 3811,
                    Name: "汇总-期-合同支付-(合计)截止上期-金额(s_pre_tp)(id: 3811)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 's_pre_tp')"
                },
                {
                    ID: 3812,
                    Name: "汇总-期-合同支付-(合计)截止本期-金额(s_end_tp)(id: 3812)",
                    DataType: "currency",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 's_end_tp')"
                },
                {
                    ID: 3813,
                    Name: "汇总-期-合同支付-交叉排序(cross_index)(id: 3813)",
                    DataType: "int",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', 'cross_index')"
                },
                {
                    ID: 3899,
                    Name: "汇总-期-合同支付-空白(id: 3899)",
                    DataType: "string",
                    TableName: "mem_gather_stage_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_stage_pay', '')"
                }
            ]
        },
        {
            Name: "汇总-签约清单 数据表(mem_gather_deal_bills)",
            remark: "",
            items: [
                {
                    ID: 3901,
                    Name: "汇总-签约清单-编号(code)(id: 3901)",
                    DataType: "string",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 'code')"
                },
                {
                    ID: 3902,
                    Name: "汇总-签约清单-名称(name)(id: 3902)",
                    DataType: "string",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 'name')"
                },
                {
                    ID: 3903,
                    Name: "汇总-签约清单-单位(unit)(id: 3903)",
                    DataType: "string",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 'unit')"
                },
                {
                    ID: 3904,
                    Name: "汇总-签约清单-单价(unit_price)(id: 3904)",
                    DataType: "currency",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 'unit_price')"
                },
                {
                    ID: 3905,
                    Name: "汇总-签约清单-标段id(t_id)(id: 3905)",
                    DataType: "int",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 't_id')"
                },
                {
                    ID: 3906,
                    Name: "汇总-签约清单-标段-名称(t_name)(id: 3906)",
                    DataType: "string",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 't_name')"
                },
                {
                    ID: 3907,
                    Name: "汇总-签约清单-(标段)金额(t_tp)(id: 3907)",
                    DataType: "currency",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 't_tp')"
                },
                {
                    ID: 3908,
                    Name: "汇总-签约清单-(合计)金额(s_tp)(id: 3908)",
                    DataType: "currency",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 's_tp')"
                },
                {
                    ID: 3909,
                    Name: "汇总-签约清单-(特殊1)金额(ts_key1_tp)(id: 3909)",
                    DataType: "currency",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 'ts_key1_tp')"
                },
                {
                    ID: 3910,
                    Name: "汇总-签约清单-(特殊2)金额(ts_key2_tp)(id: 3910)",
                    DataType: "currency",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 'ts_key2_tp')"
                },
                {
                    ID: 3911,
                    Name: "汇总-签约清单-(特殊3)金额(ts_key3_tp)(id: 3911)",
                    DataType: "currency",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 'ts_key3_tp')"
                },
                {
                    ID: 3912,
                    Name: "汇总-签约清单-(标段)数量(t_qty)(id: 3912)",
                    DataType: "currency",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 't_qty')"
                },
                {
                    ID: 3913,
                    Name: "汇总-签约清单-(合计)数量(s_qty)(id: 3913)",
                    DataType: "currency",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 's_qty')"
                },
                {
                    ID: 3914,
                    Name: "汇总-签约清单-(特殊1)数量(ts_key1_qty)(id: 3914)",
                    DataType: "currency",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 'ts_key1_qty')"
                },
                {
                    ID: 3915,
                    Name: "汇总-签约清单-(特殊2)数量(ts_key2_qty)(id: 3915)",
                    DataType: "currency",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 'ts_key2_qty')"
                },
                {
                    ID: 3916,
                    Name: "汇总-签约清单-(特殊3)数量(ts_key3_qty)(id: 3916)",
                    DataType: "currency",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 'ts_key3_qty')"
                },
                {
                    ID: 3917,
                    Name: "汇总-签约清单-交叉排序(cross_index)(id: 3917)",
                    DataType: "int",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', 'cross_index')"
                },
                {
                    ID: 3999,
                    Name: "汇总-签约清单-空白(id: 3999)",
                    DataType: "string",
                    TableName: "mem_gather_deal_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_gather_deal_bills', '')"
                }
            ]
        },
    ],
}, {
    Name: '单标段多期汇总表',
    remark: '使用用户交互进行汇总数据',
    seq: 3,
    items: [
        {
            Name: "期汇总-清单-交叉数据表(mem_stage_sum_bills)",
            remark: "",
            items: [
                {
                    ID: 4201,
                    Name: "期汇总-清单-交叉数据-台账ID(id)(id: 4201)",
                    DataType: "int",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'id')"
                },
                {
                    ID: 4202,
                    Name: "期汇总-清单-交叉数据-标段ID(tender_id)(id: 4202)",
                    DataType: "int",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'tender_id')"
                },
                {
                    ID: 4203,
                    Name: "期汇总-清单-交叉数据-树结构-ID(ledger_id)(id: 4203)",
                    DataType: "int",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'ledger_id')"
                },
                {
                    ID: 4204,
                    Name: "期汇总-清单-交叉数据-树结构-父项ID(ledger_pid)(id: 4204)",
                    DataType: "int",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'ledger_pid')"
                },
                {
                    ID: 4205,
                    Name: "期汇总-清单-交叉数据-树结构-层级(level)(id: 4205)",
                    DataType: "int",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'level')"
                },
                {
                    ID: 4206,
                    Name: "期汇总-清单-交叉数据-树结构-同层排序(order)(id: 4206)",
                    DataType: "int",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'order')"
                },
                {
                    ID: 4207,
                    Name: "期汇总-清单-交叉数据-树结构-完整路径(full_path)(id: 4207)",
                    DataType: "string",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'full_path')"
                },
                {
                    ID: 4208,
                    Name: "期汇总-清单-交叉数据-树结构-是否子项(is_leaf)(id: 4208)",
                    DataType: "int",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'is_leaf')"
                },
                {
                    ID: 4209,
                    Name: "期汇总-清单-交叉数据-项目节编号(code)(id: 4209)",
                    DataType: "string",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'code')"
                },
                {
                    ID: 4210,
                    Name: "期汇总-清单-交叉数据-清单编号(b_code)(id: 4210)",
                    DataType: "string",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'b_code')"
                },
                {
                    ID: 4211,
                    Name: "期汇总-清单-交叉数据-名称(name)(id: 4211)",
                    DataType: "string",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'name')"
                },
                {
                    ID: 4212,
                    Name: "期汇总-清单-交叉数据-单位(unit)(id: 4212)",
                    DataType: "string",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'unit')"
                },
                {
                    ID: 4213,
                    Name: "期汇总-清单-交叉数据-单价(unit_price)(id: 4213)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'unit_price')"
                },
                {
                    ID: 4214,
                    Name: "期汇总-清单-交叉数据-签约-数量(deal_qty)(id: 4214)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'deal_qty')"
                },
                {
                    ID: 4215,
                    Name: "期汇总-清单-交叉数据-签约-金额(deal_tp)(id: 4215)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'deal_tp')"
                },
                {
                    ID: 4216,
                    Name: "期汇总-清单-交叉数据-施工复核-数量(sgfh_qty)(id: 4216)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'sgfh_qty')"
                },
                {
                    ID: 4217,
                    Name: "期汇总-清单-交叉数据-施工复核-金额(sgfh_tp)(id: 4217)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'sgfh_tp')"
                },
                {
                    ID: 4218,
                    Name: "期汇总-清单-交叉数据-设计错漏-数量(sjcl_qty)(id: 4218)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'sjcl_qty')"
                },
                {
                    ID: 4219,
                    Name: "期汇总-清单-交叉数据-设计错漏-金额(sjcl_tp)(id: 4219)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'sjcl_tp')"
                },
                {
                    ID: 4220,
                    Name: "期汇总-清单-交叉数据-其他错漏-数量(qtcl_qty)(id: 4220)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'qtcl_qty')"
                },
                {
                    ID: 4221,
                    Name: "期汇总-清单-交叉数据-其他错漏-金额(qtcl_tp)(id: 4221)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'qtcl_tp')"
                },
                {
                    ID: 4222,
                    Name: "期汇总-清单-交叉数据-台账-数量(quantity)(id: 4222)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'quantity')"
                },
                {
                    ID: 4223,
                    Name: "期汇总-清单-交叉数据-台账-金额(total_price)(id: 4223)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'total_price')"
                },
                {
                    ID: 4224,
                    Name: "期汇总-清单-交叉数据-项目节-数量1(dgn_qty1)(id: 4224)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'dgn_qty1')"
                },
                {
                    ID: 4225,
                    Name: "期汇总-清单-交叉数据-项目节-数量2(dgn_qty2)(id: 4225)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'dgn_qty2')"
                },
                {
                    ID: 4226,
                    Name: "期汇总-清单-交叉数据-图册号(drawing_code)(id: 4226)",
                    DataType: "string",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'drawing_code')"
                },
                {
                    ID: 4227,
                    Name: "期汇总-清单-交叉数据-备注(memo)(id: 4227)",
                    DataType: "string",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'memo')"
                },
                {
                    ID: 4228,
                    Name: "期汇总-清单-交叉数据-节点类型(node_type)(id: 4228)",
                    DataType: "int",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'node_type')"
                },
                {
                    ID: 4229,
                    Name: "期汇总-清单-交叉数据-总额计量(is_tp)(id: 4229)",
                    DataType: "int",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'is_tp')"
                },
                {
                    ID: 4230,
                    Name: "期汇总-清单-交叉数据-(期)-第几期(s_order)(id: 4230)",
                    DataType: "int",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 's_order')"
                },
                {
                    ID: 4231,
                    Name: "期汇总-清单-交叉数据-(期)-合同-数量(s_contract_qty)(id: 4231)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 's_contract_qty')"
                },
                {
                    ID: 4232,
                    Name: "期汇总-清单-交叉数据-(期)-合同-金额(s_contract_tp)(id: 4232)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 's_contract_tp')"
                },
                {
                    ID: 4233,
                    Name: "期汇总-清单-交叉数据-(期)-变更-数量(s_qc_qty)(id: 4233)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 's_qc_qty')"
                },
                {
                    ID: 4234,
                    Name: "期汇总-清单-交叉数据-(期)-变更-金额(s_qc_tp)(id: 4234)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 's_qc_tp')"
                },
                {
                    ID: 4235,
                    Name: "期汇总-清单-交叉数据-(期)-完成-数量(s_gather_qty)(id: 4235)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 's_gather_qty')"
                },
                {
                    ID: 4236,
                    Name: "期汇总-清单-交叉数据-(期)-完成-金额(s_gather_tp)(id: 4236)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 's_gather_tp')"
                },
                {
                    ID: 4237,
                    Name: "期汇总-清单-交叉数据-交叉排序(cross_index)(id: 4237)",
                    DataType: "int",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', 'cross_index')"
                },
                {
                    ID: 4299,
                    Name: "期汇总-清单-交叉数据-空白(id: 4299)",
                    DataType: "string",
                    TableName: "mem_stage_sum_bills",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_bills', '')"
                }
            ]
        },
        {
            Name: "期汇总-合同支付 数据表(mem_stage_sum_pay)",
            remark: "",
            items: [
                {
                    ID: 4301,
                    Name: "期汇总-合同支付-名称(name)(id: 4301)",
                    DataType: "string",
                    TableName: "mem_stage_sum_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_pay', 'name')"
                },
                {
                    ID: 4302,
                    Name: "期汇总-合同支付-类型(ptype)(id: 4302)",
                    DataType: "int",
                    TableName: "mem_stage_sum_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_pay', 'ptype')"
                },
                {
                    ID: 4303,
                    Name: "期汇总-合同支付-是否扣款项(minus)(id: 4303)",
                    DataType: "int",
                    TableName: "mem_stage_sum_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_pay', 'minus')"
                },
                {
                    ID: 4304,
                    Name: "期汇总-合同支付-是否参与本期应付计算(is_yf)(id: 4304)",
                    DataType: "int",
                    TableName: "mem_stage_sum_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_pay', 'is_yf')"
                },
                {
                    ID: 4305,
                    Name: "期汇总-合同支付-(期)第几期(s_order)(id: 4305)",
                    DataType: "int",
                    TableName: "mem_stage_sum_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_pay', 's_order')"
                },
                {
                    ID: 4306,
                    Name: "期汇总-合同支付-(期)本期-金额(t_tp)(id: 4306)",
                    DataType: "currency",
                    TableName: "mem_stage_sum_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_pay', 't_tp')"
                },
                {
                    ID: 4307,
                    Name: "期汇总-合同支付-交叉排序(cross_index)(id: 4307)",
                    DataType: "int",
                    TableName: "mem_stage_sum_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_pay', 'cross_index')"
                },
                {
                    ID: 4399,
                    Name: "期汇总-合同支付-空白(id: 4399)",
                    DataType: "string",
                    TableName: "mem_stage_sum_pay",
                    descr: "",
                    mapExpression: "$PROJECT.REPORT.getProperty('mem_stage_sum_pay', '')"
                }
            ]
        },
    ],
}];
